// Code generated by running "go generate" in golang.org/x/text. DO NOT EDIT.

package main

import (
	"golang.org/x/text/language"
	"golang.org/x/text/message"
	"golang.org/x/text/message/catalog"
)

type dictionary struct {
	index []uint32
	data  string
}

func (d *dictionary) Lookup(key string) (data string, ok bool) {
	p, ok := messageKeyToIndex[key]
	if !ok {
		return "", false
	}
	start, end := d.index[p], d.index[p+1]
	if start == end {
		return "", false
	}
	return d.data[start:end], true
}

func init() {
	dict := map[string]catalog.Dictionary{
		"de":    &dictionary{index: deIndex, data: deData},
		"en":    &dictionary{index: enIndex, data: enData},
		"es_ES": &dictionary{index: es_ESIndex, data: es_ESData},
		"fa":    &dictionary{index: faIndex, data: faData},
		"fi":    &dictionary{index: fiIndex, data: fiData},
		"fr":    &dictionary{index: frIndex, data: frData},
		"id":    &dictionary{index: idIndex, data: idData},
		"it":    &dictionary{index: itIndex, data: itData},
		"ja":    &dictionary{index: jaIndex, data: jaData},
		"pa_IN": &dictionary{index: pa_INIndex, data: pa_INData},
		"pl":    &dictionary{index: plIndex, data: plData},
		"ro":    &dictionary{index: roIndex, data: roData},
		"ru":    &dictionary{index: ruIndex, data: ruData},
		"sk":    &dictionary{index: skIndex, data: skData},
		"sl":    &dictionary{index: slIndex, data: slData},
		"uk":    &dictionary{index: ukIndex, data: ukData},
		"vi":    &dictionary{index: viIndex, data: viData},
		"zh_CN": &dictionary{index: zh_CNIndex, data: zh_CNData},
		"zh_TW": &dictionary{index: zh_TWIndex, data: zh_TWData},
	}
	fallback := language.MustParse("en")
	cat, err := catalog.NewFromMap(dict, catalog.Fallback(fallback))
	if err != nil {
		panic(err)
	}
	message.DefaultCatalog = cat
}

var messageKeyToIndex = map[string]int{
	"%.2f\u00a0GiB":                         21,
	"%.2f\u00a0KiB":                         19,
	"%.2f\u00a0MiB":                         20,
	"%.2f\u00a0TiB":                         22,
	"%d day(s)":                             13,
	"%d hour(s)":                            14,
	"%d minute(s)":                          15,
	"%d second(s)":                          16,
	"%d tunnels were unable to be removed.": 161,
	"%d year(s)":                            12,
	"%d\u00a0B":                             18,
	"%s\n\nPlease consult the log for more information.": 113,
	"%s (out of date)":                        114,
	"%s (unsigned build, no updates)":         166,
	"%s You cannot undo this action.":         157,
	"%s ago":                                  17,
	"%s received, %s sent":                    73,
	"%s: %q":                                  23,
	"&About WireGuard…":                       111,
	"&Activate":                               58,
	"&Block untunneled traffic (kill-switch)": 84,
	"&Configuration:":                         88,
	"&Copy":                                   104,
	"&Deactivate":                             57,
	"&Edit":                                   135,
	"&Import tunnel(s) from file…":            121,
	"&Manage tunnels…":                        120,
	"&Name:":                                  81,
	"&Public key:":                            82,
	"&Remove selected tunnel(s)":              143,
	"&Save":                                   86,
	"&Save to file…":                          106,
	"&Toggle":                                 140,
	"&Tunnels":                                179,
	"(no argument): elevate and install manager service": 1,
	"(unknown)":                             83,
	"A name is required.":                   90,
	"A tunnel was unable to be removed: %s": 159,
	"About WireGuard":                       51,
	"Activating":                            99,
	"Active":                                98,
	"Add &empty tunnel…":                    136,
	"Add Tunnel":                            137,
	"Addresses:":                            62,
	"Addresses: %s":                         130,
	"Addresses: None":                       119,
	"All peers must have public keys":       44,
	"Allowed IPs:":                          66,
	"An Update is Available!":               131,
	"An interface must have a private key":  42,
	"An update to WireGuard is available. It is highly advisable to update without delay.":               169,
	"An update to WireGuard is now available. You are advised to update as soon as possible.":            133,
	"Another tunnel already exists with the name ‘%s’":                                                   147,
	"Another tunnel already exists with the name ‘%s’.":                                                  94,
	"App version: %s\nGo backend version: %s\nGo version: %s-%s\nOperating system: %s\nArchitecture: %s": 53,
	"Are you sure you would like to delete %d tunnels?":                                                  154,
	"Are you sure you would like to delete tunnel ‘%s’?":                                                 156,
	"Brackets must contain an IPv6 address":                                                              28,
	"Cancel":                                                                                             87,
	"Close":                                                                                              54,
	"Command Line Options":                                                                               3,
	"Config key is missing an equals separator":                                                          38,
	"Configuration Files (*.zip, *.conf)|*.zip;*.conf|All Files (*.*)|*.*":                               162,
	"Configuration ZIP Files (*.zip)|*.zip":                                                              164,
	"Could not enumerate existing tunnels: %v":                                                           146,
	"Could not import selected configuration: %v":                                                        145,
	"Create new tunnel":                                                                                  79,
	"DNS servers:":                                                                                       63,
	"Deactivating":                                                                                       101,
	"Delete %d tunnels":                                                                                  153,
	"Delete tunnel ‘%s’":                                                                                 155,
	"E&xit":                                                                                              122,
	"Edit &selected tunnel…":                                                                             142,
	"Edit tunnel":                                                                                        80,
	"Endpoint:":                                                                                          67,
	"Error":                                                                                              0,
	"Error Exiting WireGuard":                                                                            167,
	"Error in getting configuration":                                                                     45,
	"Error: %v. Please try again.":                                                                       173,
	"Export all tunnels to &zip…":                                                                        141,
	"Export all tunnels to zip":                                                                          139,
	"Export log to file":                                                                                 110,
	"Export tunnels to zip":                                                                              165,
	"Failed to activate tunnel":                                                                          75,
	"Failed to deactivate tunnel":                                                                        76,
	"Failed to determine tunnel state":                                                                   74,
	"File ‘%s’ already exists.\n\nDo you want to overwrite it?":                                          97,
	"Import tunnel(s) from file":                                                                         163,
	"Imported %d of %d tunnels":                                                                          151,
	"Imported %d tunnels":                                                                                150,
	"Imported tunnels":                                                                                   149,
	"Inactive":                                                                                           100,
	"Interface: %s":                                                                                      77,
	"Invalid IP address":                                                                                 24,
	"Invalid MTU":                                                                                        29,
	"Invalid endpoint host":                                                                              27,
	"Invalid key for [Interface] section":                                                                40,
	"Invalid key for [Peer] section":                                                                     41,
	"Invalid key for interface section":                                                                  46,
	"Invalid key for peer section":                                                                       48,
	"Invalid key: %v":                                                                                    32,
	"Invalid name":                                                                                       89,
	"Invalid network prefix length":                                                                      25,
	"Invalid persistent keepalive":                                                                       31,
	"Invalid port":                                                                                       30,
	"Key must have a value":                                                                              39,
	"Keys must decode to exactly 32 bytes":                                                               33,
	"Latest handshake:":                                                                                  69,
	"Line must occur in a section":                                                                       37,
	"Listen port:":                                                                                       60,
	"Log":                                                                                                103,
	"Log message":                                                                                        108,
	"MTU:":                                                                                               61,
	"Missing port from endpoint":                                                                         26,
	"Now":                                                                                                10,
	"Number must be a number between 0 and 2^64-1: %v":                                                   34,
	"Peer":                                78,
	"Persistent keepalive:":               68,
	"Preshared key:":                      65,
	"Protocol version must be 1":          47,
	"Public key:":                         59,
	"Remove selected tunnel(s)":           138,
	"Scripts:":                            64,
	"Select &all":                         105,
	"Status:":                             56,
	"Status: %s":                          129,
	"Status: Complete!":                   174,
	"Status: Unknown":                     118,
	"Status: Waiting for updater service": 172,
	"Status: Waiting for user":            170,
	"System clock wound backward!":        11,
	"Text Files (*.txt)|*.txt|All Files (*.*)|*.*": 109,
	"The %s tunnel has been activated.":            124,
	"The %s tunnel has been deactivated.":          126,
	"Time":                                         107,
	"Transfer:":                                    70,
	"Tunnel Error":                                 112,
	"Tunnel already exists":                        93,
	"Tunnel name is not valid":                     36,
	"Tunnel name ‘%s’ is invalid.":                 91,
	"Tunnels":                                      134,
	"Two commas in a row":                          35,
	"Unable to create new configuration":           95,
	"Unable to create tunnel":                      152,
	"Unable to delete tunnel":                      158,
	"Unable to delete tunnels":                     160,
	"Unable to determine whether the process is running under WOW64: %v":                          4,
	"Unable to exit service due to: %v. You may want to stop WireGuard from the service manager.": 168,
	"Unable to import configuration: %v":                                                          148,
	"Unable to list existing tunnels":                                                             92,
	"Unable to open current process token: %v":                                                    6,
	"Unable to wait for WireGuard window to appear: %v":                                           116,
	"Unknown state":    102,
	"Update Now":       171,
	"Usage: %s [\n%s]": 2,
	"When a configuration has exactly one peer, and that peer has an allowed IPs containing at least one of 0.0.0.0/0 or ::/0, then the tunnel service engages a firewall ruleset to block all traffic that is neither to nor from the tunnel interface or is to the wrong DNS server, with special exceptions for DHCP and NDP.": 85,
	"WireGuard Activated":        123,
	"WireGuard Deactivated":      125,
	"WireGuard Detection Error":  115,
	"WireGuard Tunnel Error":     127,
	"WireGuard Update Available": 132,
	"WireGuard is running, but the UI is only accessible from desktops of the Builtin %s group.": 8,
	"WireGuard logo image": 52,
	"WireGuard may only be used by users who are a member of the Builtin %s group.": 7,
	"WireGuard system tray icon did not appear after 30 seconds.":                   9,
	"WireGuard: %s":          128,
	"WireGuard: Deactivated": 117,
	"Writing file failed":    96,
	"You must use the native version of WireGuard on this computer.": 5,
	"[EnumerationSeparator]":            49,
	"[UnitSeparator]":                   50,
	"[none specified]":                  43,
	"disabled, per policy":              71,
	"enabled":                           72,
	"no configuration files were found": 144,
	"post-down":                         178,
	"post-up":                           176,
	"pre-down":                          177,
	"pre-up":                            175,
	"♥ &Donate!":                        55,
}

var deIndex = []uint32{ // 181 elements
	// Entry 0 - 1F
	0x00000000, 0x00000007, 0x00000059, 0x00000074,
	0x0000008b, 0x000000e1, 0x00000137, 0x0000016b,
	0x000001c2, 0x0000023a, 0x0000028a, 0x00000290,
	0x000002b6, 0x000002d6, 0x000002f4, 0x00000318,
	0x0000033c, 0x00000362, 0x0000036c, 0x00000375,
	0x00000382, 0x0000038f, 0x0000039c, 0x000003a9,
	0x000003b6, 0x000003cc, 0x000003f4, 0x00000412,
	0x0000042c, 0x00000460, 0x0000046f, 0x00000480,
	// Entry 20 - 3F
	0x000004a0, 0x000004be, 0x000004f5, 0x00000521,
	0x0000053d, 0x0000055a, 0x0000058b, 0x000005c6,
	0x000005e4, 0x00000612, 0x0000063a, 0x00000674,
	0x00000689, 0x000006c7, 0x000006ed, 0x0000071a,
	0x0000073b, 0x00000763, 0x00000766, 0x00000769,
	0x00000779, 0x00000788, 0x000007f6, 0x00000801,
	0x0000080f, 0x00000817, 0x00000825, 0x00000831,
	0x0000084b, 0x00000859, 0x0000085e, 0x00000868,
	// Entry 40 - 5F
	0x00000874, 0x0000087d, 0x00000893, 0x000008a1,
	0x000008ab, 0x000008c0, 0x000008da, 0x000008e7,
	0x00000903, 0x0000090d, 0x0000092d, 0x00000958,
	0x0000097d, 0x000009a4, 0x000009b9, 0x000009c4,
	0x000009e1, 0x000009f3, 0x000009fa, 0x00000a15,
	0x00000a21, 0x00000a55, 0x00000bbd, 0x00000bc8,
	0x00000bd2, 0x00000be2, 0x00000bf3, 0x00000c0b,
	0x00000c2f, 0x00000c62, 0x00000c7b, 0x00000cb3,
	// Entry 60 - 7F
	0x00000ce1, 0x00000d01, 0x00000d46, 0x00000d4c,
	0x00000d56, 0x00000d5e, 0x00000d6a, 0x00000d7e,
	0x00000d88, 0x00000d92, 0x00000da3, 0x00000dba,
	0x00000dbf, 0x00000dd0, 0x00000e01, 0x00000e1f,
	0x00000e33, 0x00000e41, 0x00000e82, 0x00000e93,
	0x00000eae, 0x00000ef6, 0x00000f0d, 0x00000f1f,
	0x00000f2f, 0x00000f44, 0x00000f65, 0x00000f6e,
	0x00000f82, 0x00000fa4, 0x00000fba, 0x00000fde,
	// Entry 80 - 9F
	0x00000ff6, 0x00001007, 0x00001015, 0x00001025,
	0x00001049, 0x0000106d, 0x000010e0, 0x000010e7,
	0x000010f3, 0x00001117, 0x0000112a, 0x00001148,
	0x00001172, 0x0000117e, 0x000011a3, 0x000011c7,
	0x000011e8, 0x0000120d, 0x0000124e, 0x00001280,
	0x000012ba, 0x000012ee, 0x00001300, 0x00001339,
	0x00001385, 0x000013a5, 0x000013da, 0x0000144a,
	0x00001466, 0x0000149d, 0x000014da, 0x000014f9,
	// Entry A0 - BF
	0x00001529, 0x0000154f, 0x000015b0, 0x000015fa,
	0x00001616, 0x0000163f, 0x0000165e, 0x00001689,
	0x000016ab, 0x00001717, 0x00001785, 0x0000179f,
	0x000017b3, 0x000017dc, 0x0000180a, 0x0000181a,
	0x0000181a, 0x0000181a, 0x0000181a, 0x0000181a,
	0x0000181a,
} // Size: 748 bytes

const deData string = "" + // Size: 6170 bytes
	"\x02Fehler\x02(kein Argument): Als Administrator ausführen und den Manag" +
	"er-Dienst installieren\x02Verwendung: %[1]s [\x0a%[2]s]\x02Kommandozeile" +
	"noptionen\x02Es kann nicht festgestellt werden, ob der Prozess unter WOW" +
	"64 ausgeführt wird: %[1]v\x02Sie müssen die Version von Wireguard benutz" +
	"en, die für ihren Computer bestimmt ist.\x02Konnte aktuellen Prozess-Tok" +
	"en nicht öffnen: %[1]v\x02WireGuard kann nur von Benutzern verwendet wer" +
	"den, die Mitglied der Gruppe %[1]s sind.\x02WireGuard wird ausgeführt, a" +
	"ber auf die Benutzeroberfläche kann nur von Desktops der Gruppe %[1]s zu" +
	"gegriffen werden.\x02Das WireGuard-Taskleistensymbol ist nicht innerhalb" +
	" von 30 Sekunden erschienen.\x02Jetzt\x02Die Systemuhr wurde zurück gest" +
	"ellt!\x14\x01\x81\x01\x00\x02\x0b\x02%[1]d Jahr\x00\x0c\x02%[1]d Jahre" +
	"\x14\x01\x81\x01\x00\x02\x0a\x02%[1]d Tag\x00\x0b\x02%[1]d Tage\x14\x01" +
	"\x81\x01\x00\x02\x0d\x02%[1]d Stunde\x00\x0e\x02%[1]d Stunden\x14\x01" +
	"\x81\x01\x00\x02\x0d\x02%[1]d Minute\x00\x0e\x02%[1]d Minuten\x14\x01" +
	"\x81\x01\x00\x02\x0e\x02%[1]d Sekunde\x00\x0f\x02%[1]d Sekunden\x02vor %" +
	"[1]s\x02%[1]d\u00a0B\x02%.2[1]f\u00a0KiB\x02%.2[1]f\u00a0MiB\x02%.2[1]f" +
	"\u00a0GiB\x02%.2[1]f\u00a0TiB\x02%[1]s: %[2]q\x02Ungültige IP-Adresse" +
	"\x02Ungültige Länge des Netzwerkpräfixes\x02Fehlender Port des Endpunkte" +
	"s\x02Ungültiger Endpunkt-Host\x02Eckige Klammern müssen eine IPv6 Adress" +
	"e enthalten\x02Ungültige MTU\x02Ungültiger Port\x02Ungültiges Erhaltungs" +
	"intervall\x02Ungültiger Schlüssel: %[1]v\x02Schlüssel müssen auf exakt 3" +
	"2 Bytes dekodiert werden\x02Zahl muss zwischen 0 und 2^64-1 sein: %[1]v" +
	"\x02Zwei Kommata in einer Zeile\x02Der Tunnelname ist ungültig\x02Die Ze" +
	"ile muss innerhalb eines Abschnitts stehen\x02Konfigurationsschlüssel fe" +
	"hlt ein Gleichheitstrennzeichen\x02Eintrag muss einen Wert haben\x02Ungü" +
	"ltiger Eintrage im [Interface] Abschnitt\x02Ungültiger Eintrag im [Peer]" +
	" Abschnitt\x02Eine Schnittstelle muss einen privaten Schlssel enthalten" +
	"\x02[nicht spezifiziert]\x02Alle Teilnehmer (peers) müssen öffentliche S" +
	"chlüssel haben\x02Fehler beim Abrufen der Konfiguration\x02Ungültiger Ei" +
	"ntrag im Abschnitt [interface]\x02Die Protokollversion muss 1 sein\x02Un" +
	"gültiger Eintrag im Abschnitt [peer]\x02, \x02, \x02Über WireGuard\x02Wi" +
	"reGuard Logo\x02App Version: %[1]s\x0aGo backend Version: %[2]s\x0aGo Ve" +
	"rsion: %[3]s-%[4]s\x0aBetriebssystem: %[5]s\x0aArchitektur: %[6]s\x02Sch" +
	"ließen\x02♥ &Spenden!\x02Status:\x02&Deaktivieren\x02&Aktivieren\x02Öffe" +
	"ntlicher Schlüssel:\x02Eingangsport:\x02MTU:\x02Adressen:\x02DNS-Server:" +
	"\x02Skripte:\x02Geteilter Schlüssel:\x02Erlaubte IPs:\x02Endpunkt:\x02Er" +
	"haltungsintervall:\x02Letzter Schlüsseltausch:\x02Übertragen:\x02deaktiv" +
	"iert, per Richtlinie\x02aktiviert\x02%[1]s empfangen, %[2]s gesendet\x02" +
	"Tunnelstatus konnte nicht ermittelt werden\x02Tunnel aktivieren ist fehl" +
	"geschlagen\x02Tunnel deaktivieren ist fehlgeschlagen\x02Schnittstelle: %" +
	"[1]s\x02Teilnehmer\x02Einen neuen Tunnel erstellen\x02Tunnel bearbeiten" +
	"\x02&Name:\x02&Öffentlicher Schlüssel:\x02(unbekannt)\x02&Blockiere Verk" +
	"ehr außerhalb des Tunnels (Not-Aus)\x02Wenn eine Konfiguration genau ein" +
	"en Teilnehmer enthält und dieser einen der Einträge 0.0.0.0/0 oder ::/0 " +
	"in den erlaubten IPs enthält, dann erstellt der Tunneldienst ein Firewal" +
	"l-Regelsatz, der allen Verkehr (insbesondere zum falschen DNS-Server) bl" +
	"ockiert, der weder aus dem Tunnel stammt noch in den Tunnel geht, mit Au" +
	"snahmen für DHCP- und NDP-Verkehr.\x02&Speichern\x02Abbrechen\x02&Konfig" +
	"uration:\x02Ungültiger Name\x02Ein Name ist notwendig.\x02Der Name „%[1]" +
	"s“ ist ungültig.\x02Vorhandene Tunnel können nicht aufgelistet werden" +
	"\x02Tunnel existiert bereits\x02Ein Tunnel mit dem Namen „%[1]s“ existie" +
	"rt bereits.\x02Neue Konfiguration kann nicht erstellt werden\x02Schreibe" +
	"n der Datei schlug fehl\x02Die Datei „%[1]s“ existiert bereits.\x0a\x0aM" +
	"öchten Sie sie ersetzen?\x02Aktiv\x02Aktiviere\x02Inaktiv\x02Deaktivier" +
	"e\x02Unbekannter Zustand\x02Protokoll\x02&Kopieren\x02&Alles markieren" +
	"\x02&In Datei Speichern…\x02Zeit\x02Protokolleintrag\x02Textdateien (*.t" +
	"xt)|*.txt|Alle Dateien (*.*)|*.*\x02Exportiere Protokoll in Datei\x02&Üb" +
	"er WireGuard…\x02Tunnel Fehler\x02%[1]s\x0a\x0aBitte lesen Sie das Proto" +
	"koll für weitere Informationen.\x02%[1]s (veraltet)\x02WireGuard Erkennu" +
	"ngsfehler\x02Warten auf das Erscheinen des WireGuard Fensters nicht mögl" +
	"ich: %[1]v \x02WireGuard: Deaktiviert\x02Status: Unbekannt\x02Adressen: " +
	"Keine\x02Tunnel &verwalten…\x02Tunnel aus Datei &importieren…\x02&Beende" +
	"n\x02WireGuard aktiviert\x02Der Tunnel %[1]s wurde aktiviert.\x02WireGua" +
	"rd deaktiviert\x02Der Tunnel %[1]s wurde deaktiviert.\x02WireGuard Tunne" +
	"l Fehler\x02WireGuard: %[1]s\x02Status: %[1]s\x02Adressen: %[1]s\x02Eine" +
	" Aktualisierung ist verfügbar!\x02WireGuard Aktualisierung verfügbar\x02" +
	"Eine Aktualisierung für WireGuard ist jetzt verfügbar. Es wird empfohlen" +
	" diese schnellstmöglich durchzuführen.\x02Tunnel\x02&Bearbeiten\x02Einen" +
	" &leeren Tunnel hinzufügen…\x02Tunnel hinzufügen\x02Markierte(n) Tunnel " +
	"entfernen\x02Alle Tunnel in eine Zip-Datei exportieren\x02&Umschalten" +
	"\x02Exportiere alle Tunnel in &Zip-Datei\x02Ausgewählten Tunnel &bearbei" +
	"ten…\x02Ausgewählte(n) Tunnel &löschen\x02keine Konfigurationsdateien ge" +
	"funden\x02Ausgewählte Konfiguration konnte nicht importiert werden: %[1]" +
	"v\x02Konnte existierende Tunnel nicht auflisten: %[1]v\x02Es existiert b" +
	"ereits ein Tunnel mit dem Namen „%[1]s“\x02Importieren der Konfiguration" +
	" nicht möglich: %[1]v\x02Tunnel importiert\x14\x01\x81\x01\x00\x02\x18" +
	"\x02%[1]d Tunnel importiert\x00\x18\x02%[1]d Tunnel importiert\x14\x02" +
	"\x80\x01\x02\x22\x02%[1]d von %[2]d Tunnel importiert\x00\x22\x02%[1]d v" +
	"on %[2]d Tunnel importiert\x02Tunnel erstellen nicht möglich\x14\x01\x81" +
	"\x01\x00\x02\x16\x02%[1]d Tunnel löschen\x00\x16\x02%[1]d Tunnel löschen" +
	"\x14\x01\x81\x01\x00\x024\x02Möchten Sie diesen %[1]d Tunnel wirklich lö" +
	"schen?\x003\x02Möchten Sie diese %[1]d Tunnel wirklich löschen?\x02Tunne" +
	"l „%[1]s“ löschen\x02Möchten Sie den Tunnel „%[1]s“ wirklich löschen?" +
	"\x02%[1]s Dieser Schritt kann nicht rückgängig gemacht werden.\x02Tunnel" +
	" löschen nicht möglich\x02Ein Tunnel konnte nicht gelöscht werden: %[1]s" +
	"\x02Tunnel konnten nicht gelöscht werden\x14\x01\x81\x01\x00\x02+\x02%[1" +
	"]d Tunnel konnte nicht entfernt werden.\x00-\x02%[1]d Tunnel konnten nic" +
	"ht gelöscht werden.\x02Konfigurationsdateien (*.zip, *.conf)|*.zip;*.con" +
	"f|Alle Dateien (*.*)|*.*\x02Importiere Tunnel aus Datei\x02Konfiguration" +
	"s-ZIP-Dateien (*.zip)|*.zip\x02Exportiere Tunnel in Zip-Datei\x02%[1]s (" +
	"unsigniert, keine Aktualisierungen)\x02Fehler beim Beenden von WireGuard" +
	"\x02Der Dienst konnte nicht gestoppt werden: %[1]v. Versuchen Sie WireGu" +
	"ard in der Dienstverwaltung zu beenden.\x02Eine Aktualisierung für WireG" +
	"uard ist verfügbar. Es ist höchst empfehlenswert diese sofort durchzufüh" +
	"ren.\x02Status: Auf Nutzer warten\x02Jetzt aktualisieren\x02Status: Auf " +
	"Aktualisierungsdienst warten\x02Fehler: %[1]v. Bitte versuchen Sie es er" +
	"neut.\x02Status: Fertig!"

var enIndex = []uint32{ // 181 elements
	// Entry 0 - 1F
	0x00000000, 0x00000006, 0x00000039, 0x0000004f,
	0x00000064, 0x000000aa, 0x000000e9, 0x00000115,
	0x00000166, 0x000001c4, 0x00000200, 0x00000204,
	0x00000221, 0x00000241, 0x0000025f, 0x0000027f,
	0x000002a3, 0x000002c7, 0x000002d1, 0x000002da,
	0x000002e7, 0x000002f4, 0x00000301, 0x0000030e,
	0x0000031b, 0x0000032e, 0x0000034c, 0x00000367,
	0x0000037d, 0x000003a3, 0x000003af, 0x000003bc,
	// Entry 20 - 3F
	0x000003d9, 0x000003ec, 0x00000411, 0x00000445,
	0x00000459, 0x00000472, 0x0000048f, 0x000004b9,
	0x000004cf, 0x000004f3, 0x00000512, 0x00000537,
	0x00000548, 0x00000568, 0x00000587, 0x000005a9,
	0x000005c4, 0x000005e1, 0x000005e4, 0x000005e7,
	0x000005f7, 0x0000060c, 0x0000067d, 0x00000683,
	0x00000690, 0x00000698, 0x000006a4, 0x000006ae,
	0x000006ba, 0x000006c7, 0x000006cc, 0x000006d7,
	// Entry 40 - 5F
	0x000006e4, 0x000006ed, 0x000006fc, 0x00000709,
	0x00000713, 0x00000729, 0x0000073b, 0x00000745,
	0x0000075a, 0x00000762, 0x0000077d, 0x0000079e,
	0x000007b8, 0x000007d4, 0x000007e5, 0x000007ea,
	0x000007fc, 0x00000808, 0x0000080f, 0x0000081c,
	0x00000826, 0x0000084e, 0x0000098a, 0x00000990,
	0x00000997, 0x000009a7, 0x000009b4, 0x000009c8,
	0x000009ec, 0x00000a0c, 0x00000a22, 0x00000a5b,
	// Entry 60 - 7F
	0x00000a7e, 0x00000a92, 0x00000ad1, 0x00000ad8,
	0x00000ae3, 0x00000aec, 0x00000af9, 0x00000b07,
	0x00000b0b, 0x00000b11, 0x00000b1d, 0x00000b2e,
	0x00000b33, 0x00000b3f, 0x00000b6c, 0x00000b7f,
	0x00000b93, 0x00000ba0, 0x00000bd4, 0x00000be8,
	0x00000c02, 0x00000c37, 0x00000c4e, 0x00000c5e,
	0x00000c6e, 0x00000c81, 0x00000ca0, 0x00000ca6,
	0x00000cba, 0x00000cdf, 0x00000cf5, 0x00000d1c,
	// Entry 80 - 9F
	0x00000d33, 0x00000d44, 0x00000d52, 0x00000d63,
	0x00000d7b, 0x00000d96, 0x00000dee, 0x00000df6,
	0x00000dfc, 0x00000e11, 0x00000e1c, 0x00000e36,
	0x00000e50, 0x00000e58, 0x00000e76, 0x00000e8f,
	0x00000eaa, 0x00000ecc, 0x00000efb, 0x00000f27,
	0x00000f5f, 0x00000f85, 0x00000f96, 0x00000fcc,
	0x00001013, 0x0000102b, 0x0000105d, 0x000010cf,
	0x000010e9, 0x00001123, 0x00001146, 0x0000115e,
	// Entry A0 - BF
	0x00001187, 0x000011a0, 0x000011f9, 0x0000123e,
	0x00001259, 0x0000127f, 0x00001295, 0x000012b8,
	0x000012d0, 0x0000132f, 0x00001384, 0x0000139d,
	0x000013a8, 0x000013cc, 0x000013ec, 0x000013fe,
	0x00001405, 0x0000140d, 0x00001416, 0x00001420,
	0x00001429,
} // Size: 748 bytes

const enData string = "" + // Size: 5161 bytes
	"\x02Error\x02(no argument): elevate and install manager service\x02Usage" +
	": %[1]s [\x0a%[2]s]\x02Command Line Options\x02Unable to determine wheth" +
	"er the process is running under WOW64: %[1]v\x02You must use the native " +
	"version of WireGuard on this computer.\x02Unable to open current process" +
	" token: %[1]v\x02WireGuard may only be used by users who are a member of" +
	" the Builtin %[1]s group.\x02WireGuard is running, but the UI is only ac" +
	"cessible from desktops of the Builtin %[1]s group.\x02WireGuard system t" +
	"ray icon did not appear after 30 seconds.\x02Now\x02System clock wound b" +
	"ackward!\x14\x01\x81\x01\x00\x02\x0b\x02%[1]d year\x00\x0c\x02%[1]d year" +
	"s\x14\x01\x81\x01\x00\x02\x0a\x02%[1]d day\x00\x0b\x02%[1]d days\x14\x01" +
	"\x81\x01\x00\x02\x0b\x02%[1]d hour\x00\x0c\x02%[1]d hours\x14\x01\x81" +
	"\x01\x00\x02\x0d\x02%[1]d minute\x00\x0e\x02%[1]d minutes\x14\x01\x81" +
	"\x01\x00\x02\x0d\x02%[1]d second\x00\x0e\x02%[1]d seconds\x02%[1]s ago" +
	"\x02%[1]d\u00a0B\x02%.2[1]f\u00a0KiB\x02%.2[1]f\u00a0MiB\x02%.2[1]f" +
	"\u00a0GiB\x02%.2[1]f\u00a0TiB\x02%[1]s: %[2]q\x02Invalid IP address\x02I" +
	"nvalid network prefix length\x02Missing port from endpoint\x02Invalid en" +
	"dpoint host\x02Brackets must contain an IPv6 address\x02Invalid MTU\x02I" +
	"nvalid port\x02Invalid persistent keepalive\x02Invalid key: %[1]v\x02Key" +
	"s must decode to exactly 32 bytes\x02Number must be a number between 0 a" +
	"nd 2^64-1: %[1]v\x02Two commas in a row\x02Tunnel name is not valid\x02L" +
	"ine must occur in a section\x02Config key is missing an equals separator" +
	"\x02Key must have a value\x02Invalid key for [Interface] section\x02Inva" +
	"lid key for [Peer] section\x02An interface must have a private key\x02[n" +
	"one specified]\x02All peers must have public keys\x02Error in getting co" +
	"nfiguration\x02Invalid key for interface section\x02Protocol version mus" +
	"t be 1\x02Invalid key for peer section\x02, \x02, \x02About WireGuard" +
	"\x02WireGuard logo image\x02App version: %[1]s\x0aGo backend version: %[" +
	"2]s\x0aGo version: %[3]s-%[4]s\x0aOperating system: %[5]s\x0aArchitectur" +
	"e: %[6]s\x02Close\x02♥ &Donate!\x02Status:\x02&Deactivate\x02&Activate" +
	"\x02Public key:\x02Listen port:\x02MTU:\x02Addresses:\x02DNS servers:" +
	"\x02Scripts:\x02Preshared key:\x02Allowed IPs:\x02Endpoint:\x02Persisten" +
	"t keepalive:\x02Latest handshake:\x02Transfer:\x02disabled, per policy" +
	"\x02enabled\x02%[1]s received, %[2]s sent\x02Failed to determine tunnel " +
	"state\x02Failed to activate tunnel\x02Failed to deactivate tunnel\x02Int" +
	"erface: %[1]s\x02Peer\x02Create new tunnel\x02Edit tunnel\x02&Name:\x02&" +
	"Public key:\x02(unknown)\x02&Block untunneled traffic (kill-switch)\x02W" +
	"hen a configuration has exactly one peer, and that peer has an allowed I" +
	"Ps containing at least one of 0.0.0.0/0 or ::/0, then the tunnel service" +
	" engages a firewall ruleset to block all traffic that is neither to nor " +
	"from the tunnel interface or is to the wrong DNS server, with special ex" +
	"ceptions for DHCP and NDP.\x02&Save\x02Cancel\x02&Configuration:\x02Inva" +
	"lid name\x02A name is required.\x02Tunnel name ‘%[1]s’ is invalid.\x02Un" +
	"able to list existing tunnels\x02Tunnel already exists\x02Another tunnel" +
	" already exists with the name ‘%[1]s’.\x02Unable to create new configura" +
	"tion\x02Writing file failed\x02File ‘%[1]s’ already exists.\x0a\x0aDo yo" +
	"u want to overwrite it?\x02Active\x02Activating\x02Inactive\x02Deactivat" +
	"ing\x02Unknown state\x02Log\x02&Copy\x02Select &all\x02&Save to file…" +
	"\x02Time\x02Log message\x02Text Files (*.txt)|*.txt|All Files (*.*)|*.*" +
	"\x02Export log to file\x02&About WireGuard…\x02Tunnel Error\x02%[1]s\x0a" +
	"\x0aPlease consult the log for more information.\x02%[1]s (out of date)" +
	"\x02WireGuard Detection Error\x02Unable to wait for WireGuard window to " +
	"appear: %[1]v\x02WireGuard: Deactivated\x02Status: Unknown\x02Addresses:" +
	" None\x02&Manage tunnels…\x02&Import tunnel(s) from file…\x02E&xit\x02Wi" +
	"reGuard Activated\x02The %[1]s tunnel has been activated.\x02WireGuard D" +
	"eactivated\x02The %[1]s tunnel has been deactivated.\x02WireGuard Tunnel" +
	" Error\x02WireGuard: %[1]s\x02Status: %[1]s\x02Addresses: %[1]s\x02An Up" +
	"date is Available!\x02WireGuard Update Available\x02An update to WireGua" +
	"rd is now available. You are advised to update as soon as possible.\x02T" +
	"unnels\x02&Edit\x02Add &empty tunnel…\x02Add Tunnel\x02Remove selected t" +
	"unnel(s)\x02Export all tunnels to zip\x02&Toggle\x02Export all tunnels t" +
	"o &zip…\x02Edit &selected tunnel…\x02&Remove selected tunnel(s)\x02no co" +
	"nfiguration files were found\x02Could not import selected configuration:" +
	" %[1]v\x02Could not enumerate existing tunnels: %[1]v\x02Another tunnel " +
	"already exists with the name ‘%[1]s’\x02Unable to import configuration: " +
	"%[1]v\x02Imported tunnels\x14\x01\x81\x01\x00\x02\x16\x02Imported %[1]d " +
	"tunnel\x00\x17\x02Imported %[1]d tunnels\x14\x02\x80\x01\x02\x1f\x02Impo" +
	"rted %[1]d of %[2]d tunnel\x00 \x02Imported %[1]d of %[2]d tunnels\x02Un" +
	"able to create tunnel\x14\x01\x81\x01\x00\x02\x14\x02Delete %[1]d tunnel" +
	"\x00\x15\x02Delete %[1]d tunnels\x14\x01\x81\x01\x00\x024\x02Are you sur" +
	"e you would like to delete %[1]d tunnel?\x005\x02Are you sure you would " +
	"like to delete %[1]d tunnels?\x02Delete tunnel ‘%[1]s’\x02Are you sure y" +
	"ou would like to delete tunnel ‘%[1]s’?\x02%[1]s You cannot undo this ac" +
	"tion.\x02Unable to delete tunnel\x02A tunnel was unable to be removed: %" +
	"[1]s\x02Unable to delete tunnels\x14\x01\x81\x01\x00\x02'\x02%[1]d tunne" +
	"l was unable to be removed.\x00)\x02%[1]d tunnels were unable to be remo" +
	"ved.\x02Configuration Files (*.zip, *.conf)|*.zip;*.conf|All Files (*.*)" +
	"|*.*\x02Import tunnel(s) from file\x02Configuration ZIP Files (*.zip)|*." +
	"zip\x02Export tunnels to zip\x02%[1]s (unsigned build, no updates)\x02Er" +
	"ror Exiting WireGuard\x02Unable to exit service due to: %[1]v. You may w" +
	"ant to stop WireGuard from the service manager.\x02An update to WireGuar" +
	"d is available. It is highly advisable to update without delay.\x02Statu" +
	"s: Waiting for user\x02Update Now\x02Status: Waiting for updater service" +
	"\x02Error: %[1]v. Please try again.\x02Status: Complete!\x02pre-up\x02po" +
	"st-up\x02pre-down\x02post-down\x02&Tunnels"

var es_ESIndex = []uint32{ // 181 elements
	// Entry 0 - 1F
	0x00000000, 0x00000006, 0x00000044, 0x00000058,
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	// Entry 20 - 3F
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	// Entry 40 - 5F
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	// Entry 60 - 7F
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	// Entry 80 - 9F
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	// Entry A0 - BF
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	0x00000058, 0x00000058, 0x00000058, 0x00000058,
	0x00000058,
} // Size: 748 bytes

const es_ESData string = "" + // Size: 88 bytes
	"\x02Error\x02(sin argumento): eleva e instala el servicio de administrad" +
	"or\x02Uso: %[1]s [\x0a%[2]s]"

var faIndex = []uint32{ // 181 elements
	// Entry 0 - 1F
	0x00000000, 0x00000007, 0x00000007, 0x00000007,
	0x0000002b, 0x0000002b, 0x0000002b, 0x0000002b,
	0x0000002b, 0x0000002b, 0x0000002b, 0x0000003b,
	0x0000003b, 0x0000005e, 0x00000081, 0x000000a8,
	0x000000d3, 0x000000fe, 0x0000010b, 0x0000011b,
	0x0000011b, 0x0000011b, 0x0000011b, 0x0000011b,
	0x0000011b, 0x00000148, 0x00000148, 0x00000148,
	0x00000148, 0x00000148, 0x00000162, 0x0000017a,
	// Entry 20 - 3F
	0x0000017a, 0x0000017a, 0x0000017a, 0x0000017a,
	0x0000017a, 0x0000017a, 0x0000017a, 0x0000017a,
	0x000001b0, 0x000001b0, 0x000001b0, 0x000001b0,
	0x000001c4, 0x00000214, 0x0000023e, 0x0000023e,
	0x0000023e, 0x0000023e, 0x00000242, 0x00000246,
	0x0000025d, 0x0000025d, 0x0000025d, 0x00000266,
	0x0000027d, 0x00000289, 0x000002a4, 0x000002b9,
	0x000002ce, 0x000002e1, 0x000002e6, 0x000002f9,
	// Entry 40 - 5F
	0x0000030d, 0x0000030d, 0x00000335, 0x00000348,
	0x0000035d, 0x00000388, 0x00000388, 0x00000396,
	0x00000396, 0x000003a6, 0x000003a6, 0x000003a6,
	0x000003a6, 0x000003a6, 0x000003b6, 0x000003bf,
	0x000003dc, 0x000003f2, 0x000003fb, 0x00000411,
	0x00000424, 0x00000424, 0x00000424, 0x00000430,
	0x00000437, 0x0000044a, 0x00000460, 0x00000481,
	0x00000481, 0x000004c7, 0x000004f4, 0x000004f4,
	// Entry 60 - 7F
	0x000004f4, 0x000004f4, 0x000004f4, 0x000004fd,
	0x0000051d, 0x0000052c, 0x00000552, 0x0000056e,
	0x00000584, 0x00000592, 0x00000592, 0x000005b3,
	0x000005bc, 0x000005dd, 0x000005dd, 0x00000619,
	0x00000634, 0x00000648, 0x00000648, 0x00000648,
	0x00000648, 0x00000648, 0x00000648, 0x00000665,
	0x0000067f, 0x000006a0, 0x000006a0, 0x000006a0,
	0x000006ba, 0x000006dc, 0x000006fa, 0x000006fa,
	// Entry 80 - 9F
	0x00000716, 0x00000716, 0x00000728, 0x00000728,
	0x0000075d, 0x00000796, 0x00000796, 0x000007a6,
	0x000007b4, 0x000007e2, 0x000007f8, 0x0000081d,
	0x00000852, 0x00000852, 0x0000088b, 0x0000088b,
	0x0000088b, 0x0000088b, 0x0000088b, 0x0000088b,
	0x0000088b, 0x0000088b, 0x000008ad, 0x000008f0,
	0x00000948, 0x00000975, 0x000009aa, 0x000009aa,
	0x000009c6, 0x000009c6, 0x000009c6, 0x000009f8,
	// Entry A0 - BF
	0x000009f8, 0x00000a2d, 0x00000a2d, 0x00000a2d,
	0x00000a60, 0x00000a9c, 0x00000aca, 0x00000aca,
	0x00000b00, 0x00000b00, 0x00000b00, 0x00000b31,
	0x00000b5a, 0x00000ba3, 0x00000bdb, 0x00000bf6,
	0x00000bf6, 0x00000bf6, 0x00000bf6, 0x00000bf6,
	0x00000bf6,
} // Size: 748 bytes

const faData string = "" + // Size: 3062 bytes
	"\x02خطا\x02گزینه\u200cهای خط فرمان\x02هم اکنون\x14\x01\x81\x01\x00\x02" +
	"\x0d\x02%[1]d سال\x00\x0d\x02%[1]d سال\x14\x01\x81\x01\x00\x02\x0d\x02%[" +
	"1]d روز\x00\x0d\x02%[1]d روز\x14\x01\x81\x01\x00\x02\x0f\x02%[1]d ساعت" +
	"\x00\x0f\x02%[1]d ساعت\x14\x01\x81\x01\x00\x02\x11\x02%[1]d دقیقه\x00" +
	"\x11\x02%[1]d دقیقه\x14\x01\x81\x01\x00\x02\x11\x02%[1]d ثانیه\x00\x11" +
	"\x02%[1]d ثانیه\x02%[1]s پیش\x02%[1]d\u00a0بایت\x02نشانی آی\u200cپی نامع" +
	"تبر است\x02MTU نامعتبر است\x02پورت نامعتبر\x02کلید باید یک مقدار داشته " +
	"باشد\x02[مشخص نشده]\x02همه همتاها باید کلید\u200cهای عمومی داشته باشند" +
	"\x02خطا در دریافت پیکربندی\x02، \x02، \x02درباره WireGuard\x02بستن\x02♥&" +
	"کمک\u200cمالی!\x02وضعیت:\x02&غیرفعال\u200cسازی\x02&فعال\u200cسازی\x02کل" +
	"ید عمومی:\x02پورت شنود:\x02MTU:\x02نشانی\u200cها:\x02سرورهای DNS:\x02کل" +
	"ید از پیش تقسیم شده:\x02IPهای مجاز:\x02نقطه پایان:\x02زنده نگه\u200cداش" +
	"تن پیوسته:\x02انتقال:\x02فعال شده\x02رابط: %[1]s\x02همتا\x02ایجاد تونل " +
	"جدید\x02ویرایش تونل\x02&نام:\x02&کلید عمومی:\x02(ناشناخته)\x02&ذخیره" +
	"\x02لغو\x02&پیکربندی:\x02نام نامعتبر\x02یک نام الزامی است.\x02نمی\u200cت" +
	"وان تونل\u200cهای موجود را فهرست کرد\x02تونل هم\u200cاکنون موجود است" +
	"\x02فعال\x02در حال فعال\u200cسازی\x02غیرفعال\x02در حال غیرفعال\u200cسازی" +
	"\x02وضعیت ناشناخته\x02گزارش وقایع\x02&روگرفت\x02&ذخیره در پرونده…\x02زما" +
	"ن\x02پیام گزارش رویداد\x02برون\u200cبرد گزارش رویداد به پرونده\x02&دربا" +
	"ره WireGuard…\x02خطالی تونل\x02وضعیت: ناشناخته\x02نشانی\u200cها: هیچ" +
	"\x02&مدیریت تونل\u200cها…\x02WireGuard فعال\u200cشد\x02تونل %[1]s فعال" +
	"\u200cشده.\x02WireGuard غیرفعال شد\x02خطای تونل WireGuard\x02وضعیت: %[1]" +
	"s\x02یک به\u200cروزرسانی در دسترس است!\x02به\u200cروزرسانی WireGuard در " +
	"دسترس است\x02تونل\u200cها\x02&ویرایش\x02افزودن &خالی\u200cکردن تونل…" +
	"\x02افزودن تونل\x02حذف تونل(ها) انتخابی\x02برون\u200cبری همه تونل\u200cه" +
	"ا به زیپ\x02برون\u200cبری همه تونل\u200cها به &زیپ…\x02تونل\u200cهای وا" +
	"رد شده\x14\x01\x81\x01\x00\x02\x1d\x02%[1]d تونل وارد شد\x00\x1d\x02%[1" +
	"]d تونل وارد شد\x14\x02\x80\x01\x02(\x02%[1]d از %[2]d تونل وارد شد\x00(" +
	"\x02%[1]d از %[2]d تونل وارد شد\x02نمی\u200cتوان تونل ایجاد کرد\x14\x01" +
	"\x81\x01\x00\x02\x16\x02حذف %[1]d تونل\x00\x16\x02حذف %[1]d تونل\x02حذف " +
	"تونل ‘%[1]s’\x02حذف تونل\u200c امکان\u200cپذیر نیست\x02نمی\u200cتوان تو" +
	"نل\u200cها را حذف کرد\x02وارد کردن تونل(ها) از پرونده\x02پرونده\u200cها" +
	"ی پیکربندی زیپ (*.zip)|*.zip\x02برون\u200cبری تونل\u200cها به زیپ\x02خط" +
	"ا در هنگام خارج شدن از WireGuard\x02وضعیت: درانتظار برای کاربر\x02اکنون" +
	" به\u200cروز رسانی کن\x02وضعیت: درانتظار برای سرویس به\u200cروزرسانی\x02" +
	"خطا: %[1]v. لطفا دوباره تلاش کنید.\x02وضعیت: کامل شد!"

var fiIndex = []uint32{ // 181 elements
	// Entry 0 - 1F
	0x00000000, 0x00000006, 0x00000006, 0x00000006,
	0x00000006, 0x00000006, 0x00000006, 0x00000006,
	0x00000006, 0x00000006, 0x00000006, 0x0000000a,
	0x0000002a, 0x0000002a, 0x0000002a, 0x0000002a,
	0x0000002a, 0x0000002a, 0x0000002a, 0x0000002a,
	0x0000002a, 0x0000002a, 0x0000002a, 0x0000002a,
	0x0000002a, 0x0000002a, 0x0000002a, 0x0000002a,
	0x0000002a, 0x0000002a, 0x0000002a, 0x0000002a,
	// Entry 20 - 3F
	0x00000049, 0x00000049, 0x00000049, 0x00000049,
	0x00000049, 0x00000049, 0x00000049, 0x00000049,
	0x00000049, 0x00000049, 0x00000049, 0x00000049,
	0x00000049, 0x00000049, 0x00000049, 0x00000049,
	0x00000049, 0x00000049, 0x0000004c, 0x0000004c,
	0x00000061, 0x00000076, 0x00000076, 0x0000007c,
	0x0000008b, 0x00000091, 0x00000091, 0x00000091,
	0x00000091, 0x00000091, 0x00000096, 0x000000a1,
	// Entry 40 - 5F
	0x000000b1, 0x000000c0, 0x000000ce, 0x000000e5,
	0x000000f3, 0x00000106, 0x0000011a, 0x00000123,
	0x00000123, 0x00000123, 0x00000123, 0x00000123,
	0x00000123, 0x00000123, 0x00000123, 0x0000012c,
	0x0000013d, 0x0000014e, 0x00000155, 0x00000166,
	0x00000173, 0x000001a3, 0x000001a3, 0x000001ad,
	0x000001ad, 0x000001bd, 0x000001cf, 0x000001e3,
	0x000001e3, 0x000001e3, 0x000001fa, 0x000001fa,
	// Entry 60 - 7F
	0x000001fa, 0x000001fa, 0x000001fa, 0x000001fa,
	0x000001fa, 0x000001fa, 0x000001fa, 0x000001fa,
	0x000001ff, 0x00000207, 0x00000207, 0x00000207,
	0x00000207, 0x00000207, 0x00000207, 0x00000207,
	0x00000207, 0x00000207, 0x00000207, 0x00000207,
	0x00000207, 0x00000207, 0x00000207, 0x00000207,
	0x00000207, 0x00000207, 0x00000207, 0x00000207,
	0x00000207, 0x00000207, 0x00000207, 0x00000207,
	// Entry 80 - 9F
	0x00000207, 0x00000207, 0x00000207, 0x00000207,
	0x00000220, 0x0000023f, 0x0000029f, 0x000002a7,
	0x000002b0, 0x000002b0, 0x000002b0, 0x000002b0,
	0x000002b0, 0x000002b0, 0x000002b0, 0x000002b0,
	0x000002b0, 0x000002b0, 0x000002b0, 0x000002b0,
	0x000002b0, 0x000002b0, 0x000002c0, 0x000002f2,
	0x000002f2, 0x000002f2, 0x000002f2, 0x000002f2,
	0x000002f2, 0x000002f2, 0x000002f2, 0x000002f2,
	// Entry A0 - BF
	0x000002f2, 0x0000030c, 0x0000030c, 0x0000030c,
	0x00000327, 0x00000327, 0x00000327, 0x00000327,
	0x00000327, 0x00000327, 0x00000327, 0x00000345,
	0x00000353, 0x00000353, 0x00000353, 0x00000361,
	0x00000361, 0x00000361, 0x00000361, 0x00000361,
	0x00000361,
} // Size: 748 bytes

const fiData string = "" + // Size: 865 bytes
	"\x02Virhe\x02Nyt\x02Järjestelmän kello jättää!\x02Virheellinen jatkuva k" +
	"eepalive\x02, \x02Tietoa WireGuardista\x02WireGuard logon kuva\x02Sulje" +
	"\x02♥ &Lahjoita!\x02Tila:\x02MTU:\x02Osoitteet:\x02DNS palvelimet:\x02Ko" +
	"mentosarjat:\x02Jaettu avain:\x02Sallitut IP-osoitteet:\x02Päätepiste:" +
	"\x02Jatkuva keepalive:\x02Viimeisin kättely:\x02Siirrot:\x02Osapuoli\x02" +
	"Luo uusi tunneli\x02Muokkaa tunnelia\x02&Nimi:\x02&Julkinen avain:\x02(t" +
	"untematon)\x02&Estä tunneloimaton liikenne (pääkatkaisija)\x02&Tallenna" +
	"\x02&Konfiguraatio:\x02Virheellinen nimi\x02Nimi on pakollinen.\x02Tunne" +
	"li on jo olemassa\x02Loki\x02&Kopioi\x02Päivitys on saatavilla!\x02WireG" +
	"uard päivitys saatavilla\x02WireGuardin päivitys on nyt saatavilla. Sinu" +
	"a kehotetaan päivittämään mahdollisimman pian.\x02Tunneli\x02&Muokkaa" +
	"\x02Tuodut tunnelit\x14\x01\x81\x01\x00\x02\x14\x02Tuotu %[1]d tunneli" +
	"\x00\x15\x02Tuotu %[1]d tunnelia\x02Tunnelia ei voitu poistaa\x02Tuo tun" +
	"neli(t) tiedostosta\x02Tila: Odotetaan käyttäjää\x02Päivitä nyt\x02Tila:" +
	" Valmis!"

var frIndex = []uint32{ // 181 elements
	// Entry 0 - 1F
	0x00000000, 0x00000007, 0x00000046, 0x00000063,
	0x00000083, 0x000000cb, 0x00000112, 0x0000014b,
	0x000001ad, 0x00000225, 0x00000282, 0x0000028d,
	0x000002b0, 0x000002cc, 0x000002ec, 0x0000030e,
	0x00000332, 0x00000358, 0x00000365, 0x0000036e,
	0x0000037b, 0x00000388, 0x00000395, 0x000003a2,
	0x000003b0, 0x000003c6, 0x000003ee, 0x00000414,
	0x0000043d, 0x00000475, 0x00000484, 0x00000494,
	// Entry 20 - 3F
	0x000004a9, 0x000004c1, 0x000004ee, 0x00000526,
	0x00000542, 0x0000055b, 0x00000587, 0x000005c2,
	0x000005dd, 0x00000609, 0x00000630, 0x00000658,
	0x00000670, 0x000006a4, 0x000006cb, 0x000006f7,
	0x00000719, 0x00000745, 0x00000748, 0x0000074a,
	0x00000761, 0x0000077c, 0x00000806, 0x0000080d,
	0x00000821, 0x00000829, 0x00000836, 0x0000083f,
	0x0000084f, 0x00000860, 0x00000866, 0x00000871,
	// Entry 40 - 5F
	0x00000880, 0x0000088a, 0x000008a0, 0x000008ba,
	0x000008d1, 0x000008ff, 0x00000926, 0x00000932,
	0x00000950, 0x0000095b, 0x0000097c, 0x000009a8,
	0x000009c7, 0x000009eb, 0x000009fd, 0x00000a07,
	0x00000a20, 0x00000a33, 0x00000a3a, 0x00000a4b,
	0x00000a58, 0x00000a8b, 0x00000c05, 0x00000c12,
	0x00000c1a, 0x00000c2b, 0x00000c3a, 0x00000c52,
	0x00000c7c, 0x00000cb1, 0x00000cc7, 0x00000cfb,
	// Entry 60 - 7F
	0x00000d2b, 0x00000d49, 0x00000d88, 0x00000d91,
	0x00000da5, 0x00000dae, 0x00000dc6, 0x00000dd4,
	0x00000ddc, 0x00000de4, 0x00000df8, 0x00000e18,
	0x00000e1e, 0x00000e31, 0x00000e6a, 0x00000e8e,
	0x00000ea6, 0x00000eb7, 0x00000f01, 0x00000f13,
	0x00000f35, 0x00000f77, 0x00000f8e, 0x00000f9e,
	0x00000fb0, 0x00000fc8, 0x00000ffa, 0x00001003,
	0x00001015, 0x00001033, 0x00001049, 0x0000106b,
	// Entry 80 - 9F
	0x00001086, 0x00001098, 0x000010a6, 0x000010b7,
	0x000010d0, 0x000010f6, 0x0000116b, 0x00001173,
	0x0000117d, 0x00001198, 0x000011aa, 0x000011d5,
	0x000011f8, 0x00001202, 0x00001229, 0x0000124e,
	0x0000127a, 0x000012a1, 0x000012df, 0x00001316,
	0x00001342, 0x00001371, 0x00001383, 0x000013ba,
	0x00001403, 0x00001422, 0x0000145a, 0x000014be,
	0x000014de, 0x00001514, 0x00001543, 0x00001565,
	// Entry A0 - BF
	0x0000159a, 0x000015be, 0x0000162a, 0x0000167d,
	0x000016ab, 0x000016d7, 0x000016f5, 0x00001726,
	0x00001744, 0x000017bf, 0x00001838, 0x0000185d,
	0x00001877, 0x000018a6, 0x000018cb, 0x000018dc,
	0x000018ec, 0x000018fc, 0x00001910, 0x00001924,
	0x0000192e,
} // Size: 748 bytes

const frData string = "" + // Size: 6446 bytes
	"\x02Erreur\x02(sans argument) : élever et installer service du gestionna" +
	"ire\x02Utilisation : %[1]s [\x0a%[2]s]\x02Options de la ligne de command" +
	"e\x02Impossible de détecter si le processus s’exécute sous WOW64 : %[1]v" +
	"\x02Vous devez utiliser la version native de WireGuard sur cet ordinateu" +
	"r.\x02Impossible d'ouvrir le jeton du processus actuel : %[1]v\x02Seulem" +
	"ent les utilisateurs qui sont membres du groupe intégré %[1]s peuvent ut" +
	"iliser WireGuard.\x02WireGuard est en cours d'exécution, mais l'IU est a" +
	"ccessible seulement à partir des bureaux du group intégré %[1]s.\x02L’ic" +
	"ône de la barre d’état système du WireGuard n'est pas apparue après 30 " +
	"secondes.\x02Maintenant\x02L’horloge système est inversé!\x14\x01\x81" +
	"\x01\x00\x02\x09\x02%[1]d an\x00\x0a\x02%[1]d ans\x14\x01\x81\x01\x00" +
	"\x02\x0b\x02%[1]d jour\x00\x0c\x02%[1]d jours\x14\x01\x81\x01\x00\x02" +
	"\x0c\x02%[1]d heure\x00\x0d\x02%[1]d heures\x14\x01\x81\x01\x00\x02\x0d" +
	"\x02%[1]d minute\x00\x0e\x02%[1]d minutes\x14\x01\x81\x01\x00\x02\x0e" +
	"\x02%[1]d seconde\x00\x0f\x02%[1]d secondes\x02Il y a %[1]s\x02%[1]d" +
	"\u00a0o\x02%.2[1]f\u00a0Kio\x02%.2[1]f\u00a0Mio\x02%.2[1]f\u00a0Gio\x02%" +
	".2[1]f\u00a0Tio\x02%[1]s : %[2]q\x02Adresse IP non valide\x02Longueur du" +
	" préfixe réseau non valide\x02Port manquant au point de terminaison\x02H" +
	"ôte du point de terminaison non valide\x02L’adresse IPv6 doit être cont" +
	"enue entre des crochets\x02MTU non valide\x02Port non valide\x02Keepaliv" +
	"e non valide\x02Clé non valide : %[1]v\x02Clés doivent être décodées sur" +
	" 32 octets\x02Le numéro doit être compris entre 0 et 2^64-1 : %[1]v\x02D" +
	"eux virgules consécutives\x02Nom du tunnel non valide\x02Une ligne doit " +
	"apparaître dans une section\x02Il manque le séparateur égal à la clé de " +
	"configuration\x02Clé doit avoir une valeur\x02Clé non valide pour la sec" +
	"tion [Interface]\x02Clé non valide pour la section [Peer]\x02L'interface" +
	" doit avoir une clé privée\x02[aucune spécification]\x02Toutes les pairs" +
	" doivent contenir une clé publique\x02Erreur d'obtention de la configura" +
	"tion\x02Clé non valide pour la section d'interface\x02Version du protoco" +
	"le doit être 1\x02Clé non valide pour la section d'homologue\x02, \x02 " +
	"\x02À propos du WireGuard\x02Image du logo du WireGuard\x02Version de l'" +
	"application : %[1]s\x0aVersion backend Go : %[2]s\x0aVersion Go : %[3]s-" +
	"%[4]s\x0aSystème d'exploitation : %[5]s\x0aArchitecture : %[6]s\x02Ferme" +
	"r\x02♥ &Faites un don!\x02État :\x02&Désactiver\x02&Activer\x02Clé publi" +
	"que :\x02Port d'écoute :\x02MTU :\x02Adresses :\x02Serveurs DNS :\x02Scr" +
	"ipts :\x02Clé pré-partagée :\x02Adresses IP autorisées :\x02Point de ter" +
	"minaison :\x02Conservation de connexion active permanente :\x02Dernier é" +
	"tablissement d'une liaison :\x02Transfert :\x02désactivé, par préférence" +
	"\x02activé(e)\x02%[1]s reçu(e), %[2]s envoyé(e)\x02Impossible de détermi" +
	"ner l'état du tunnel\x02Impossible d'activer le tunnel\x02Impossible de " +
	"désactiver le tunnel\x02Interface : %[1]s\x02Homologue\x02Créer un nouve" +
	"au tunnel\x02Modifier le tunnel\x02&Nom :\x02&Clé publique :\x02(inconnu" +
	"(e))\x02&Bloquer tous le trafic hors tunnel (interrupteur)\x02Si la conf" +
	"iguration a exactement un homologue et si cet homologue a une adresse IP" +
	" autorisée contenant au moins un de 0.0.0.0/0\u00a0ou\u00a0::/0, le serv" +
	"ice de tunnel utilise un ensemble de règles du pare-feu afin de bloquer " +
	"tout le trafic qui n'est ni vers ni depuis l'interface de tunnel ou qui " +
	"est vers le mauvais serveur DNS, avec des exceptions spéciales pour les " +
	"DHCP et NDP.\x02&Enregistrer\x02Annuler\x02&Configuration :\x02Nom non v" +
	"alide\x02Le nom est obligatoire.\x02Nom de tunnel « %[1]s » est non vali" +
	"de.\x02Impossible de créer une liste des tunnels existants\x02Tunnel exi" +
	"ste déjà.\x02Nom « %[1]s » est déjà utilisé pour un tunnel.\x02Impossibl" +
	"e de créer une configuration nouvelle\x02Échec d'écriture du fichier\x02" +
	"Fichier « %[1]s » existe déjà.\x0a\x0aVoulez-vous le remplacer ?\x02Acti" +
	"vée\x02Activation en cours\x02Éteinte\x02Désactivation en cours\x02État " +
	"inconnu\x02Journal\x02&Copier\x02Sélectionner &tout\x02&Enregistrer dans" +
	" le fichier…\x02Temps\x02Message du journal\x02Fichiers texte (*.txt)|*." +
	"txt|Tous les fichiers (*.*)|*.*\x02Exporter le journal vers le fichier" +
	"\x02&À propos WireGuard…\x02Erreur du tunnel\x02%[1]s\x0a\x0aConsultez l" +
	"e journal pour plus d’informations, s'il vous plaît.\x02%[1]s (obsolète)" +
	"\x02Erreur de détection du WireGuard\x02Impossible d’attendre l'affichag" +
	"e du fenêtre WireGuard : %[1]v\x02WireGuard: Désactivé\x02État : Inconnu" +
	"\x02Adresses : Aucune\x02&Gestion des tunnels…\x02&Importer le(s) tunnel" +
	"(s) à partir du fichier…\x02Q&uitter\x02WireGuard activé\x02Tunnel %[1]s" +
	" a été activé.\x02WireGuard désactivé\x02Tunnel %[1]s a été désactivé." +
	"\x02Erreur du tunnel WireGuard\x02WireGuard : %[1]s\x02État : %[1]s\x02A" +
	"dresses : %[1]s\x02Mise à jour disponible!\x02WireGuard mise à jour est " +
	"disponible\x02Une mise à jour du WireGuard est disponible. Il est consei" +
	"llé de mettre votre WireGuard à jour dès que possible.\x02Tunnels\x02&Mo" +
	"difier\x02Ajouter un &tunnel vide…\x02Ajouter le tunnel\x02Supprimer le(" +
	"s) tunnel(s) sélectionné(s)\x02Exporter tous les tunnels vers zip\x02&Ba" +
	"sculer\x02Exporter tous les tunnels vers &zip…\x02Modifier &le tunnel sé" +
	"lectionné…\x02&Supprimer le(s) tunnel(s) sélectionné(s)\x02aucun fichier" +
	" de configuration trouvé\x02Impossible d'importer la configuration sélec" +
	"tionnée : %[1]v\x02Impossible d'énumérer les tunnels existantes : %[1]v" +
	"\x02Un tunnel nommé « %[1]s » existe déjà.\x02Impossible d'importer la c" +
	"onfiguration : %[1]v\x02Tunnels importés\x14\x01\x81\x01\x00\x02\x16\x02" +
	"%[1]d tunnel importé\x00\x18\x02%[1]d tunnels importés\x14\x02\x80\x01" +
	"\x02 \x02%[1]d de %[2]d tunnels importé\x00!\x02%[1]d de %[2]d tunnels i" +
	"mportés\x02Impossible de créer le tunnel\x14\x01\x81\x01\x00\x02\x17\x02" +
	"Supprimer %[1]d tunnel\x00\x18\x02Supprimer %[1]d tunnels\x14\x01\x81" +
	"\x01\x00\x02-\x02Voulez-vous vraiment supprimer %[1]d tunnel?\x00.\x02Vo" +
	"ulez-vous vraiment supprimer %[1]d tunnels?\x02Supprimer le tunnel ‘%[1]" +
	"s’\x02Voulez-vous vraiment supprimer le tunnel « %[1]s »?\x02%[1]s Vous " +
	"ne pouvez pas annuler cette action.\x02Impossible de supprimer le tunnel" +
	"\x02Il a été impossible de supprimer un tunnel : %[1]s\x02Impossible de " +
	"supprimer les tunnels\x14\x01\x81\x01\x00\x021\x02Il a été impossible de" +
	" supprimer %[1]d tunnel.\x002\x02Il a été impossible de supprimer %[1]d " +
	"tunnels.\x02Fichiers de configuration (*.zip, *.conf)|*.zip;*.conf|Tous " +
	"les fichiers (*.*)|*.*\x02Importer le(s) tunnel(s) à partir du fichier" +
	"\x02Fichiers de configuration ZIP (*.zip)|*.zip\x02Exporter les tunnels " +
	"vers zip\x02%[1]s (version non signée, aucune mise à jour)\x02Erreur de " +
	"sortie du WireGuard\x02Impossible de quitter le service en raison de : %" +
	"[1]v. Essayez d'arrêter WireGuard à partir du gestionnair des services." +
	"\x02Une mise à jour du WireGuard est disponible. Il est fortement consei" +
	"llé de metter votre WireGuard à jour sans délai.\x02État: En attente de " +
	"l’utilisateur\x02Mettre à jour maintenant\x02État: En attente du program" +
	"me de mise à jour\x02Erreur : %[1]v. Veuillez réessayer.\x02État: Termin" +
	"é!\x02pré-activation\x02post-activation\x02pré-désactivation\x02post-dé" +
	"sactivation\x02& Tunnels"

var idIndex = []uint32{ // 181 elements
	// Entry 0 - 1F
	0x00000000, 0x0000000a, 0x00000047, 0x00000062,
	0x00000074, 0x000000bf, 0x000000bf, 0x000000f0,
	0x00000148, 0x000001a1, 0x000001d6, 0x000001df,
	0x000001f2, 0x00000211, 0x00000223, 0x00000234,
	0x00000247, 0x0000025a, 0x0000026a, 0x00000272,
	0x0000027e, 0x0000028a, 0x00000296, 0x000002a2,
	0x000002af, 0x000002c5, 0x000002e0, 0x00000300,
	0x0000031a, 0x00000340, 0x00000350, 0x00000361,
	// Entry 20 - 3F
	0x00000382, 0x00000398, 0x000003c0, 0x000003f2,
	0x0000040c, 0x00000424, 0x00000441, 0x00000441,
	0x0000045c, 0x00000486, 0x000004ab, 0x000004d0,
	0x000004e1, 0x00000509, 0x0000052d, 0x00000557,
	0x0000056e, 0x00000593, 0x00000596, 0x00000596,
	0x000005a8, 0x000005a8, 0x000005a8, 0x000005ae,
	0x000005bb, 0x000005c3, 0x000005c3, 0x000005c3,
	0x000005c3, 0x000005c3, 0x000005c3, 0x000005c3,
	// Entry 40 - 5F
	0x000005c3, 0x000005c3, 0x000005c3, 0x000005c3,
	0x000005c3, 0x000005c3, 0x000005c3, 0x000005c3,
	0x000005c3, 0x000005c3, 0x000005c3, 0x000005c3,
	0x000005c3, 0x000005c3, 0x000005c3, 0x000005c3,
	0x000005c3, 0x000005c3, 0x000005c3, 0x000005c3,
	0x000005c3, 0x000005c3, 0x000005c3, 0x000005c3,
	0x000005c3, 0x000005c3, 0x000005c3, 0x000005c3,
	0x000005c3, 0x000005c3, 0x000005c3, 0x000005c3,
	// Entry 60 - 7F
	0x000005c3, 0x000005c3, 0x000005c3, 0x000005c9,
	0x000005d6, 0x000005df, 0x000005ed, 0x00000604,
	0x0000060c, 0x00000612, 0x0000061e, 0x0000063b,
	0x00000641, 0x0000064b, 0x0000067b, 0x00000693,
	0x000006a9, 0x000006b5, 0x000006eb, 0x000006fe,
	0x00000715, 0x0000074a, 0x00000763, 0x0000077b,
	0x0000078a, 0x0000079d, 0x000007b8, 0x000007c0,
	0x000007c0, 0x000007c0, 0x000007c0, 0x000007c0,
	// Entry 80 - 9F
	0x000007d6, 0x000007e7, 0x000007f5, 0x000007f5,
	0x000007f5, 0x000007f5, 0x000007f5, 0x000007f5,
	0x000007f5, 0x000007f5, 0x000007f5, 0x000007f5,
	0x000007f5, 0x000007f5, 0x00000814, 0x0000082d,
	0x00000844, 0x00000844, 0x0000087a, 0x0000087a,
	0x0000087a, 0x0000087a, 0x0000087a, 0x0000087a,
	0x0000087a, 0x0000087a, 0x0000087a, 0x0000087a,
	0x0000087a, 0x0000087a, 0x0000087a, 0x0000087a,
	// Entry A0 - BF
	0x0000087a, 0x0000087a, 0x0000087a, 0x0000087a,
	0x0000087a, 0x0000087a, 0x0000087a, 0x0000087a,
	0x0000087a, 0x0000087a, 0x0000087a, 0x0000087a,
	0x0000087a, 0x0000087a, 0x0000087a, 0x0000087a,
	0x0000087a, 0x0000087a, 0x0000087a, 0x0000087a,
	0x0000087a,
} // Size: 748 bytes

const idData string = "" + // Size: 2170 bytes
	"\x02Kesalahan\x02(tidak ada argumen): naikkan akses dan instal servis ma" +
	"najer\x02Penggunaan: %[1]s [\x0a%[2]s]\x02Opsi Command Line\x02Tidak dap" +
	"at menentukan apakah proses sedang berjalan di bawah WOW64: %[1]v\x02Tid" +
	"ak dapat membuka token proses saat ini: %[1]v\x02WireGuard hanya dapat d" +
	"igunakan oleh pengguna yang merupakan anggota grup Bawaan %[1]s.\x02Wire" +
	"Guard sedang berjalan, tetapi UI hanya dapat diakses dari desktop grup B" +
	"awaan %[1]s.\x02Ikon sistem WireGuard tidak muncul setelah 30 detik.\x02" +
	"Sekarang\x02Jam sistem mundur!\x14\x01\x81\x01\x00\x00\x18\x02%[1]d tahu" +
	"n\x0a%[1]d tahun\x14\x01\x81\x01\x00\x00\x0b\x02%[1]d Hari\x14\x01\x81" +
	"\x01\x00\x00\x0a\x02%[1]d jam\x14\x01\x81\x01\x00\x00\x0c\x02%[1]d menit" +
	"\x14\x01\x81\x01\x00\x00\x0c\x02%[1]d detik\x02%[1]s yang lalu\x02%[1]d " +
	"B\x02%.2[1]f KiB\x02%.2[1]f MiB\x02%.2[1]f GiB\x02%.2[1]f TiB\x02%[1]s: " +
	"%[2]q\x02Alamat IP tidak valid\x02Network prefix tidak valid\x02Port bel" +
	"um terisi dari endpoint\x02Host endpoint tidak valid\x02Dalam Kurung har" +
	"us berisi alamat IPv6\x02MTU tidak valid\x02Port tidak valid\x02Persiste" +
	"nt keepalive tidak valid\x02Kunci tidak sah:%[1]v\x02Kunci harus diterje" +
	"mahkan tepat 32 byte\x02Nomor harus diantara 0 sampai dengan 2^64-1:%[1]" +
	"v\x02Dua koma dalam satu baris\x02Nama Tunnel tidak valid\x02Garis harus" +
	" muncul perbagian\x02Kunci harus memiliki value\x02Kunci tidak valid pad" +
	"a bagian [Interface]\x02Kunci tidak valid pada bagian [Peer]\x02Interfac" +
	"e harus memiliki Private Key\x02Tidak Ditetapkan\x02Semua peers harus me" +
	"miliki kunci publik\x02Eror ketika mendapatkan konfigurasi\x02Kunci tida" +
	"k valid pada bagian [Interface]\x02Versi protokol harus 1\x02Kunci tidak" +
	" valid pada bagian [Peer]\x02, \x02Tentang WireGuard\x02Tutup\x02♥ &Dona" +
	"si!\x02Status:\x02Aktif\x02Mengaktifkan\x02Nonaktif\x02Menonaktifkan\x02" +
	"Status tidak diketahui\x02Catatan\x02Salin\x02Pilih semua\x02Menyimpan k" +
	"e dalam berkas…\x02Waktu\x02Pesan log\x02Berkas Txt (*.Txt)|*.Txt|Semua " +
	"berkas (*.*)|*.*\x02Ekspor log kedalam file\x02&Tentang WireGuard…\x02Tu" +
	"nnel eror\x02%[1]s\x0a\x0aSilakan baca log untuk informasi lebih lanjut." +
	"\x02%[1]s (kadaluarsa)\x02Deteksi eror WireGuard\x02Tidak dapat menunggu" +
	" jendela WireGuard muncul: %[1]v\x02WireGuard: Dinonaktifkan\x02Status: " +
	"Tidak diketahui\x02Alamat: Kosong\x02&Manajer Tunnel…\x02&Impor tunnel d" +
	"ari file…\x02&Keluar\x02Wireguard Tunnel Eror\x02WireGuard: %[1]s\x02Sta" +
	"tus: %[1]s\x02Ekspor semua tunnel ke &zip…\x02Ubah tunnel &terpilih…\x02" +
	"&Hapus tunnel terpilih\x02Tidak dapat mengimpor konfigurasi yang dipilih" +
	": %[1]v"

var itIndex = []uint32{ // 181 elements
	// Entry 0 - 1F
	0x00000000, 0x00000007, 0x00000044, 0x0000005d,
	0x00000075, 0x000000bd, 0x000000bd, 0x000000f6,
	0x0000014d, 0x000001be, 0x00000212, 0x00000216,
	0x0000023d, 0x0000025c, 0x0000027f, 0x0000029c,
	0x000002bf, 0x000002e4, 0x000002ed, 0x000002f6,
	0x00000303, 0x00000310, 0x0000031d, 0x0000032a,
	0x00000337, 0x0000034f, 0x00000379, 0x00000396,
	0x000003b4, 0x000003e4, 0x000003f3, 0x00000404,
	// Entry 20 - 3F
	0x00000424, 0x0000043d, 0x0000046f, 0x000004ae,
	0x000004c6, 0x000004e7, 0x00000514, 0x00000514,
	0x00000533, 0x00000560, 0x00000588, 0x000005b5,
	0x000005c7, 0x000005f5, 0x00000625, 0x00000657,
	0x00000680, 0x000006a6, 0x000006a9, 0x000006ab,
	0x000006c5, 0x000006e4, 0x000006e4, 0x000006eb,
	0x00000703, 0x0000070a, 0x00000715, 0x0000071d,
	0x0000072e, 0x00000740, 0x00000745, 0x00000750,
	// Entry 40 - 5F
	0x0000075c, 0x0000075c, 0x00000772, 0x00000781,
	0x0000078b, 0x000007a1, 0x000007b6, 0x000007c5,
	0x000007c5, 0x000007cf, 0x000007ed, 0x00000820,
	0x00000844, 0x0000086b, 0x0000087e, 0x00000883,
	0x0000088f, 0x0000089f, 0x000008a6, 0x000008b8,
	0x000008c6, 0x000008f6, 0x000008f6, 0x000008fd,
	0x00000905, 0x00000916, 0x00000926, 0x0000093c,
	0x0000096a, 0x00000992, 0x000009a8, 0x000009dd,
	// Entry 60 - 7F
	0x00000a08, 0x00000a28, 0x00000a5f, 0x00000a66,
	0x00000a72, 0x00000a7b, 0x00000a8a, 0x00000a9c,
	0x00000aa0, 0x00000aa7, 0x00000ab8, 0x00000aca,
	0x00000ad0, 0x00000ae1, 0x00000b14, 0x00000b28,
	0x00000b46, 0x00000b58, 0x00000b8b, 0x00000b9c,
	0x00000bbf, 0x00000c04, 0x00000c1b, 0x00000c2e,
	0x00000c41, 0x00000c57, 0x00000c72, 0x00000c78,
	0x00000c8b, 0x00000cae, 0x00000cc4, 0x00000cea,
	// Entry 80 - 9F
	0x00000d05, 0x00000d16, 0x00000d23, 0x00000d23,
	0x00000d44, 0x00000d6b, 0x00000dca, 0x00000dd1,
	0x00000ddb, 0x00000df2, 0x00000e02, 0x00000e1d,
	0x00000e3b, 0x00000e44, 0x00000e63, 0x00000e86,
	0x00000ea4, 0x00000ea4, 0x00000edf, 0x00000f0f,
	0x00000f43, 0x00000f72, 0x00000f83, 0x00000fba,
	0x00001002, 0x0000101f, 0x00001052, 0x000010b3,
	0x000010ce, 0x00001103, 0x00001133, 0x00001153,
	// Entry A0 - BF
	0x00001185, 0x000011a4, 0x0000120b, 0x00001256,
	0x0000126d, 0x00001296, 0x000012ac, 0x000012df,
	0x00001307, 0x00001379, 0x000013de, 0x000013fb,
	0x00001408, 0x00001437, 0x00001454, 0x00001465,
	0x00001465, 0x00001465, 0x00001465, 0x00001465,
	0x00001465,
} // Size: 748 bytes

const itData string = "" + // Size: 5221 bytes
	"\x02Errore\x02(nessun argomento): eleva e installa il servizio di gestio" +
	"ne\x02Utilizzo: %[1]s [\x0a%[2]s]\x02Opzioni riga di comando\x02Impossib" +
	"ile determinare se il processo è in esecuzione in WOW64: %[1]v\x02Imposs" +
	"ibile aprire il token del processo corrente: %[1]v\x02WireGuard può esse" +
	"re utilizzato solo dagli utenti membri del gruppo %[1]s di sistema.\x02W" +
	"ireGuard è in esecuzione, ma l'interfaccia utente è accessibile solo dai" +
	" desktop del gruppo %[1]s di sistema.\x02L'icona della barra delle appli" +
	"cazioni di WireGuard non è apparsa dopo 30 secondi.\x02Ora\x02L'orologio" +
	" di sistema va all'indietro!\x14\x01\x81\x01\x00\x02\x0b\x02%[1]d anno" +
	"\x00\x0b\x02%[1]d anni\x14\x01\x81\x01\x00\x02\x0d\x02%[1]d giorno\x00" +
	"\x0d\x02%[1]d giorni\x14\x01\x81\x01\x00\x02\x0a\x02%[1]d ora\x00\x0a" +
	"\x02%[1]d ore\x14\x01\x81\x01\x00\x02\x0d\x02%[1]d minuto\x00\x0d\x02%[1" +
	"]d minuti\x14\x01\x81\x01\x00\x02\x0e\x02%[1]d secondo\x00\x0e\x02%[1]d " +
	"secondi\x02%[1]s fa\x02%[1]d\u00a0B\x02%.2[1]f\u00a0KiB\x02%.2[1]f\u00a0" +
	"MiB\x02%.2[1]f\u00a0GiB\x02%.2[1]f\u00a0TiB\x02%[1]s: %[2]q\x02Indirizzo" +
	" IP non valido\x02Lunghezza del prefisso di rete non valida\x02Manca la " +
	"porta dall'endpoint\x02Host dell'endpoint non valido\x02Le parentesi dev" +
	"ono contenere un indirizzo IPv6\x02MTU non valido\x02Porta non valida" +
	"\x02Keepalive permanente non valido\x02Chiave non valida: %[1]v\x02Le ch" +
	"iavi devono decodificare esattamente 32 byte\x02Il numero deve essere un" +
	" numero compreso tra 0 e 2^64-1: %[1]v\x02Due virgole in una riga\x02Il " +
	"nome del tunnel non è valido\x02Una riga deve essere presente in una sez" +
	"ione\x02La chiave deve avere un valore\x02Chiave non valida per la sezio" +
	"ne [Interface]\x02Chiave non valida per la sezione [Peer]\x02Un'interfac" +
	"cia deve avere una chiave privata\x02[non specificato]\x02Tutti i peer d" +
	"evono avere una chiave pubblica\x02Errore durante il recupero della conf" +
	"igurazione\x02Chiave non valida per la sezione dell'interfaccia\x02La ve" +
	"rsione del protocollo deve essere 1\x02Chiave non valida per la sezione " +
	"peer\x02, \x02 \x02Informazioni su WireGuard\x02Immagine del logo di Wir" +
	"eGuard\x02Chiudi\x02♥ Fai una &donazione!\x02Stato:\x02&Disattiva\x02&At" +
	"tiva\x02Chiave pubblica:\x02Porta in ascolto:\x02MTU:\x02Indirizzi:\x02S" +
	"erver DNS:\x02Chiave pre-condivisa:\x02IP consentiti:\x02Endpoint:\x02Ke" +
	"epalive permanente:\x02Ultima negoziazione:\x02Trasferimento:\x02abilita" +
	"to\x02%[1]s ricevuti, %[2]s inviati\x02Determinazione dello stato del tu" +
	"nnel non riuscita\x02Attivazione del tunnel non riuscita\x02Disattivazio" +
	"ne del tunnel non riuscita\x02Interfaccia: %[1]s\x02Peer\x02Crea tunnel" +
	"\x02Modifica tunnel\x02&Nome:\x02Chiave &pubblica:\x02(sconosciuto)\x02&" +
	"Blocca traffico fuori dal tunnel (kill-switch)\x02&Salva\x02Annulla\x02&" +
	"Configurazione:\x02Nome non valido\x02Un nome è richiesto.\x02Il nome de" +
	"l tunnel ‘%[1]s’ non è valido.\x02Impossibile elencare i tunnel esistent" +
	"i\x02Il tunnel esiste già\x02Un altro tunnel con il nome ‘%[1]s’ esiste " +
	"già.\x02Impossibile creare la nuova configurazione\x02Scrittura del file" +
	" non riuscita\x02Il file ‘%[1]s’ esiste già.\x0a\x0aVuoi sovrascriverlo?" +
	"\x02Attivo\x02Attivazione\x02Inattivo\x02Disattivazione\x02Stato sconosc" +
	"iuto\x02Log\x02&Copia\x02Selezion&a tutto\x02&Salva su file…\x02Tempo" +
	"\x02Messaggio di log\x02File di testo (*.txt)|*.txt|Tutti i file (*.*)|*" +
	".*\x02Esporta log su file\x02Inform&azioni su WireGuard…\x02Errore del t" +
	"unnel\x02%[1]s\x0a\x0aConsulta il log per ulteriori Informazioni.\x02%[1" +
	"]s (obsoleto)\x02Errore di rilevamento di WireGuard\x02Impossibile atten" +
	"dere la comparsa della finestra di WireGuard: %[1]v\x02WireGuard: disatt" +
	"ivato\x02Stato: sconosciuto\x02Indirizzi: nessuno\x02&Gestisci i tunnel…" +
	"\x02&Importa tunnel da file…\x02E&sci\x02WireGuard attivato\x02Il tunnel" +
	" %[1]s è stato attivato.\x02WireGuard disattivato\x02Il tunnel %[1]s è s" +
	"tato disattivato.\x02Errore tunnel di WireGuard\x02WireGuard: %[1]s\x02S" +
	"tato: %[1]s\x02Un aggiornamento è disponibile!\x02Aggiornamento di WireG" +
	"uard disponibile\x02Un aggiornamento di WireGuard è disponibile. Ti cons" +
	"igliamo di aggiornare il prima possibile.\x02Tunnel\x02&Modifica\x02Aggi" +
	"ungi tunn&el vuoto\x02Aggiungi tunnel\x02Rimuovi tunnel selezionati\x02E" +
	"sporta tutti i tunnel in zip\x02Commu&ta\x02Esporta tutti i tunnel in &z" +
	"ip\x02Modifica il tunnel &selezionato…\x02&Rimuovi i tunnel selezionati" +
	"\x02Impossibile importare la configurazione selezionata: %[1]v\x02Imposs" +
	"ibile enumerare i tunnel esistenti: %[1]v\x02Un altro tunnel esiste già " +
	"con il nome ‘%[1]s‘\x02Impossibile importare la configurazione: %[1]v" +
	"\x02Tunnel importati\x14\x01\x81\x01\x00\x02\x17\x02%[1]d tunnel importa" +
	"to\x00\x17\x02%[1]d tunnel importati\x14\x02\x80\x01\x02 \x02%[1]d de %[" +
	"2]d tunnel importato\x00 \x02%[1]d di %[2]d tunnel importati\x02Impossib" +
	"ile creare il tunnel\x14\x01\x81\x01\x00\x02\x15\x02Elimina %[1]d tunnel" +
	"\x00\x15\x02Elimina %[1]d tunnel\x14\x01\x81\x01\x00\x02,\x02Sei sicuro " +
	"di voler eliminare %[1]d tunnel?\x00,\x02Sei sicuro di voler eliminare %" +
	"[1]d tunnel?\x02Elimina tunnel ‘%[1]s‘\x02Sei sicuro di voler eliminare " +
	"il tunnel ‘%[1]s‘?\x02%[1]s Non è possibile annullare questa azione.\x02" +
	"Impossibile eliminare il tunnel\x02Non è stato possibile rimuovere un tu" +
	"nnel: %[1]s\x02Impossibile eliminare i tunnel\x14\x01\x81\x01\x00\x02/" +
	"\x02Non è stato possibile eliminare %[1]d tunnel.\x00/\x02Non è stato po" +
	"ssibile eliminare %[1]d tunnel.\x02File di configurazione (*.zip, *.conf" +
	")|*.zip;*.conf|Tutti i file (*.*)|*.*\x02Importa tunnel da file\x02File " +
	"di configurazione ZIP (*.zip)|*.zip\x02Esporta tunnel in zip\x02%[1]s (v" +
	"ersione non firmata, nessun aggiornamento)\x02Errore durante la chiusura" +
	" di WireGuard\x02Impossibile uscire dal servizio a causa di: %[1]v. Potr" +
	"esti voler interrompere WireGuard dal gestore dei servizi.\x02Un aggiorn" +
	"amento di WireGuard è disponibile. Ti consigliamo vivamente di aggiornar" +
	"e immediatamente.\x02Stato: in attesa dell'utente\x02Aggiorna ora\x02Sta" +
	"to: in attesa del servizio di aggiornamento\x02Errore: %[1]v. Prova anco" +
	"ra.\x02Stato: Completo!"

var jaIndex = []uint32{ // 181 elements
	// Entry 0 - 1F
	0x00000000, 0x0000000a, 0x0000005b, 0x00000075,
	0x0000009a, 0x000000e6, 0x000000e6, 0x00000124,
	0x0000017b, 0x000001fe, 0x00000253, 0x00000257,
	0x0000027f, 0x00000290, 0x000002a1, 0x000002b5,
	0x000002c6, 0x000002d7, 0x000002e1, 0x000002e9,
	0x000002f6, 0x00000303, 0x00000310, 0x0000031d,
	0x0000032a, 0x00000344, 0x00000378, 0x000003a6,
	0x000003ce, 0x000003ff, 0x0000040d, 0x00000426,
	// Entry 20 - 3F
	0x00000451, 0x00000465, 0x00000497, 0x000004ea,
	0x0000050e, 0x0000052d, 0x00000558, 0x0000058f,
	0x000005c0, 0x000005f5, 0x00000625, 0x0000065c,
	0x0000066b, 0x0000069c, 0x000006d0, 0x00000703,
	0x00000746, 0x00000774, 0x00000777, 0x00000779,
	0x00000790, 0x000007a7, 0x000007a7, 0x000007b1,
	0x000007cd, 0x000007d5, 0x000007e3, 0x000007f1,
	0x000007fc, 0x00000813, 0x00000818, 0x00000826,
	// Entry 40 - 5F
	0x00000835, 0x00000835, 0x00000846, 0x00000853,
	0x0000086a, 0x0000088a, 0x000008aa, 0x000008b2,
	0x000008b2, 0x000008b9, 0x000008e1, 0x00000912,
	0x00000940, 0x0000096e, 0x0000098e, 0x00000995,
	0x000009b1, 0x000009c7, 0x000009d3, 0x000009e2,
	0x000009eb, 0x00000a44, 0x00000a44, 0x00000a4f,
	0x00000a5f, 0x00000a6b, 0x00000a7b, 0x00000a94,
	0x00000ac3, 0x00000af1, 0x00000b19, 0x00000b68,
	// Entry 60 - 7F
	0x00000b99, 0x00000bbe, 0x00000c10, 0x00000c17,
	0x00000c24, 0x00000c2b, 0x00000c38, 0x00000c48,
	0x00000c4f, 0x00000c5d, 0x00000c71, 0x00000c8e,
	0x00000c95, 0x00000cac, 0x00000cf6, 0x00000d21,
	0x00000d3e, 0x00000d54, 0x00000d89, 0x00000d9e,
	0x00000db8, 0x00000dfa, 0x00000e15, 0x00000e24,
	0x00000e39, 0x00000e56, 0x00000e8e, 0x00000e99,
	0x00000eb3, 0x00000ee5, 0x00000eff, 0x00000f31,
	// Entry 80 - 9F
	0x00000f51, 0x00000f62, 0x00000f70, 0x00000f70,
	0x00000f8f, 0x00000fb8, 0x00001020, 0x0000102d,
	0x00001038, 0x0000105b, 0x00001071, 0x00001093,
	0x000010c7, 0x000010d8, 0x00001113, 0x0000113c,
	0x00001162, 0x00001162, 0x000011af, 0x000011ed,
	0x00001239, 0x00001271, 0x00001296, 0x000012ce,
	0x00001312, 0x00001337, 0x0000135a, 0x00001396,
	0x000013b9, 0x000013f4, 0x00001425, 0x0000144a,
	// Entry A0 - BF
	0x0000147f, 0x000014a4, 0x000014df, 0x00001532,
	0x00001563, 0x0000158d, 0x000015b5, 0x000015eb,
	0x00001605, 0x00001689, 0x000016ee, 0x00001718,
	0x00001728, 0x0000175b, 0x00001790, 0x000017a2,
	0x000017a2, 0x000017a2, 0x000017a2, 0x000017a2,
	0x000017a2,
} // Size: 748 bytes

const jaData string = "" + // Size: 6050 bytes
	"\x02エラー\x02(引数なし): 管理者権限でmanagerサービスをインストールする\x02使い方: %[1]s [\x0a%[2]s]" +
	"\x02コマンドラインオプション\x02プロセスがWOW64下で動作しているか確認できません: %[1]v\x02現在のプロセスのトークンを開け" +
	"ません: %[1]v\x02WireGuard は組み込みの %[1]s グループのメンバーだけが使えます。\x02WireGuard は実" +
	"行中ですが、UI画面は組み込みの %[1]s グループのデスクトップからしか開けません。\x02WireGuard システムトレイアイコンは" +
	"30秒後に非表示になります。\x02今\x02システム時刻が巻き戻った！\x14\x01\x81\x01\x00\x00\x0a\x02%[1]" +
	"d 年\x14\x01\x81\x01\x00\x00\x0a\x02%[1]d 日\x14\x01\x81\x01\x00\x00\x0d" +
	"\x02%[1]d 時間\x14\x01\x81\x01\x00\x00\x0a\x02%[1]d 分\x14\x01\x81\x01\x00" +
	"\x00\x0a\x02%[1]d 秒\x02%[1]s 前\x02%[1]d B\x02%.2[1]f\u00a0KiB\x02%.2[1]f" +
	"\u00a0MiB\x02%.2[1]f\u00a0GiB\x02%.2[1]f\u00a0TiB\x02%[1]s: %[2]q\x02無効な" +
	" IP アドレス\x02無効なネットワークプレフィックス長\x02エンドポイントのポート指定なし\x02無効なエンドポイントホスト\x02カッコ" +
	"内は IPv6 アドレスが入ります\x02無効な MTU\x02無効なポート番号\x02無効な持続的キープアライブ値\x02不正な鍵: %[" +
	"1]v\x02鍵は 32 バイトでなければなりません\x02数値は0から2の64乗-1の範囲内の値でなければなりません: %[1]v\x021行" +
	"にカンマが2つあります\x02トンネル名が不正です\x02行がセクション内にありません\x02設定項目にイコール(=)セパレータがない" +
	"\x02キー項目に対応する値がありません\x02無効な [Interface] セクションのキー項目\x02無効な [Peer] セクションのキ" +
	"ー項目\x02インターフェースには秘密鍵が必須です\x02[指定なし]\x02すべてのピアには公開鍵が必須です\x02設定の読込中にエラーが" +
	"発生しました\x02無効な Interface セクションのキー項目\x02プロトコルバージョンは 1 でなければなりません\x02無効な " +
	"Peer セクションのキー項目\x02, \x02 \x02WireGuard について\x02WireGuard ロゴ画像\x02閉じる" +
	"\x02♥ 寄付のお願い!(&D)\x02状態:\x02無効化(&D)\x02有効化(&A)\x02公開鍵:\x02待受ポート番号:\x02MT" +
	"U:\x02アドレス:\x02DNS サーバ:\x02事前共有鍵:\x02Allowed IPs:\x02エンドポイント:\x02持続的キープア" +
	"ライブ:\x02直近のハンドシェイク:\x02転送:\x02有効\x02%[1]s 受信済み、%[2]s 送信済み\x02トンネルの状態取得" +
	"に失敗しました\x02トンネルの有効化に失敗しました\x02トンネルの無効化に失敗しました\x02インターフェース: %[1]s\x02ピア" +
	"\x02トンネルの新規作成\x02トンネルの編集\x02名前(&N):\x02公開鍵(&P):\x02(不明)\x02トンネルを通らないトラフィ" +
	"ックのブロック（キルスイッチ）(&B)\x02保存(&S)\x02キャンセル\x02設定(&C):\x02無効な名前\x02名前は必須です。" +
	"\x02トンネル名 ‘%[1]s’ は不正です。\x02既存のトンネルを表示できません\x02トンネルはすでに存在します\x02‘%[1]s’ " +
	"という名前の別のトンネルがすでに存在します。\x02新しい設定を作成できませんでした\x02ファイルの書き込みに失敗\x02ファイル ‘%[" +
	"1]s’ はすでに存在します。\x0a\x0a上書きしますか？\x02有効\x02有効化中\x02無効\x02無効化中\x02不明な状態\x02" +
	"ログ\x02コピー(&C)\x02すべて選択(&A)\x02ファイルに保存…(&S)\x02時刻\x02ログ メッセージ\x02テキストファ" +
	"イル (*.txt)|*.txt|すべてのファイル (*.*)|*.*\x02ログをファイルにエクスポート\x02WireGuardについて" +
	"…(&A)\x02トンネルエラー\x02%[1]s\x0a\x0a詳細はログを参照してください。\x02%[1]s (更新あり)\x02Wi" +
	"reGuard 検出エラー\x02WireGuard ウィンドウが表示できませんでした: %[1]v\x02WireGuard: 無効化済み" +
	"\x02状態: 不明\x02アドレス: なし\x02トンネルの管理…(&M)\x02トンネルをファイルからインポート…(&I)\x02終了(&X" +
	")\x02WireGuard 有効化済み\x02トンネル %[1]s は有効になりました。\x02WireGuard 無効化済み\x02トンネル" +
	" %[1]s は無効になりました。\x02WireGuard トンネルエラー\x02WireGuard: %[1]s\x02状態: %[1]s" +
	"\x02更新が利用できます！\x02WireGuard の更新が利用可能です\x02WireGuard の更新が利用可能になりました。できるだけ" +
	"早く更新してください。\x02トンネル\x02編集(&E)\x02空のトンネルを追加…(&E)\x02トンネルの追加\x02選択したトンネル" +
	"の削除\x02すべてのトンネルをzipにエクスポート\x02切り替え(&T)\x02すべてのトンネルをzipにエクスポート…(&Z)\x02" +
	"選択したトンネルの編集…(&S)\x02選択したトンネルの削除(&R)\x02選択したファイルからインポートできませんでした: %[1]v" +
	"\x02既存のトンネルを表示できませんでした: %[1]v\x02‘%[1]s’ という名前の別のトンネルがすでに存在します\x02設定をインポ" +
	"ートできませんでした: %[1]v\x02トンネルのインポート結果\x14\x01\x81\x01\x00\x001\x02%[1]d トン" +
	"ネルをインポートしました\x14\x02\x80\x01\x00>\x02%[2]d 中の %[1]d トンネルをインポートしました\x02" +
	"トンネルを作成できません\x14\x01\x81\x01\x00\x00\x1c\x02%[1]d トンネルを削除\x14\x01\x81" +
	"\x01\x00\x005\x02本当に %[1]d トンネルを削除しますか？\x02トンネル ‘%[1]s’ を削除\x02本当にトンネル ‘" +
	"%[1]s’ を削除しますか？\x02%[1]s この操作はもとに戻せません。\x02トンネルを削除できません\x02トンネルを削除できませんで" +
	"した: %[1]s\x02トンネルを削除できません\x14\x01\x81\x01\x00\x004\x02%[1]d トンネルを削除できま" +
	"せんでした\x02設定ファイル (*.zip, *.conf)|*.zip;*.conf|すべてのファイル (*.*)|*.*\x02ファイ" +
	"ルからトンネルをインポート\x02ZIP形式設定ファイル (*.zip)|*.zip\x02トンネルをZIPにエクスポート\x02%[1]s" +
	" (未署名のビルド、更新の提供なし)\x02WireGuard 終了エラー\x02%[1]v のためサービスを終了できませんでした。サービスマネ" +
	"ージャから WireGuard を停止できます。\x02WireGuard の更新が利用可能です。速やかに更新することを強く推奨します。" +
	"\x02状態: ユーザーからの応答待ち\x02今すぐ更新\x02状態: アップデータサービスを待機中\x02エラー: %[1]v。再度実行してく" +
	"ださい。\x02状態: 完了！"

var pa_INIndex = []uint32{ // 181 elements
	// Entry 0 - 1F
	0x00000000, 0x00000010, 0x00000010, 0x00000030,
	0x0000005d, 0x000000ea, 0x0000017f, 0x000001e6,
	0x000002b4, 0x0000039c, 0x0000042d, 0x00000437,
	0x00000479, 0x000004a2, 0x000004cb, 0x000004fa,
	0x00000529, 0x0000055e, 0x00000577, 0x00000580,
	0x0000058d, 0x0000059a, 0x000005a7, 0x000005b4,
	0x000005c1, 0x000005ea, 0x0000062a, 0x00000671,
	0x00000671, 0x00000671, 0x0000068f, 0x000006b6,
	// Entry 20 - 3F
	0x000006e5, 0x000006e5, 0x000006e5, 0x000006e5,
	0x000006e5, 0x000006e5, 0x000006e5, 0x000006e5,
	0x000006e5, 0x000006e5, 0x000006e5, 0x000006e5,
	0x000006e5, 0x000006e5, 0x000006e5, 0x000006e5,
	0x000006e5, 0x000006e5, 0x000006e8, 0x000006eb,
	0x00000711, 0x00000711, 0x000007d7, 0x000007eb,
	0x00000808, 0x00000819, 0x0000083e, 0x0000085c,
	0x0000087d, 0x000008a5, 0x000008aa, 0x000008c1,
	// Entry 40 - 5F
	0x000008d3, 0x000008f0, 0x000008f0, 0x00000911,
	0x0000092f, 0x0000092f, 0x0000092f, 0x00000946,
	0x00000946, 0x0000095d, 0x00000984, 0x000009cf,
	0x00000a11, 0x00000a5a, 0x00000a77, 0x00000a84,
	0x00000aa8, 0x00000ac9, 0x00000ad8, 0x00000afd,
	0x00000b15, 0x00000b15, 0x00000b15, 0x00000b2c,
	0x00000b40, 0x00000b58, 0x00000b6f, 0x00000b96,
	0x00000b96, 0x00000b96, 0x00000bd1, 0x00000c2f,
	// Entry 60 - 7F
	0x00000c80, 0x00000cbe, 0x00000d68, 0x00000d78,
	0x00000db0, 0x00000dc7, 0x00000e06, 0x00000e2c,
	0x00000e39, 0x00000e54, 0x00000e72, 0x00000ea9,
	0x00000eb6, 0x00000ed3, 0x00000f37, 0x00000f78,
	0x00000fa5, 0x00000fbc, 0x00000ff0, 0x00001004,
	0x00001028, 0x00001028, 0x00001066, 0x0000108d,
	0x000010be, 0x000010f9, 0x00001144, 0x00001155,
	0x0000118b, 0x000011c9, 0x00001206, 0x0000124b,
	// Entry 80 - 9F
	0x0000127b, 0x0000129b, 0x000012b2, 0x000012d2,
	0x000012fd, 0x00001340, 0x00001436, 0x00001446,
	0x00001457, 0x00001482, 0x00001499, 0x000014d3,
	0x00001534, 0x00001545, 0x000015a9, 0x000015d4,
	0x00001612, 0x00001665, 0x00001665, 0x00001665,
	0x00001665, 0x00001665, 0x0000169b, 0x0000169b,
	0x0000169b, 0x000016cf, 0x000016cf, 0x000017a2,
	0x000017cf, 0x00001837, 0x00001837, 0x0000186b,
	// Entry A0 - BF
	0x0000186b, 0x0000186b, 0x0000186b, 0x000018e4,
	0x00001928, 0x00001969, 0x00001969, 0x00001969,
	0x00001969, 0x00001969, 0x00001969, 0x00001969,
	0x00001993, 0x00001993, 0x00001993, 0x000019b2,
	0x000019b2, 0x000019b2, 0x000019b2, 0x000019b2,
	0x000019c0,
} // Size: 748 bytes

const pa_INData string = "" + // Size: 6592 bytes
	"\x02ਗ਼ਲਤੀ\x02ਵਰਤੋਂ: %[1]s [\x0a%[2]s]\x02ਕਮਾਂਡ ਲਾਈਨ ਚੋਣਾਂ\x02ਪਤਾ ਲਗਾਉਣ ਲ" +
	"ਈ ਅਸਮਰੱਥ ਹੈ ਕਿ ਪਰੋਸੈਸ WOW64 ਅਧੀਨ ਚੱਲ ਰਿਹਾ ਹੈ: %[1]v\x02ਤੁਹਾਨੂੰ ਇਸ ਕੰਪਿ" +
	"ਊਟਰ ਉੱਤੇ WireGuard ਦਾ ਮੂਲ ਵਰਜ਼ਨ ਵਰਤਣਾ ਚਾਹੀਦਾ ਹੈ।\x02ਮੌਜੂਦਾ ਪਰੋਸੈਸ ਟੋਕਨ " +
	"ਖੋਲ੍ਹਣ ਲਈ ਅਸਮਰੱਥ: %[1]v\x02WireGuard ਨੂੰ ਸਿਰਫ਼ ਉਹੀ ਵਰਤੋਂਕਾਰ ਵਰਤ ਸਕਦੇ ਹ" +
	"ਨ, ਜੋ ਕਿ ਪਹਿਲਾਂ ਮੌਜੂਦ %[1]s ਗਰੁੱਪ ਦੇ ਮੈਂਬਰ ਹਨ।\x02WireGuard ਚੱਲ ਰਿਹਾ ਹ" +
	"ੈ, ਪਰ UI ਨੂੰ ਸਿਰਫ਼ ਪਹਿਲਾਂ ਮੌਜੂਦ %[1]s ਗਰੁੱਪ ਦੇ ਡੈਸਕਟਾਪ ਰਾਹੀਂ ਹੀ ਵਰਤਿਆ " +
	"ਜਾ ਸਕਦਾ ਹੈ।\x02WireGuard ਸਿਸਟਮ ਟਰੇ ਆਈਕਾਨ 30 ਸਕਿੰਟਾਂ ਬਾਅਦ ਦਿਖਾਈ ਨਹੀਂ ਦਿ" +
	"ੱਤਾ ਹੈ।\x02ਹੁਣ\x02ਸਿਸਟਮ ਘੜੀ ਪੁ਼ੱਠੀ ਮੋੜੀ ਗਈ!\x14\x01\x81\x01\x00\x02" +
	"\x10\x02%[1]d ਸਾਲ\x00\x10\x02%[1]d ਸਾਲ\x14\x01\x81\x01\x00\x02\x10\x02%[" +
	"1]d ਦਿਨ\x00\x10\x02%[1]d ਦਿਨ\x14\x01\x81\x01\x00\x02\x13\x02%[1]d ਘੰਟਾ" +
	"\x00\x13\x02%[1]d ਘੰਟੇ\x14\x01\x81\x01\x00\x02\x13\x02%[1]d ਮਿੰਟ\x00\x13" +
	"\x02%[1]d ਮਿੰਟ\x14\x01\x81\x01\x00\x02\x16\x02%[1]d ਸਕਿੰਟ\x00\x16\x02%[1" +
	"]d ਸਕਿੰਟ\x02%[1]s ਪਹਿਲਾਂ\x02%[1]d\u00a0B\x02%.2[1]f\u00a0KiB\x02%.2[1]f" +
	"\u00a0MiB\x02%.2[1]f\u00a0GiB\x02%.2[1]f\u00a0TiB\x02%[1]s: %[2]q\x02ਅਵੈ" +
	"ਧ IP ਸਿਰਨਾਵਾਂ\x02ਗਲਤ ਨੈੱਟਵਰਕ ਅਗੇਤਰ ਲੰਬਾਈ\x02ਐਂਡਪੁਆਇੰਟ ਤੋਂ ਪੋਰਟ ਗੁੰਮ ਹੈ" +
	"\x02ਗ਼ੈਰ-ਵਾਜਬ MTU\x02ਗ਼ੈਰ-ਵਾਜਬ ਪੋਰਟ\x02ਗ਼ੈਰ-ਵਾਜਬ persistent keepalive" +
	"\x02, \x02, \x02ਵਾਇਰਗਾਰਡ ਬਾਰੇ\x02ਐਪ ਦਾ ਵਰਜ਼ਨ: %[1]s\x0aਗੋ ਬੈਕਐਂਡ ਦਾ ਵਰਜ਼ਨ:" +
	" %[2]s\x0aਗੋ ਦਾ ਵਰਜ਼ਨ: %[3]s-%[4]s\x0aਓਪਰੇਟਿੰਗ ਸਿਸਟਮ: %[5]s\x0aਢਾਂਚਾ: %[6" +
	"]s\x02ਬੰਦ ਕਰੋ\x02♥ ਦਾਨ ਦਿਓ(&D)!\x02ਸਥਿਤੀ:\x02ਨਾ-ਸਰਗਰਮ ਕਰੋ(&D)\x02ਸਰਗਰਮ ਕ" +
	"ਰੋ(&A)\x02ਪਬਲਿਕ ਕੁੰਜੀ:\x02ਸੁਣਨ ਵਾਲੀ ਪੋਰਟ:\x02MTU:\x02ਸਿਰਨਾਵੇ:\x02DNS ਸ" +
	"ਰਵਰ:\x02ਸਕ੍ਰਿਪਟਾਂ:\x02ਮਨਜ਼ੂਰ ਕੀਤੇ IP:\x02ਐਂਡ-ਪੁਆਇੰਟ:\x02ਟਰਾਂਸਫਰ:\x02ਸਮਰ" +
	"ੱਥ ਹੈ\x02%[1]s ਮਿਲੇ, %[2]s ਭੇਜੇ\x02ਟਨਲ ਸਥਿਤੀ ਪਤਾ ਲਗਾਉਣ ਲਈ ਅਸਫ਼ਲ\x02ਟਨਲ" +
	" ਸਰਗਰਮ ਕਰਨ ਲਈ ਅਸਫ਼ਲ ਹੈ\x02ਟਨਲ ਨਾ-ਸਰਗਰਮ ਕਰਨ ਲਈ ਅਸਫ਼ਲ ਹੈ\x02ਇੰਟਰਫੇਸ: %[1]s" +
	"\x02ਪੀਅਰ\x02ਨਵੀਂ ਟਨਲ ਬਣਾਓ\x02ਟਨਲ ਨੂੰ ਸੋਧੋ\x02ਨਾਂ(&N):\x02ਪਬਲਿਕ ਕੁੰਜੀ(&P)" +
	":\x02(ਅਣਪਛਾਤਾ)\x02ਸੰਭਾਲੋ(&S)\x02ਰੱਦ ਕਰੋ\x02ਸੰਰਚਨਾ(&C):\x02ਅਯੋਗ ਨਾਂ\x02ਨਾ" +
	"ਂ ਚਾਹੀਦਾ ਹੈ।\x02ਟਨਲ ਪਹਿਲਾਂ ਹੀ ਮੌਜੂਦ ਹੈ\x02ਨਾਂ ‘%[1]s’ ਨਾਲ ਟਨਲ ਪਹਿਲਾਂ ਹ" +
	"ੀ ਮੌਜੂਦ ਹੈ।\x02ਨਵੀਂ ਸੰਰਚਨਾ ਬਣਾਉਣ ਲਈ ਅਸਮਰੱਥ ਹੈ\x02ਫ਼ਾਇਲ ਬਣਾਉਣ ਲਈ ਅਸਫ਼ਲ " +
	"ਹੈ\x02‘%[1]s’ ਫ਼ਾਇਲ ਪਹਿਲਾਂ ਹੀ ਮੌਜੂਦ ਹੈ।\x0a\x0aਕੀ ਤੁਸੀਂ ਇਸ ਉੱਤੇ ਲਿਖਣਾ " +
	"ਚਾਹੁੰਦੇ ਹੋ?\x02ਸਰਗਰਮ\x02ਸਰਗਰਮ ਕੀਤਾ ਜਾ ਰਿਹਾ ਹੈ\x02ਨਾ-ਸਰਗਰਮ\x02ਨਾ-ਸਰਗਰਮ " +
	"ਕੀਤਾ ਜਾ ਰਿਹਾ ਹੈ\x02ਅਣਪਛਾਤੀ ਸਥਿਤੀ\x02ਲਾਗੂ\x02ਕਾਪੀ ਕਰੋ(&C)\x02ਸਾਰੇ ਚੁਣੋ(" +
	"&a)\x02ਫ਼ਾਇਲ ਵਿੱਚ ਸੰਭਾਲੋ(&S)…\x02ਸਮਾਂ\x02ਲਾਗ ਸੁਨੇਹਾ\x02ਲਿਖਤ ਫ਼ਾਇਲਾਂ (*.t" +
	"xt)|*.txt|ਸਾਰੀਆਂ ਫ਼ਾਇਲਾਂ (*.*)|*.*\x02ਲਾਗ ਫ਼ਾਇਲ ਵਿੱਚ ਬਰਾਮਦ ਕਰੋ\x02ਵਾਇਰਗਾ" +
	"ਰਡ ਬਾਰੇ(&A)…\x02ਟਨਲ ਗਲਤੀ\x02%[1]s\x0a\x0aPlease consult the log for mo" +
	"re information.\x02%[1]s (out of date)\x02WireGuard ਖੋਜ ਗ਼ਲਤੀ\x02ਵਾਇਰਗਾਰ" +
	"ਡ: ਨਾ-ਸਰਗਰਮ ਕੀਤਾ\x02ਸਥਿਤੀ: ਅਣਪਛਾਤੀ\x02ਸਿਰਨਾਵੇਂ: ਕੋਈ ਨਹੀਂ\x02ਟਨਲਾਂ ਦਾ ਇ" +
	"ੰਤਜ਼ਾਮ ਕਰੋ(&M)…\x02ਫ਼ਾਇਲ ਤੋਂ ਟਨਲਾਂ ਦਰਾਮਦ ਕਰੋ(&I)…\x02ਬਾਹਰ(&x)\x02ਵਾਇਰਗਾ" +
	"ਰਡ ਸਰਗਰਮ ਕੀਤਾ\x02%[1]s ਟਨਲ ਸਰਗਰਮ ਕੀਤੀ ਗਈ ਹੈ।\x02ਵਾਇਰਗਾਰਡ ਨਾ-ਸਰਗਰਮ ਕੀਤਾ" +
	"\x02%[1]s ਟਨਲ ਨਾ-ਸਰਗਰਮ ਕੀਤੀ ਗਈ ਹੈ।\x02ਵਾਇਰਗਾਰਡ ਟਨਲ ਗਲਤੀ\x02ਵਾਇਰਗਾਰਡ: %[1" +
	"]s\x02ਸਥਿਤੀ: %[1]s\x02ਸਿਰਨਾਵੇਂ: %[1]s\x02ਅੱਪਡੇਟ ਮੌਜੂਦ ਹੈ!\x02ਵਾਇਰਗਾਰਡ ਅੱ" +
	"ਪਡੇਟ ਮੌਜੂਦ ਹੈ\x02ਵਾਇਰਗਾਰਡ ਲਈ ਅੱਪਡੇਟ ਹੁਣ ਮੌਜੂਦ ਹੈ। ਜਿੰਨਾ ਛੇਤੀ ਹੋ ਸਕੇ ਤੁ" +
	"ਹਾਨੂੰ ਅੱਪਡੇਟ ਕਰਨ ਦੀ ਸਲਾਹ ਦਿੱਤੀ ਜਾਂਦੀ ਹੈ।\x02ਟਨਲਾਂ\x02ਸੋਧੋ(&E)\x02…ਖਾਲੀ" +
	" ਟਨਲ ਜੋੜੋ(&e)\x02ਟਨਲ ਜੋੜੋ\x02ਚੁਣੀਆਂ ਟਨਲਾਂ ਨੂੰ ਹਟਾਓ\x02ਸਾਰੀਆਂ ਟਨਲਾਂ ਨੂੰ ਜ਼" +
	"ਿੱਪ ਵਜੋਂ ਬਰਾਮਦ ਕਰੋ\x02ਪਲਟੋ(&T)\x02ਸਾਰੀਆਂ ਟਨਲਾਂ ਨੂੰ ਜ਼ਿੱਪ ਵਜੋਂ ਬਰਾਮਦ ਕਰੋ" +
	"…\x02ਚੁਣੀ ਟਨਲ ਸੋਧੋ(&s)…\x02ਚੁਣੀਆਂ ਟਨਲਾਂ ਨੂੰ ਹਟਾਓ(&R)\x02ਕੋਈ ਸੰਰਚਨਾ ਫ਼ਾ" +
	"ਇਲਾਂ ਨਹੀਂ ਲੱਭੀਆਂ\x02ਇੰਪੋਰਟ ਕੀਤੀਆਂ ਟਨਲਾਂ\x02ਟਨਲ ਬਣਾਉਣ ਲਈ ਅਸਮਰੱਥ\x14\x01" +
	"\x81\x01\x00\x02b\x02ਕੀ ਤੁਸੀਂ %[1]d ਟਨਲ ਨੂੰ ਹਟਾਉਣਾ ਚਾਹੁੰਦੇ ਹੋ?\x00h\x02ਕ" +
	"ੀ ਤੁਸੀਂ %[1]d ਟਨਲਾਂ ਨੂੰ ਹਟਾਉਣਾ ਚਾਹੁੰਦੇ ਹੋ?\x02‘%[1]s’ ਟਨਲ ਨੂੰ ਹਟਾਓ\x02" +
	"ਕੀ ਤੁਸੀਂ ‘%[1]s‘ ਟਨਲ ਨੂੰ ਹਟਾਉਣਾ ਚਾਹੁੰਦੇ ਹੋ?\x02ਟਨਲ ਹਟਾਉਣ ਲਈ ਅਸਮਰੱਥ\x02" +
	"ਸੰਰਚਨਾ ਫ਼ਾਇਲਾਂ (*.zip, *.conf)|*.zip;*.conf|ਸਾਰੀਆਂ ਫ਼ਾਇਲਾਂ (*.*)|*.*" +
	"\x02ਫ਼ਾਇਲ ਤੋਂ ਟਨਲਾਂ ਦਰਾਮਦ ਕਰੋ\x02ਸੰਰਚਨਾ ਜ਼ਿੱਪ ਫਾਇਲਾਂ (*.zip)|*.zip\x02ਹੁਣ" +
	"ੇ ਅੱਪਡੇਟ ਕਰੋ\x02ਸਥਿਤੀ: ਪੂਰਾ!\x02ਟਨਲ(&T)"

var plIndex = []uint32{ // 181 elements
	// Entry 0 - 1F
	0x00000000, 0x00000007, 0x0000004f, 0x00000066,
	0x0000007d, 0x000000cb, 0x00000106, 0x0000013d,
	0x000001a6, 0x00000226, 0x00000271, 0x00000277,
	0x0000029a, 0x000002d1, 0x00000309, 0x0000034d,
	0x0000038c, 0x000003cf, 0x000003da, 0x000003e3,
	0x000003f0, 0x000003fd, 0x0000040a, 0x00000417,
	0x00000424, 0x0000043c, 0x00000465, 0x00000487,
	0x000004b2, 0x000004d6, 0x000004e9, 0x000004fd,
	// Entry 20 - 3F
	0x0000052d, 0x00000549, 0x00000584, 0x000005be,
	0x000005d5, 0x000005f6, 0x00000617, 0x00000653,
	0x0000066e, 0x0000069a, 0x000006c1, 0x000006e5,
	0x000006f6, 0x00000727, 0x0000074e, 0x00000778,
	0x00000796, 0x000007bb, 0x000007be, 0x000007c1,
	0x000007d8, 0x000007e7, 0x00000870, 0x00000878,
	0x00000886, 0x0000088e, 0x0000089a, 0x000008a3,
	0x000008b4, 0x000008c4, 0x000008c9, 0x000008d1,
	// Entry 40 - 5F
	0x000008de, 0x000008e7, 0x000008ec, 0x00000901,
	0x00000917, 0x00000930, 0x00000954, 0x0000095e,
	0x0000097f, 0x0000098a, 0x000009a9, 0x000009d1,
	0x000009f3, 0x00000a13, 0x00000a24, 0x00000a29,
	0x00000a3c, 0x00000a49, 0x00000a51, 0x00000a63,
	0x00000a6e, 0x00000aa4, 0x00000bf7, 0x00000bff,
	0x00000c06, 0x00000c15, 0x00000c2a, 0x00000c3f,
	0x00000c6a, 0x00000c96, 0x00000caa, 0x00000ce3,
	// Entry 60 - 7F
	0x00000d0b, 0x00000d2a, 0x00000d63, 0x00000d6b,
	0x00000d77, 0x00000d82, 0x00000d91, 0x00000d9f,
	0x00000da8, 0x00000db0, 0x00000dc2, 0x00000dd6,
	0x00000ddb, 0x00000df1, 0x00000e28, 0x00000e44,
	0x00000e5f, 0x00000e6d, 0x00000ead, 0x00000ec1,
	0x00000edb, 0x00000f19, 0x00000f32, 0x00000f43,
	0x00000f50, 0x00000f68, 0x00000f8c, 0x00000f96,
	0x00000fa8, 0x00000fc8, 0x00000fe0, 0x00001003,
	// Entry 80 - 9F
	0x0000101b, 0x0000102c, 0x0000103a, 0x00001048,
	0x00001065, 0x0000108b, 0x000010e2, 0x000010e9,
	0x000010f1, 0x00001107, 0x00001113, 0x00001130,
	0x0000115b, 0x00001167, 0x00001196, 0x000011af,
	0x000011cd, 0x000011eb, 0x00001221, 0x00001251,
	0x00001289, 0x000012b6, 0x000012cb, 0x00001343,
	0x000013da, 0x000013f6, 0x0000144e, 0x00001506,
	0x0000151e, 0x0000154e, 0x00001573, 0x0000158e,
	// Entry A0 - BF
	0x000015b8, 0x000015d3, 0x0000167e, 0x000016c8,
	0x000016e8, 0x0000170d, 0x0000172e, 0x0000175d,
	0x00001780, 0x0000180a, 0x0000185c, 0x0000187b,
	0x0000188c, 0x000018b4, 0x000018d6, 0x000018ea,
	0x000018fd, 0x0000190c, 0x00001920, 0x00001930,
	0x00001938,
} // Size: 748 bytes

const plData string = "" + // Size: 6456 bytes
	"\x02Błąd\x02(brak argumentu): Podnieś uprawnienia i zainstaluj usługę me" +
	"nedżera\x02Użycie: %[1]s [%[2]s]\x02Opcje wiersza poleceń\x02Nie można o" +
	"kreślić, czy proces jest uruchomiony w środowisku WOW64: %[1]v\x02Musisz" +
	" użyć natywnej wersji WireGuard na tym komputerze.\x02Nie można otworzyć" +
	" bieżącego tokenu procesu: %[1]v\x02WireGuard może być używany tylko prz" +
	"ez użytkowników, którzy są członkami wbudowanej grupy %[1]s.\x02WireGuar" +
	"d jest uruchomiony, ale interfejs jest dostępny tylko z poziomu użytkown" +
	"ików należących do wbudowanej grupy %[1]s.\x02Ikona WireGuard nie pojawi" +
	"ła się po 30 sekundach w zasobniku systemowym.\x02Teraz\x02Zegar system" +
	"owy został cofnięty!\x14\x01\x81\x01\x00\x04\x0b\x02%[1]d lata\x05\x0a" +
	"\x02%[1]d lat\x02\x0a\x02%[1]d rok\x00\x0b\x02%[1]d lata\x14\x01\x81\x01" +
	"\x00\x04\x0a\x02%[1]d dni\x05\x0a\x02%[1]d dni\x02\x0d\x02%[1]d dzień" +
	"\x00\x0a\x02%[1]d dni\x14\x01\x81\x01\x00\x04\x0e\x02%[1]d godziny\x05" +
	"\x0d\x02%[1]d godzin\x02\x0e\x02%[1]d godzina\x00\x0e\x02%[1]d godziny" +
	"\x14\x01\x81\x01\x00\x04\x0d\x02%[1]d minuty\x05\x0c\x02%[1]d minut\x02" +
	"\x0d\x02%[1]d minuta\x00\x0c\x02%[1]d minut\x14\x01\x81\x01\x00\x04\x0e" +
	"\x02%[1]d sekundy\x05\x0d\x02%[1]d sekund\x02\x0e\x02%[1]d sekunda\x00" +
	"\x0d\x02%[1]d sekund\x02%[1]s temu\x02%[1]d\u00a0B\x02%.2[1]f\u00a0KiB" +
	"\x02%.2[1]f\u00a0MiB\x02%.2[1]f\u00a0GiB\x02%.2[1]f\u00a0TiB\x02%[1]s: %" +
	"[2]q\x02Nieprawidłowy adres IP\x02Nieprawidłowa długość prefiksu sieci" +
	"\x02Brak portu urządzenia końcowego\x02Nieprawidłowy host (urządzenie ko" +
	"ńcowe)\x02Nawiasy muszą zawierać adres IPv6\x02Nieprawidłowe MTU\x02Nie" +
	"prawidłowy port\x02Nieprawidłowy parametr utrzymania połączenia\x02Niepr" +
	"awidłowy klucz: %[1]v\x02Klucze muszą zostać zdekodowane do dokładnie 32" +
	" bajtów\x02Liczba musi zawierać się w przedziale 0 - 2^64-1: %[1]v\x02Dw" +
	"a przecinki z rzędu\x02Nazwa tunelu jest nieprawidłowa\x02Linia musi wys" +
	"tępować w sekcji\x02Klucz konfiguracyjny nie zawiera separatora równorzę" +
	"dnego\x02Klucz musi mieć wartość\x02Nieprawidłowy klucz dla sekcji [Inte" +
	"rface]\x02Nieprawidłowy klucz dla sekcji [Peer]\x02Interfejs musi mieć k" +
	"lucz prywatny\x02[nie określono]\x02Wszyscy uczestnicy muszą mieć klucze" +
	" publiczne\x02Błąd podczas pobierania konfiguracji\x02Nieprawidłowy kluc" +
	"z dla sekcji interface\x02Wersja protokołu musi być 1\x02Nieprawidłowy k" +
	"lucz dla sekcji peer\x02, \x02, \x02Informacje o WireGuard\x02Logo WireG" +
	"uard\x02Wersja aplikacji: %[1]s\x0aWersja implementacji w jęz. Go: %[2]s" +
	"\x0aWersja jęz. Go: %[3]s-%[4]s\x0aSystem operacyjny: %[5]s\x0aArchitekt" +
	"ura: %[6]s\x02Zamknij\x02♥ &Wpłać!\x02Status:\x02&Dezaktywuj\x02&Aktywuj" +
	"\x02Klucz publiczny:\x02Port nasłuchu:\x02MTU:\x02Adresy:\x02Serwery DNS" +
	":\x02Skrypty:\x02PSK:\x02Dozwolone adresy IP:\x02Urządzenie końcowe:\x02" +
	"Utrzymanie połączenia:\x02Ostatni uścisk dłoni (handshake):\x02Transfer:" +
	"\x02wyłączone, według zasad grupy\x02włączyć\x02%[1]s odebrano, %[2]s wy" +
	"słano\x02Nie udało się określić stanu tunelu\x02Nie udało się aktywować " +
	"tunelu\x02Nie można dezaktywować tunelu\x02Interfejs: %[1]s\x02Peer\x02U" +
	"twórz nowy tunel\x02Edytuj tunel\x02&Nazwa:\x02&Klucz publiczny:\x02(nie" +
	"znany)\x02Zablokuj niezabezpieczony ruch (wyłącznik awaryjny)\x02Jeżeli " +
	"konfiguracja ma dokładnie jednego peer'a i ma w liście dozwolonych IP pr" +
	"zynajmniej jeden adres 0.0.0.0/0 lub ::/0, wtedy usługa tunelowania dołą" +
	"cza do zapory sieciowej zestaw zasad, żeby zablokować ruch, który nie je" +
	"st z interfejsu sieciowego lub jest skierowany do złego serwera DNS, z w" +
	"yjątkiem dla serwera DHCP i NDP.\x02&Zapisz\x02Anuluj\x02&Konfiguracja:" +
	"\x02Nieprawidłowa nazwa\x02Nazwa jest wymagana.\x02Nazwa tunelu ‘%[1]s’ " +
	"jest niepoprawna.\x02Nie można wylistować istniejących tuneli\x02Tunel j" +
	"uż istnieje\x02Inny tunel już istnieje z tą samą nazwą ‘%[1]s’.\x02Nie m" +
	"ożna utworzyć nowej konfiguracji\x02Zapis pliku się nie powiódł\x02Plik " +
	"‘%[1]s’ już istnieje. Czy chcesz go nadpisać?\x02Aktywny\x02Aktywowani" +
	"e\x02Nieaktywny\x02Dezaktywowanie\x02Stan nieznany\x02Dziennik\x02&Kopiu" +
	"j\x02Wybierz &wszystko\x02&Zapisz do pliku…\x02Czas\x02Wiadomości dzienn" +
	"ika\x02Pliki tekstowe (*.txt)|*.txt|Wszystkie pliki (*.*)|*.*\x02Eksport" +
	"uj dziennik do pliku\x02&Informacje o WireGuard…\x02Błąd tunelu\x02%[1]s" +
	"\x0a\x0aAby uzyskać więcej informacji, zapoznaj się z logiem.\x02%[1]s (" +
	"nieaktualny)\x02Błąd detekcji WireGuard\x02Nie można poczekać na pojawie" +
	"nie się okna WireGuard: %[1]v\x02WireGuard: Dezaktywowany\x02Status: Nie" +
	"znany\x02Adresy: Brak\x02&Zarządzaj tunelami…\x02&Importuj tunel (tunele" +
	") z pliku…\x02W&yjście\x02WireGuard Aktywny\x02Tunel %[1]s został aktywo" +
	"wany.\x02WireGuard Dezaktywowany\x02Tunel %[1]s został dezaktywowany." +
	"\x02Błąd tunelu WireGuard\x02WireGuard: %[1]s\x02Status: %[1]s\x02Adresy" +
	": %[1]s\x02Dostępna nowa aktualizacja!\x02Aktualizacja WireGuard jest do" +
	"stępna\x02Aktualizacja WireGuard jest już dostępna. Zaleca się jak najsz" +
	"ybszą aktualizację.\x02Tunele\x02&Edytuj\x02Dodaj &pusty tunel…\x02Dodaj" +
	" Tunel\x02Usuń wybrany tunel (tunele)\x02Eksportuj wszystkie tunele do a" +
	"rchiwum ZIP\x02&Przełącz\x02Eksportuj wszystkie tunele do archiwum &zip…" +
	"\x02Edytuj &wybrany tunel…\x02&Usuń wybrany tunel (tunele)\x02brak plikó" +
	"w konfiguracyjnych\x02Nie można zaimportować wybranej konfiguracji: %[1]" +
	"v\x02Nie można wskazać istniejących tuneli: %[1]v\x02Inny tunel już istn" +
	"ieje z tą samą nazwą ‘%[1]s’\x02Nie można zaimportować konfiguracji: %[1" +
	"]v\x02Zaimportowane tunele\x14\x01\x81\x01\x00\x04\x1b\x02Zaimportowano " +
	"%[1]d tunele\x05\x1b\x02Zaimportowano %[1]d tuneli\x02\x1a\x02Zaimportow" +
	"ano %[1]d tunel\x00\x1b\x02Zaimportowano %[1]d tuneli\x14\x02\x80\x01" +
	"\x04#\x02Zaimportowano %[1]d z %[2]d tunele\x05#\x02Zaimportowano %[1]d " +
	"z %[2]d tuneli\x02\x22\x02Zaimportowano %[1]d z %[2]d tunel\x00#\x02Zaim" +
	"portowano %[1]d z %[2]d tuneli\x02Nie można utworzyć tunelu\x14\x01\x81" +
	"\x01\x00\x04\x13\x02Usuń %[1]d tunele\x05\x13\x02Usuń %[1]d tuneli\x02" +
	"\x12\x02Usuń %[1]d tunel\x00\x13\x02Usuń %[1]d tuneli\x14\x01\x81\x01" +
	"\x00\x04+\x02Czy na pewno chcesz usunąć %[1]d tunele?\x05+\x02Czy na pew" +
	"no chcesz usunąć %[1]d tuneli?\x02*\x02Czy na pewno chcesz usunąć %[1]d " +
	"tunel?\x00+\x02Czy na pewno chcesz usunąć %[1]d tuneli?\x02Usuń tunel ‘%" +
	"[1]s’\x02Czy na pewno chcesz usunąć tunel ‘%[1]s’?\x02%[1]s Tej akcji ni" +
	"e można cofnąć.\x02Nie można usunąć tunelu\x02Tunel nie mógł zostać usun" +
	"ięty: %[1]s\x02Nie można usunąć tuneli\x14\x01\x81\x01\x00\x04'\x02%[1]d" +
	" tunele nie mogą być usunięte.\x05'\x02%[1]d tunele nie mogą być usunięt" +
	"e.\x02)\x02%[1]d tunel nie może zostać usunięty.\x00'\x02%[1]d tunele ni" +
	"e mogą być usunięte.\x02Pliki konfiguracji (*.zip, *.conf)|*.zip;*.conf|" +
	"Wszystkie pliki (*.*)|*.*\x02Importuj tunel (tunele) z pliku\x02Pliki ZI" +
	"P konfiguracji (*.zip)|*.zip\x02Eksportuj tunele do archiwum ZIP\x02%[1]" +
	"s (wersja niepodpisana, brak aktualizacji)\x02Błąd podczas zamykania Wir" +
	"eGuard\x02Nie można wyłączyć usługi ze względu na: %[1]v. Jeśli chcesz w" +
	"yłączyć WireGuard możesz to zrobić z poziomu menedżera usług.\x02Aktuali" +
	"zacja WireGuard jest dostępna. Zaleca się natychmiastową aktualizację." +
	"\x02Status: Czekam na użytkownika\x02Uaktualnij teraz\x02Status: Czekam " +
	"na usługę aktualizacji\x02Błąd: %[1]v. Spróbuj ponownie.\x02Status: Ukoń" +
	"czone!\x02przed włączeniem\x02po włączeniu\x02przed wyłączeniem\x02po wy" +
	"łączeniu\x02&Tunele"

var roIndex = []uint32{ // 181 elements
	// Entry 0 - 1F
	0x00000000, 0x00000007, 0x0000005d, 0x00000077,
	0x00000092, 0x000000d1, 0x0000011a, 0x0000014e,
	0x000001b2, 0x0000022e, 0x00000278, 0x0000027d,
	0x000002a4, 0x000002cf, 0x000002fc, 0x00000329,
	0x0000035d, 0x00000396, 0x000003a1, 0x000003aa,
	0x000003b7, 0x000003c4, 0x000003d1, 0x000003de,
	0x000003eb, 0x00000400, 0x0000042d, 0x00000452,
	0x00000475, 0x000004a6, 0x000004b4, 0x000004c1,
	// Entry 20 - 3F
	0x000004e4, 0x000004fb, 0x00000540, 0x0000057c,
	0x0000059e, 0x000005bd, 0x000005e8, 0x0000062f,
	0x00000655, 0x00000683, 0x000006ac, 0x000006dd,
	0x000006f4, 0x00000723, 0x00000747, 0x00000775,
	0x0000079d, 0x000007c8, 0x000007cb, 0x000007ce,
	0x000007df, 0x000007f8, 0x0000087c, 0x00000887,
	0x00000896, 0x0000089d, 0x000008aa, 0x000008b4,
	0x000008c4, 0x000008d7, 0x000008dc, 0x000008e4,
	// Entry 40 - 5F
	0x000008f1, 0x000008fc, 0x00000913, 0x00000923,
	0x00000930, 0x0000094c, 0x00000969, 0x00000976,
	0x00000994, 0x0000099e, 0x000009b9, 0x000009e5,
	0x00000a03, 0x00000a24, 0x00000a37, 0x00000a3f,
	0x00000a50, 0x00000a5e, 0x00000a65, 0x00000a76,
	0x00000a85, 0x00000ad2, 0x00000c6e, 0x00000c77,
	0x00000c7f, 0x00000c8f, 0x00000c9c, 0x00000cb2,
	0x00000cdd, 0x00000d04, 0x00000d19, 0x00000d4a,
	// Entry 60 - 7F
	0x00000d6f, 0x00000d8d, 0x00000dd3, 0x00000dd9,
	0x00000de7, 0x00000def, 0x00000e00, 0x00000e13,
	0x00000e1a, 0x00000e23, 0x00000e36, 0x00000e4e,
	0x00000e53, 0x00000e63, 0x00000e9a, 0x00000eb7,
	0x00000ecc, 0x00000edc, 0x00000f14, 0x00000f29,
	0x00000f47, 0x00000f85, 0x00000f9b, 0x00000faf,
	0x00000fbf, 0x00000fd7, 0x00000ffc, 0x00001005,
	0x00001017, 0x00001035, 0x0000104a, 0x0000106b,
	// Entry 80 - 9F
	0x00001085, 0x00001096, 0x000010a3, 0x000010b1,
	0x000010d2, 0x000010fc, 0x00001172, 0x0000117b,
	0x00001184, 0x0000119c, 0x000011ac, 0x000011cd,
	0x000011ef, 0x000011f9, 0x0000121f, 0x0000123a,
	0x0000125c, 0x00001287, 0x000012c0, 0x000012f5,
	0x00001325, 0x00001351, 0x00001364, 0x000013b7,
	0x00001427, 0x00001441, 0x00001497, 0x00001541,
	0x0000155d, 0x00001597, 0x000015c5, 0x000015e0,
	// Entry A0 - BF
	0x00001607, 0x00001624, 0x000016a8, 0x000016f8,
	0x00001719, 0x00001743, 0x0000175e, 0x0000178f,
	0x000017b0, 0x00001811, 0x0000186e, 0x00001890,
	0x000018a3, 0x000018d1, 0x000018f4, 0x00001908,
	0x00001914, 0x00001921, 0x0000192c, 0x00001938,
	0x00001942,
} // Size: 748 bytes

const roData string = "" + // Size: 6466 bytes
	"\x02Eroare\x02(fără argument): obținere drept administrativ și instalare" +
	" serviciu de gestionare\x02Utilizare: %[1]s [\x0a%[2]s]\x02Opțiuni linie" +
	" de comandă\x02Nu se poate determina dacă procesul rulează sub WOW64: %[" +
	"1]v\x02Trebuie să utilizezi versiunea nativă a WireGuard pe acest calcul" +
	"ator.\x02Nu poate fi deschis tokenul actual de proces: %[1]v\x02WireGuar" +
	"d poate fi utilizat doar de către utilizatorii care sunt membri ai grupu" +
	"lui Builtin %[1]s.\x02WireGuard rulează, dar interfața cu utilizatorul e" +
	"ste accesibilă doar din spațiile de lucru ale grupului Builtin %[1]s." +
	"\x02Pictograma WireGuard din bara de sistem nu a apărut după 30 de secun" +
	"de.\x02Acum\x02Ceasul de sistem a fost dat în spate!\x14\x01\x81\x01\x00" +
	"\x04\x0a\x02%[1]d ani\x02\x09\x02%[1]d an\x00\x0d\x02%[1]d de ani\x14" +
	"\x01\x81\x01\x00\x04\x0b\x02%[1]d zile\x02\x09\x02%[1]d zi\x00\x0e\x02%[" +
	"1]d de zile\x14\x01\x81\x01\x00\x04\x0a\x02%[1]d ore\x02\x0b\x02%[1]d or" +
	"ă\x00\x0d\x02%[1]d de ore\x14\x01\x81\x01\x00\x04\x0d\x02%[1]d minute" +
	"\x02\x0c\x02%[1]d minut\x00\x10\x02%[1]d de minute\x14\x01\x81\x01\x00" +
	"\x04\x0e\x02%[1]d secunde\x02\x0f\x02%[1]d secundă\x00\x11\x02%[1]d de s" +
	"ecunde\x02acum %[1]s\x02%[1]d\u00a0B\x02%.2[1]f\u00a0KiB\x02%.2[1]f" +
	"\u00a0MiB\x02%.2[1]f\u00a0GiB\x02%.2[1]f\u00a0TiB\x02%[1]s: %[2]q\x02Adr" +
	"esă IP invalidă\x02Lungimea prefixului de rețea este invalidă\x02Lipseșt" +
	"e portul de la punctul final\x02Gazdă invalidă a punctului final\x02Para" +
	"ntezele trebuie să conțină o adresă IPv6\x02MTU invalidă\x02Port invalid" +
	"\x02Mesaj keepalive persistent invalid\x02Cheie invalidă: %[1]v\x02Rezul" +
	"tatul decodificat de chei trebuie să aibă exact 32 de octeți\x02Numărul " +
	"trebuie să fie cuprins între 0 și 2^64-1: %[1]v\x02Două virgule una după" +
	" cealaltă\x02Numele tunelului nu este valid\x02Linia trebuie să apară în" +
	"tr-o secțiune\x02Cheii de configurare îi lipsește un separator de forma " +
	"semnului egal\x02Cheia trebuie să conțină o valoare\x02Cheie invalidă pe" +
	"ntru secțiunea [Interface]\x02Cheie invalidă pentru secțiunea [Peer]\x02" +
	"O interfață trebuie să aibă o cheie privată\x02[niciuna specificată]\x02" +
	"Toate perechile trebuie să aibă chei publice\x02Eroare la obținerea conf" +
	"igurației\x02Cheie invalidă pentru secțiunea interfeței\x02Versiunea de " +
	"protocol trebuie să fie 1\x02Cheie invalidă pentru secțiunea perechii" +
	"\x02, \x02, \x02Despre WireGuard\x02Imagine siglă WireGuard\x02Versiunea" +
	" aplicației: %[1]s\x0aVersiunea bibliotecii Go: %[2]s\x0aVersiunea Go: %" +
	"[3]s-%[4]s\x0aSistem de operare: %[5]s\x0aArhitectură: %[6]s\x02Închider" +
	"e\x02♥ &Donează!\x02Stare:\x02&Dezactivare\x02&Activare\x02Cheie publică" +
	":\x02Port de ascultare:\x02MTU:\x02Adrese:\x02Servere DNS:\x02Scripturi:" +
	"\x02Cheie predistribuită:\x02IP-uri permise:\x02Punct final:\x02Mesaj ke" +
	"epalive persistent:\x02Ultimul acord de interogare:\x02Transferare:\x02d" +
	"ezactivat, conform politicii\x02activată\x02%[1]s primit, %[2]s trimis" +
	"\x02Nu a putut fi determinată starea tunelului\x02Tunelul nu a putut fi " +
	"activat\x02Tunelul nu a putut fi dezactivat\x02Interfață: %[1]s\x02Perec" +
	"he\x02Creare tunel nou\x02Editare tunel\x02&Nume:\x02Cheie &publică:\x02" +
	"(necunoscută)\x02&Blochează traficul care nu trece prin tunel (întrerupă" +
	"tor de activitate)\x02Când o configurație conține exact o pereche, iar a" +
	"cea pereche are IP-uri permise care conțin cel puțin o variantă dintre 0" +
	".0.0.0/0 sau ::/0, atunci serviciul tunelului activează un set de reguli" +
	" al paravanului de protecție pentru a bloca întregul trafic care nu prov" +
	"ine de la interfața tunelului sau care este direcționat către serverul D" +
	"NS greșit, existând excepții speciale pentru DHCP și NDP.\x02&Salvare" +
	"\x02Anulare\x02&Configurație:\x02Nume invalid\x02Este necesar un nume." +
	"\x02Numele tunelului „%[1]s” este invalid.\x02Tunelurile existente nu po" +
	"t fi listate\x02Tunelul există deja\x02Există deja un alt tunel cu numel" +
	"e „%[1]s”.\x02Nu se poate crea configurația nouă\x02Scrierea fișierului " +
	"a eșuat\x02Fișierul „%[1]s” există deja.\x0a\x0aDorești suprascrierea ac" +
	"estuia?\x02Activ\x02Se activează\x02Inactiv\x02Se dezactivează\x02Stare " +
	"necunoscută\x02Jurnal\x02&Copiere\x02Selectare &totală\x02&Salvare în fi" +
	"șier…\x02Timp\x02Mesaj de jurnal\x02Fișiere text (*.txt)|*.txt|Toate fi" +
	"șierele (*.*)|*.*\x02Exportare jurnal în fișier\x02&Despre WireGuard…" +
	"\x02Eroare de tunel\x02%[1]s\x0a\x0aConsultă jurnalul pentru mai multe i" +
	"nformații.\x02%[1]s (neactualizat)\x02Eroare de detectare WireGuard\x02N" +
	"u se poate aștepta ca fereastra WireGuard să apară: %[1]v\x02WireGuard: " +
	"dezactivat\x02Stare: necunoscută\x02Adrese: niciuna\x02&Gestionare tunel" +
	"uri…\x02&Importare tunel(uri) din fișier…\x02Ie&șire\x02WireGuard activa" +
	"t\x02Tunelul %[1]s a fost activat.\x02WireGuard dezactivat\x02Tunelul %[" +
	"1]s a fost dezactivat.\x02Eroare de tunel WireGuard\x02WireGuard: %[1]s" +
	"\x02Stare: %[1]s\x02Adrese: %[1]s\x02Este disponibilă o actualizare!\x02" +
	"Actualizare disponibilă pentru WireGuard\x02O actualizare pentru WireGua" +
	"rd este acum disponibilă. Se recomandă efectuarea actualizării cât mai r" +
	"apid posibil.\x02Tuneluri\x02&Editare\x02Adăugare tunel &gol…\x02Adăugar" +
	"e tunel\x02Eliminare tunel(uri) selectat(e)\x02Exportă toate tunelurile " +
	"în zip\x02&Comutare\x02Exportă toate tunelurile în &zip…\x02Editare tun" +
	"el &selectat…\x02&Eliminare tunel(uri) selectat(e)\x02nu au fost găsite " +
	"fișiere de configurare\x02Configurația selectată nu a putut fi importată" +
	": %[1]v\x02Tunelurile existente nu au putut fi enumerate: %[1]v\x02Exist" +
	"ă deja un alt tunel cu numele „%[1]s”\x02Configurația nu poate fi impor" +
	"tată: %[1]v\x02Tuneluri importate\x14\x01\x81\x01\x00\x04\x18\x02Importa" +
	"t %[1]d tuneluri\x02\x15\x02Importat %[1]d tunel\x00\x1b\x02Importat %[1" +
	"]d de tuneluri\x14\x02\x80\x01\x04\x22\x02Importat %[1]d din %[2]d tunel" +
	"uri\x02\x1f\x02Importat %[1]d din %[2]d tunel\x00%\x02Importat %[1]d din" +
	" %[2]d de tuneluri\x02Tunelul nu poate fi creat\x14\x01\x81\x01\x00\x04" +
	"\x19\x02Ștergere %[1]d tuneluri\x02\x16\x02Ștergere %[1]d tunel\x00\x1c" +
	"\x02Ștergere %[1]d de tuneluri\x14\x01\x81\x01\x00\x045\x02Ești sigur că" +
	" dorești să ștergi %[1]d tuneluri?\x022\x02Ești sigur că dorești să șter" +
	"gi %[1]d tunel?\x008\x02Ești sigur că dorești să ștergi %[1]d de tunelur" +
	"i?\x02Ștergere tunel „%[1]s”\x02Ești sigur că dorești să ștergi tunelul " +
	"„%[1]s”?\x02%[1]s Această acțiune nu poate fi anulată.\x02Tunelul nu p" +
	"oate fi șters\x02Un tunel nu a putut fi eliminat: %[1]s\x02Nu se pot ște" +
	"rge tunelurile\x14\x01\x81\x01\x00\x04)\x02%[1]d tuneluri nu au putut fi" +
	" eliminate.\x02$\x02%[1]d tunel nu a putut fi eliminat.\x00,\x02%[1]d de" +
	" tuneluri nu au putut fi eliminate.\x02Fișiere de configurare (*.zip, *." +
	"conf)|*.zip;*.conf|Toate fișierele (*.*)|*.*\x02Importare tunel(uri) din" +
	" fișier\x02Fișiere ZIP de configurare (*.zip)|*.zip\x02Exportare tunelur" +
	"i în zip\x02%[1]s (versiune nesemnată, fără actualizări)\x02Eroare la ie" +
	"șirea din WireGuard\x02Nu se poate ieși din serviciu din cauza: %[1]v. " +
	"Poți opri WireGuard din managerul de servicii.\x02Este disponibilă o act" +
	"ualizare pentru WireGuard. Se recomandă ferm actualizarea imediată.\x02S" +
	"tare: se așteaptă utilizatorul\x02Actualizează acum\x02Stare: se așteapt" +
	"ă serviciul de actualizare\x02Eroare: %[1]v. Încearcă din nou.\x02Stare" +
	": finalizată!\x02pre-pornire\x02post-pornire\x02pre-oprire\x02post-oprir" +
	"e\x02&Tuneluri"

var ruIndex = []uint32{ // 181 elements
	// Entry 0 - 1F
	0x00000000, 0x0000000d, 0x000000a9, 0x000000d4,
	0x00000107, 0x00000166, 0x000001c9, 0x00000220,
	0x000002a7, 0x0000034b, 0x000003b3, 0x000003c0,
	0x000003fd, 0x0000042a, 0x00000457, 0x00000484,
	0x000004c1, 0x000004fe, 0x0000050f, 0x00000518,
	0x00000525, 0x00000532, 0x0000053f, 0x0000054c,
	0x00000559, 0x00000580, 0x000005be, 0x000005fd,
	0x0000062b, 0x00000663, 0x00000680, 0x000006a2,
	// Entry 20 - 3F
	0x000006f8, 0x00000721, 0x00000776, 0x000007b5,
	0x000007d8, 0x00000817, 0x0000084a, 0x0000089f,
	0x000008d1, 0x0000090b, 0x00000940, 0x0000098a,
	0x000009a0, 0x000009e6, 0x00000a26, 0x00000a69,
	0x00000aa1, 0x00000ae8, 0x00000aeb, 0x00000aee,
	0x00000afb, 0x00000b14, 0x00000bcd, 0x00000bdc,
	0x00000bfb, 0x00000c09, 0x00000c1d, 0x00000c33,
	0x00000c50, 0x00000c5a, 0x00000c5f, 0x00000c70,
	// Entry 40 - 5F
	0x00000c84, 0x00000c94, 0x00000ca9, 0x00000cd1,
	0x00000cef, 0x00000d20, 0x00000d4b, 0x00000d5d,
	0x00000d87, 0x00000d98, 0x00000dcb, 0x00000e16,
	0x00000e4e, 0x00000e84, 0x00000e9e, 0x00000ea5,
	0x00000ec3, 0x00000eed, 0x00000f00, 0x00000f1e,
	0x00000f35, 0x00000f7d, 0x00001186, 0x0000119a,
	0x000011a7, 0x000011c2, 0x000011ec, 0x00001213,
	0x00001257, 0x0000128f, 0x000012ba, 0x00001302,
	// Entry 60 - 7F
	0x00001349, 0x0000136e, 0x000013d0, 0x000013e3,
	0x000013fa, 0x0000140b, 0x00001420, 0x0000144a,
	0x00001457, 0x0000146f, 0x00001486, 0x000014a9,
	0x000014b4, 0x000014d6, 0x0000151e, 0x00001548,
	0x00001559, 0x00001575, 0x000015f0, 0x00001607,
	0x00001635, 0x00001689, 0x000016af, 0x000016d2,
	0x000016e7, 0x00001713, 0x00001745, 0x00001751,
	0x0000176a, 0x00001793, 0x000017ae, 0x000017d5,
	// Entry 80 - 9F
	0x000017fb, 0x0000180c, 0x00001820, 0x00001834,
	0x0000185b, 0x0000188b, 0x00001916, 0x00001925,
	0x00001941, 0x00001972, 0x00001992, 0x000019c3,
	0x000019fe, 0x00001a16, 0x00001a55, 0x00001a96,
	0x00001ac8, 0x00001b09, 0x00001b59, 0x00001bb3,
	0x00001bfa, 0x00001c4a, 0x00001c78, 0x00001d4c,
	0x00001e48, 0x00001e7a, 0x00001f1a, 0x00002062,
	0x0000208c, 0x000020dc, 0x00002127, 0x00002159,
	// Entry A0 - BF
	0x00002193, 0x000021c5, 0x000022bc, 0x00002319,
	0x00002347, 0x0000237f, 0x000023b1, 0x000023fe,
	0x00002427, 0x000024c1, 0x00002549, 0x00002581,
	0x0000259f, 0x000025d3, 0x0000260c, 0x0000262e,
	0x00002652, 0x00002674, 0x00002696, 0x000026b6,
	0x000026c6,
} // Size: 748 bytes

const ruData string = "" + // Size: 9926 bytes
	"\x02Ошибка\x02(нет аргумента): получить права администратора и установит" +
	"ь административную службу\x02Использование: %[1]s [\x0a%[2]s]\x02Параме" +
	"тры командной строки\x02Ошибка определения или процесс работает как WOW" +
	"64: %[1]v\x02Используйте нативную версию WireGuard на этом компьютере." +
	"\x02Не удается открыть токен текущего процесса: %[1]v\x02WireGuard может" +
	" использоваться только пользователями, входящими в группу %[1]s.\x02Wire" +
	"Guard запущен, но пользовательский интерфейс доступен только с рабочих с" +
	"толов группы %[1]s.\x02Значок в системном трее WireGuard не появился по" +
	"сле 30 секунд.\x02Сейчас\x02Системные часы переведены назад!\x14\x01" +
	"\x81\x01\x00\x04\x08\x02%[1]dг\x05\x08\x02%[1]dг\x02\x08\x02%[1]dг\x00" +
	"\x08\x02%[1]dг\x14\x01\x81\x01\x00\x04\x08\x02%[1]dд\x05\x08\x02%[1]dд" +
	"\x02\x08\x02%[1]dд\x00\x08\x02%[1]dд\x14\x01\x81\x01\x00\x04\x08\x02%[1]" +
	"dч\x05\x08\x02%[1]dч\x02\x08\x02%[1]dч\x00\x08\x02%[1]dч\x14\x01\x81\x01" +
	"\x00\x04\x0c\x02%[1]dмин\x05\x0c\x02%[1]dмин\x02\x0c\x02%[1]dмин\x00\x0c" +
	"\x02%[1]dмин\x14\x01\x81\x01\x00\x04\x0c\x02%[1]dсек\x05\x0c\x02%[1]dсек" +
	"\x02\x0c\x02%[1]dсек\x00\x0c\x02%[1]dсек\x02%[1]s назад\x02%[1]d Б\x02%." +
	"2[1]f Кб\x02%.2[1]f Мб\x02%.2[1]f Гб\x02%.2[1]f Тб\x02%[1]s: %[2]q\x02Не" +
	"допустимый IP-адрес\x02Недопустимая длина префикса сети\x02Отсутствует " +
	"порт IP-адреса сервера\x02Неверный IP-адрес сервера\x02В скобках должен" +
	" быть IPv6 адрес\x02Недопустимый MTU\x02Недопустимый порт\x02Недопустимо" +
	"е значение поддержания соединения\x02Недопустимый ключ: %[1]v\x02Ключи " +
	"должны декодироваться ровно с 32 байтами\x02Число должно быть между 0 и" +
	" 2^64-1: %[1]v\x02Две запятые подряд\x02Название туннеля недействительно" +
	"\x02Строка должна быть в секции\x02В ключе конфигурации отсутствует разд" +
	"елитель\x02Ключ должен иметь значение\x02Неверный ключ для секции [Inte" +
	"rface]\x02Неверный ключ для секции [Peer]\x02В Интерфейсе должен быть пр" +
	"иватный ключ\x02[не указано]\x02Все пиры должны иметь публичные ключи" +
	"\x02Ошибка при получении конфигурации\x02Неверный ключ для секции Интерф" +
	"ейса\x02Версия протокола должна быть 1\x02Недействительный ключ для сек" +
	"ции пира\x02, \x02, \x02О WireGuard\x02Логотип WireGuard\x02Версия прил" +
	"ожения: %[1]s\x0aВерсия Go-бэкенда: %[2]s\x0aВерсия Go: %[3]s-%[4]s\x0a" +
	"Операционная система: %[5]s\x0aАрхитектура: %[6]s\x02Закрыть\x02♥ &Поже" +
	"ртвовать!\x02Статус:\x02&Отключить\x02&Подключить\x02Публичный ключ:" +
	"\x02Порт:\x02MTU:\x02IP-адреса:\x02DNS-серверы:\x02Скрипты:\x02Общий клю" +
	"ч:\x02Разрешенные IP-адреса:\x02IP-адрес сервера:\x02Поддерживание соед" +
	"инения:\x02Последнее рукопожатие:\x02Передача:\x02отключено, по политик" +
	"е\x02включено\x02Получено %[1]s, отправлено %[2]s\x02Не удалось определ" +
	"ить состояние туннеля\x02Не удалось подключить туннель\x02Не удалось от" +
	"ключить туннель\x02Интерфейс: %[1]s\x02Пир\x02Создать туннель\x02Редакт" +
	"ировать туннель\x02&Название:\x02&Публичный ключ:\x02(неизвестно)\x02&Б" +
	"локировать нетуннелированный трафик\x02Если конфигурация имеет ровно од" +
	"ин пир, а этот пир имеет разрешенные IP, содержащие хотя бы один из 0.0" +
	".0.0/0 или ::/0, то туннельный сервис использует набор правил брандмауэр" +
	"а для блокирования всего трафика, который не проходит через туннель или" +
	" к неверным DNS-серверам, за исключением DHCP и NDP.\x02&Сохранить\x02От" +
	"мена\x02&Конфигурация:\x02Некорректное название\x02Необходимо название." +
	"\x02Название туннеля ‘%[1]s’ недопустимо.\x02Не удалось отобразить тунне" +
	"ли\x02Туннель уже существует\x02Туннель с именем ’%[1]s’ уже существует" +
	".\x02Не удалось создать новую конфигурацию\x02Ошибка записи файла\x02Фай" +
	"л '%[1]s' уже существует!\x0a\x0aВы хотите перезаписать его?\x02Подключ" +
	"ен\x02Подключение\x02Отключен\x02Отключение\x02Неизвестное состояние" +
	"\x02Журнал\x02&Скопировать\x02Выбрать &все\x02&Сохранить в файл…\x02Врем" +
	"я\x02Сообщение журнала\x02Текстовые файлы (*.txt)|*.txt|Все файлы (*.*)" +
	"|*.*\x02Экспорт журнала в файл\x02&О WireGuard…\x02Ошибка туннеля\x02%[1" +
	"]s\x0a\x0aОбратитесь к журналу для получения дополнительной информации." +
	"\x02%[1]s (устарел)\x02Ошибка обнаружения WireGuard\x02Не удалось дождат" +
	"ься появления окна WireGuard: %[1]v\x02WireGuard: Деактивирован\x02Стат" +
	"ус: Неизвестен\x02Адреса: нет\x02&Управление туннелями…\x02&Импорт тунн" +
	"елей из файла…\x02Вы&ход\x02WireGuard Включен\x02Туннель %[1]s подключе" +
	"н.\x02WireGuard Выключен\x02Туннель %[1]s отключен.\x02Ошибка туннеля W" +
	"ireGuard\x02WireGuard: %[1]s\x02Статус: %[1]s\x02Адреса: %[1]s\x02Доступ" +
	"но обновление!\x02Доступно обновление WireGuard\x02Доступно обновление " +
	"для WireGuard. Рекомендуется обновить его как можно скорее.\x02Туннели" +
	"\x02&Редактировать\x02Добавить &пустой туннель…\x02Добавить туннель\x02У" +
	"далить выбранные туннели\x02Экспорт всех туннелей в zip-архив\x02&Перек" +
	"лючить\x02Экспорт всех туннелей в &zip-архив…\x02Редактировать &выбранн" +
	"ый туннель…\x02&Удалить выбранные туннели\x02файлы конфигурации не были" +
	" найдены\x02Невозможно импортировать конфигурацию: %[1]v\x02Не удалось п" +
	"еречислить существующие туннели: %[1]v\x02Туннель с именем ’%[1]s’ уже " +
	"существует\x02Невозможно импортировать конфигурацию: %[1]v\x02Импортиро" +
	"ванные туннели\x14\x01\x81\x01\x00\x041\x02Импортированы туннели: %[1]d" +
	"\x051\x02Импортированы туннели: %[1]d\x024\x02Импортированный %[1]d тунн" +
	"ель\x001\x02Импортированы туннели: %[1]d\x14\x02\x80\x01\x04<\x02Импорт" +
	"ированы туннели: %[1]d из %[2]d\x05<\x02Импортированы туннели: %[1]d из" +
	" %[2]d\x02<\x02Импортированы туннели: %[1]d из %[2]d\x00<\x02Импортирова" +
	"ны туннели: %[1]d из %[2]d\x02Не удалось создать туннель\x14\x01\x81" +
	"\x01\x00\x04%\x02Удалить туннели: %[1]d\x05%\x02Удалить туннели: %[1]d" +
	"\x02$\x02Удалить %[1]d туннель\x00%\x02Удалить туннели: %[1]d\x14\x01" +
	"\x81\x01\x00\x04O\x02Вы уверены, что хотите удалить туннели: %[1]d?\x05O" +
	"\x02Вы уверены, что хотите удалить туннели: %[1]d?\x02N\x02Вы уверены, ч" +
	"то хотите удалить %[1]d туннель?\x00O\x02Вы уверены, что хотите удалить" +
	" туннели: %[1]d?\x02Удалить туннель ‘%[1]s’\x02Вы уверены, что хотите уд" +
	"алить '%[1]s' туннель?\x02%[1]s Данное действие невозможно отменить." +
	"\x02Не удалось удалить туннель\x02Невозможно удалить туннель: %[1]s\x02Н" +
	"е удалось удалить туннели\x14\x01\x81\x01\x00\x04;\x02туннелей не удало" +
	"сь удалить: %[1]d\x05;\x02туннелей не удалось удалить: %[1]d\x029\x02%[" +
	"1]d туннель не удалось удалить.\x00;\x02туннелей не удалось удалить: %[1" +
	"]d\x02Файлы конфигурации (*.zip, *.conf)|*.zip;*.conf|Все файлы (*.*)|*." +
	"*\x02Импорт туннелей из файла\x02Конфигурация ZIP файлов (*.zip)|*.zip" +
	"\x02Экспорт туннелей в zip-архив\x02%[1]s (неподписанная сборка, нет обн" +
	"овлений)\x02Ошибка выхода из WireGuard\x02Не удается выйти из сервиса и" +
	"з-за: %[1]v. Вы можете остановить WireGuard из менеджера служб.\x02Дост" +
	"упно обновление WireGuard. Настоятельно рекомендуем обновить приложение" +
	".\x02Статус: Ожидание пользователя\x02Обновить Сейчас\x02Статус: Ожидани" +
	"е обновления\x02Ошибка: %[1]v. Попробуйте еще раз.\x02Статус: Завершено" +
	"!\x02перед подключением\x02после подключения\x02перед отключением\x02пос" +
	"ле отключения\x02&Туннели"

var skIndex = []uint32{ // 181 elements
	// Entry 0 - 1F
	0x00000000, 0x00000006, 0x0000005e, 0x00000078,
	0x00000097, 0x000000d1, 0x000000d1, 0x00000109,
	0x0000014b, 0x000001b5, 0x000001ff, 0x00000205,
	0x0000022d, 0x0000022d, 0x00000265, 0x000002a6,
	0x000002e9, 0x0000032e, 0x00000339, 0x00000342,
	0x0000034f, 0x0000035c, 0x00000369, 0x00000376,
	0x00000383, 0x00000397, 0x000003bd, 0x000003e2,
	0x00000406, 0x0000042f, 0x0000043d, 0x0000044c,
	// Entry 20 - 3F
	0x0000046e, 0x00000487, 0x000004bc, 0x000004ef,
	0x00000505, 0x00000522, 0x00000541, 0x00000583,
	0x000005a4, 0x000005c9, 0x000005e9, 0x0000061c,
	0x00000630, 0x00000665, 0x00000689, 0x000006ac,
	0x000006ca, 0x000006e8, 0x000006eb, 0x000006ed,
	0x000006f9, 0x00000711, 0x00000711, 0x0000071b,
	0x0000072a, 0x00000730, 0x0000073f, 0x0000074c,
	0x0000075e, 0x0000076e, 0x00000773, 0x0000077b,
	// Entry 40 - 5F
	0x00000788, 0x00000788, 0x000007a3, 0x000007b8,
	0x000007c6, 0x000007df, 0x000007ff, 0x00000807,
	0x00000807, 0x00000811, 0x00000835, 0x00000857,
	0x00000876, 0x00000897, 0x000008a8, 0x000008ad,
	0x000008c3, 0x000008d2, 0x000008db, 0x000008ee,
	0x000008f9, 0x00000927, 0x00000927, 0x00000931,
	0x0000093a, 0x0000094a, 0x0000095b, 0x0000096f,
	0x00000997, 0x000009cd, 0x000009e0, 0x00000a0a,
	// Entry 60 - 7F
	0x00000a37, 0x00000a5a, 0x00000a97, 0x00000aa0,
	0x00000aac, 0x00000ab7, 0x00000ac5, 0x00000ad3,
	0x00000ad3, 0x00000ad3, 0x00000ad3, 0x00000ad3,
	0x00000ad3, 0x00000ad3, 0x00000ad3, 0x00000ad3,
	0x00000ae3, 0x00000ae3, 0x00000ae3, 0x00000ae3,
	0x00000ae3, 0x00000ae3, 0x00000ae3, 0x00000ae3,
	0x00000ae3, 0x00000af9, 0x00000b1d, 0x00000b28,
	0x00000b28, 0x00000b28, 0x00000b28, 0x00000b28,
	// Entry 80 - 9F
	0x00000b28, 0x00000b39, 0x00000b39, 0x00000b39,
	0x00000b39, 0x00000b39, 0x00000b39, 0x00000b39,
	0x00000b39, 0x00000b39, 0x00000b39, 0x00000b39,
	0x00000b39, 0x00000b39, 0x00000b39, 0x00000b39,
	0x00000b39, 0x00000b39, 0x00000b39, 0x00000b39,
	0x00000b39, 0x00000b39, 0x00000b39, 0x00000b39,
	0x00000b39, 0x00000b39, 0x00000b39, 0x00000b39,
	0x00000b39, 0x00000b39, 0x00000b39, 0x00000b39,
	// Entry A0 - BF
	0x00000b39, 0x00000b39, 0x00000b39, 0x00000b39,
	0x00000b39, 0x00000b39, 0x00000b39, 0x00000b39,
	0x00000b39, 0x00000b39, 0x00000b39, 0x00000b39,
	0x00000b39, 0x00000b39, 0x00000b39, 0x00000b39,
	0x00000b39, 0x00000b39, 0x00000b39, 0x00000b39,
	0x00000b39,
} // Size: 748 bytes

const skData string = "" + // Size: 2873 bytes
	"\x02Chyba\x02(bez argumentu): získať administrátorské práva a nainštalov" +
	"ať službu manažéra\x02Použitie: %[1]s [\x0a%[2]s]\x02Možnosti príkazovéh" +
	"o riadku\x02Nepodarilo sa zistiť, či proces beží pod WOW64: %[1]v\x02Nep" +
	"odarilo sa otvoriť token aktuálneho procesu: %[1]v\x02WireGuard môžu pou" +
	"žívať iba členovia Builtin skupiny %[1]s.\x02WireGuard je spustený, ale" +
	" používateľské rozhranie je prístupné iba členom Builtin skupiny %[1]s." +
	"\x02WireGuard ikona sa ani po 30 sekundách neobjavila na systémovej lišt" +
	"e.\x02Teraz\x02Systémové hodiny sa vrátili v čase!\x14\x01\x81\x01\x00" +
	"\x04\x0a\x02%[1]d dni\x05\x0b\x02%[1]d dní\x02\x0b\x02%[1]d deň\x00\x0b" +
	"\x02%[1]d dní\x14\x01\x81\x01\x00\x04\x0d\x02%[1]d hodiny\x05\x0d\x02%[1" +
	"]d hodín\x02\x0d\x02%[1]d hodina\x00\x0d\x02%[1]d hodín\x14\x01\x81\x01" +
	"\x00\x04\x0e\x02%[1]d minúty\x05\x0d\x02%[1]d minút\x02\x0e\x02%[1]d min" +
	"úta\x00\x0d\x02%[1]d minút\x14\x01\x81\x01\x00\x04\x0e\x02%[1]d sekundy" +
	"\x05\x0e\x02%[1]d sekúnd\x02\x0e\x02%[1]d sekunda\x00\x0e\x02%[1]d sekún" +
	"d\x02Pred %[1]s\x02%[1]d\u00a0B\x02%.2[1]f\u00a0KiB\x02%.2[1]f\u00a0MiB" +
	"\x02%.2[1]f\u00a0GiB\x02%.2[1]f\u00a0TiB\x02%[1]s: %[2]q\x02Neplatná adr" +
	"esa IP\x02Neplatná dĺžka sieťového prefixu\x02Koncovému bodu chýba číslo" +
	" portu\x02Neplatný hostiteľ koncového bodu\x02Medzi zátvorkami musí byť " +
	"IPv6 adresa\x02Neplatné MTU\x02Neplatný port\x02Neplatný perzistentný ke" +
	"epalive\x02Neplatný kľúč: %[1]v\x02Dekódované kľúče musia mať veľkosť 32" +
	" bajtov\x02Číslo musí mať hodnotu medzi 0 a 2^64-1: %[1]v\x02Dve čiarky " +
	"v poradí\x02Názov tunela nie je platný\x02Sekcia musí obsahovať čiaru" +
	"\x02Konfiguračný kľúč neobsahuje separátor (znamienko rovnosti)\x02Kľúč " +
	"musí obsahovať hodnotu\x02Neplatný kľúč sekcie [Interface]\x02Neplatný k" +
	"ľúč sekcie [Peer]\x02Rozhranie musí mať priradený súkromný kľúč\x02[neš" +
	"pecifikované]\x02Všetci peeri musia mať priradený verejný kľúč\x02Chyba " +
	"pri získavaní konfigurácie\x02Neplatný kľúč sekcie rozhrania\x02Verzia p" +
	"rotokolu musí byť 1\x02Neplatný kľúč peer sekcie\x02, \x02 \x02O WireGua" +
	"rd\x02Obrázok WireGuard loga\x02Zatvoriť\x02♥ a Darovat!\x02Stav:\x02a D" +
	"eaktivovať\x02a Aktivovať\x02Verejný kľúč:\x02Otvorený port:\x02MTU:\x02" +
	"Adresy:\x02Servery DNS:\x02Vopred zdieľaný kľúč:\x02Povolené IP adresy:" +
	"\x02Koncový bod:\x02Perzistentný keepalive:\x02Posledné spojenie (handsh" +
	"ake):\x02Prenos:\x02povolené\x02%[1]s prijatých, %[2]s odoslaných\x02Nep" +
	"odarilo sa zistiť stav tunela\x02Nepodarilo sa aktivovať tunel\x02Nepoda" +
	"rilo sa deaktivovať tunel\x02Rozhranie: %[1]s\x02Peer\x02Vytvoriť nový t" +
	"unel\x02Upraviť tunel\x02&Názov:\x02&Verejný kľúč:\x02(neznámy)\x02&Blok" +
	"ovať netunelovaný prenos (kill-switch)\x02&Uložiť\x02Zrušiť\x02&Konfigur" +
	"ácia:\x02Neplatný názov\x02Názov je povinný.\x02Názov tunela ‘%[1]s’ je" +
	" neplatný.\x02Nepodarilo sa pripraviť zoznam existujúcich tunelov\x02Tun" +
	"el už existuje\x02Tunel s názvom ‘%[1]s’ už existuje.\x02Nie je možné vy" +
	"tvoriť novú konfiguráciu\x02Nepodarilo sa zapísať do súboru\x02Súbor ‘%[" +
	"1]s’ už existuje.\x0a\x0aŽeláte si ho prepísať?\x02Aktívny\x02Aktivuje s" +
	"a\x02Neaktívny\x02Deaktivuje sa\x02Neznámy stav\x02&O WireGuard…\x02&Spr" +
	"avovať tunely…\x02&Importovať tunel(y) zo súboru…\x02U&končiť\x02WireGua" +
	"rd: %[1]s"

var slIndex = []uint32{ // 181 elements
	// Entry 0 - 1F
	0x00000000, 0x00000007, 0x00000058, 0x00000070,
	0x00000089, 0x000000c1, 0x00000111, 0x00000148,
	0x0000019a, 0x00000200, 0x00000244, 0x00000249,
	0x00000268, 0x000002a0, 0x000002d7, 0x0000030b,
	0x0000034b, 0x0000038f, 0x0000039b, 0x000003a4,
	0x000003b1, 0x000003be, 0x000003cb, 0x000003d8,
	0x000003e5, 0x000003f8, 0x0000041c, 0x0000043e,
	0x00000467, 0x0000048d, 0x0000049a, 0x000004a9,
	// Entry 20 - 3F
	0x000004cd, 0x000004e4, 0x00000515, 0x00000549,
	0x0000055e, 0x00000575, 0x00000590, 0x000005bf,
	0x000005da, 0x000005ff, 0x0000061f, 0x00000641,
	0x0000064f, 0x00000676, 0x00000696, 0x000006b8,
	0x000006d6, 0x000006f8, 0x000006fb, 0x000006fd,
	0x0000070a, 0x00000728, 0x000007a3, 0x000007a9,
	0x000007b7, 0x000007bf, 0x000007cc, 0x000007d7,
	0x000007e5, 0x000007f8, 0x000007fd, 0x00000806,
	// Entry 40 - 5F
	0x00000816, 0x0000081f, 0x00000835, 0x00000846,
	0x00000856, 0x00000872, 0x00000884, 0x0000088c,
	0x000008aa, 0x000008b5, 0x000008d2, 0x000008f6,
	0x00000914, 0x00000934, 0x00000943, 0x0000094b,
	0x0000095d, 0x00000969, 0x0000096f, 0x0000097e,
	0x00000988, 0x000009b2, 0x00000af2, 0x00000afa,
	0x00000b04, 0x00000b14, 0x00000b21, 0x00000b31,
	0x00000b53, 0x00000b83, 0x00000b95, 0x00000bc0,
	// Entry 60 - 7F
	0x00000be7, 0x00000c05, 0x00000c40, 0x00000c48,
	0x00000c54, 0x00000c5e, 0x00000c6c, 0x00000c7b,
	0x00000c83, 0x00000c8c, 0x00000c98, 0x00000cb0,
	0x00000cb5, 0x00000ccb, 0x00000d03, 0x00000d1d,
	0x00000d30, 0x00000d3e, 0x00000d6d, 0x00000d83,
	0x00000da0, 0x00000ddb, 0x00000df2, 0x00000e01,
	0x00000e0f, 0x00000e26, 0x00000e45, 0x00000e4c,
	0x00000e60, 0x00000e7e, 0x00000e94, 0x00000eb4,
	// Entry 80 - 9F
	0x00000ecc, 0x00000edd, 0x00000eeb, 0x00000efa,
	0x00000f13, 0x00000f36, 0x00000f7b, 0x00000f82,
	0x00000f89, 0x00000fa2, 0x00000fae, 0x00000fc6,
	0x00000fde, 0x00000fe8, 0x00001006, 0x0000101f,
	0x00001038, 0x0000105d, 0x0000108b, 0x000010be,
	0x000010e3, 0x00001109, 0x00001119, 0x0000117d,
	0x00001208, 0x00001229, 0x0000128e, 0x0000137b,
	0x00001396, 0x000013d1, 0x000013fc, 0x00001416,
	// Entry A0 - BF
	0x0000143e, 0x00001459, 0x0000150d, 0x0000155a,
	0x00001573, 0x0000159e, 0x000015bb, 0x000015ec,
	0x0000160c, 0x00001679, 0x000016cc, 0x000016e8,
	0x000016f6, 0x0000171d, 0x0000173f, 0x00001751,
	0x00001761, 0x0000176f, 0x00001781, 0x00001791,
	0x00001799,
} // Size: 748 bytes

const slData string = "" + // Size: 6041 bytes
	"\x02Napaka\x02(brez argumenta): povzdigni na skrbniške pravice in namest" +
	"i skrbniško storitev\x02Uporaba: %[1]s [\x0a%[2]s]\x02Možnosti ukazne vr" +
	"stice\x02Napaka pri določanju ali proces teče kot WOW64: %[1]v\x02Na tem" +
	"u računalniku morate uporabiti enako-arhitekturno različico WireGuarda." +
	"\x02Napaka pri odpiranju žetona trenutnega procesa: %[1]v\x02WireGuard l" +
	"ahko uporabljajo samo uporabniki, ki so člani vgrajene skupine %[1]s." +
	"\x02WireGuard je zagnan, vendar je up. vmesnik dostopen samo z namizij u" +
	"porabnikov članov skupine %[1]s.\x02Ikona WireGuarda se po 30 sekundah n" +
	"i pojavila v sistemski vrstici.\x02Zdaj\x02Sistemska ura prevrtena nazaj" +
	"!\x14\x01\x81\x01\x00\x04\x0b\x02%[1]d leta\x02\x0b\x02%[1]d leto\x03" +
	"\x0b\x02%[1]d leti\x00\x0a\x02%[1]d let\x14\x01\x81\x01\x00\x04\x0a\x02%" +
	"[1]d dni\x02\x0a\x02%[1]d dan\x03\x0c\x02%[1]d dneva\x00\x0a\x02%[1]d dn" +
	"i\x14\x01\x81\x01\x00\x04\x0a\x02%[1]d ure\x02\x0a\x02%[1]d uro\x03\x0a" +
	"\x02%[1]d uri\x00\x09\x02%[1]d ur\x14\x01\x81\x01\x00\x04\x0d\x02%[1]d m" +
	"inute\x02\x0d\x02%[1]d minuto\x03\x0d\x02%[1]d minuti\x00\x0c\x02%[1]d m" +
	"inut\x14\x01\x81\x01\x00\x04\x0e\x02%[1]d sekunde\x02\x0e\x02%[1]d sekun" +
	"do\x03\x0e\x02%[1]d sekundi\x00\x0d\x02%[1]d sekund\x02%[1]s nazaj\x02%[" +
	"1]d\u00a0B\x02%.2[1]f\u00a0KiB\x02%.2[1]f\u00a0MiB\x02%.2[1]f\u00a0GiB" +
	"\x02%.2[1]f\u00a0TiB\x02%[1]s: %[2]q\x02Napačen naslov IP\x02Napačna dol" +
	"žina predpone omrežja\x02Pri končni točki manjkajo vrata\x02Pri končni " +
	"točki je gostitelj napačen\x02Oklepaji morajo vsebovati naslov IPv6\x02N" +
	"apačen MTU\x02Napačna vrata\x02Napačno trajno ohranjanje povezave\x02Nap" +
	"ačen ključ: %[1]v\x02Dekodirani ključi morajo biti natanko 32 bajtov\x02" +
	"Številka mora biti število med 0 in 2^64-1: %[1]v\x02Dve zaporedni veji" +
	"ci\x02Ime tunela ni veljavno\x02Vrstica mora biti v odseku\x02Ključu v k" +
	"onfiguraciji manjka ločilo enačaj\x02Ključ mora imeti vrednost\x02Napače" +
	"n ključ za odsek [Interface]\x02Napačen ključ za odsek [Peer]\x02Vmesnik" +
	" mora imeti zasebni ključ\x02[ni navedeno]\x02Vsi vrstniki morajo imeti " +
	"javni ključ\x02Napaka pri branju konfiguracije\x02Napačen ključ za odsek" +
	" vmesnika\x02Verzija protokola mora biti 1\x02Napačen ključ za odsek vrs" +
	"tnika\x02, \x02 \x02O WireGuardu\x02Slika WireGuardovega logotipa\x02Ver" +
	"zija aplikacije: %[1]s\x0aVerzija wireguard-go: %[2]s\x0aVerzija Go: %[3" +
	"]s-%[4]s\x0aOperacijski sistem: %[5]s\x0aArhitektura: %[6]s\x02Zapri\x02" +
	"♥ &Doniraj!\x02Status:\x02&Deaktiviraj\x02&Aktiviraj\x02Javni ključ:" +
	"\x02Vrata poslušanja:\x02MTU:\x02Naslovi:\x02Strežniki DNS:\x02Skripta:" +
	"\x02Ključ v skupni rabi:\x02Dovoljeni IP-ji:\x02Končna točka:\x02Trajno " +
	"ohranjanje povezave:\x02Zadnje rokovanje:\x02Prenos:\x02onemogočeno, zar" +
	"adi politike\x02omogočeno\x02%[1]s prejeto, %[2]s poslano\x02Napaka pri " +
	"določanju stanja tunela\x02Napaka pri aktiviranju tunela\x02Napaka pri d" +
	"eaktiviranju tunela\x02Vmesnik: %[1]s\x02Vrstnik\x02Ustvari nov tunel" +
	"\x02Uredi tunel\x02&Ime:\x02&Javni ključ:\x02(neznano)\x02&Blokiraj prom" +
	"et izven tunela (varovalka)\x02Kadar ima konfiguracija natanko enega vrs" +
	"tnika in njegov spisek dovoljenih IP-jev vsebuje vsaj enega izmed 0.0.0." +
	"0/0 ali ::/0, bo storitev tunela vzpostavila pravila požarnega zidu, ki " +
	"bodo blokirala ves promet, ki ni niti za niti iz vmesnika tunela oz. za " +
	"napačen strežnik DNS, s posebnimi izjemami za DHCP and NDP.\x02&Shrani" +
	"\x02Prekliči\x02&Konfiguracija:\x02Napačno ime\x02Ime je obvezno.\x02Ime" +
	" tunela »%[1]s« ni veljavno.\x02Napaka pri pripravi seznama obstoječih t" +
	"unelov\x02Tunel že obstaja\x02Drug tunel z imenom »%[1]s« že obstaja." +
	"\x02Napaka pri izdelavi nove konfiguracije\x02Napaka pri pisanju v datot" +
	"eko\x02Datoteka »%[1]s« že obstaja.\x0a\x0aAli jo želite prepisati?\x02A" +
	"ktivno\x02Se aktivira\x02Neaktivno\x02Se deaktivira\x02Neznano stanje" +
	"\x02Dnevnik\x02&Kopiraj\x02&Izberi vse\x02&Shrani v datoteko\u00a0…\x02Č" +
	"as\x02Sporočilo v dnevniku\x02Tekstovne datoteke (*.txt)|*.txt|Vse datot" +
	"eke (*.*)|*.*\x02Izvozi dnevnik v datoteko\x02O WireGu&ardu\u00a0…\x02Na" +
	"paka tunela\x02%[1]s\x0a\x0aDodatne informacije najdete v dnevniku.\x02%" +
	"[1]s (neposodobljen)\x02Napaka zaznavanja WireGuarda\x02Čakanje, da se p" +
	"ojavi WireGuardovo okno, ni možno: %[1]v\x02WireGuard: Deaktiviran\x02St" +
	"atus: Neznan\x02Naslovi: Brez\x02&Upravljaj tunele\u00a0…\x02&Uvozi tune" +
	"l(e) iz datoteke…\x02I&zhod\x02WireGuard aktiviran\x02Tunel %[1]s je bil" +
	" aktiviran.\x02WireGuard deaktiviran\x02Tunel %[1]s je bil deaktiviran." +
	"\x02Napaka tunela WireGuard\x02WireGuard: %[1]s\x02Status: %[1]s\x02Nasl" +
	"ovi: %[1]s\x02Na voljo je posodobitev!\x02Posodobitev WireGuarda je na v" +
	"oljo\x02Posodobitev WireGuarda je na voljo. Svetujemo posodobitev čim pr" +
	"ej.\x02Tuneli\x02&Uredi\x02Dodaj &prazen tunel\u00a0…\x02Dodaj tunel\x02" +
	"Odstrani izbrane tunele\x02Izvozi vse tunele v zip\x02&Preklopi\x02Izvoz" +
	"i vse tunele v &zip\u00a0…\x02Uredi &izbran tunel\u00a0…\x02Odst&rani iz" +
	"brane tunele\x02ni najdenih konfiguracijskih datotek\x02Napaka pri uvozu" +
	" izbrane konfiguracije: %[1]v\x02Napaka pri preštevanju obstoječih tunel" +
	"ov: %[1]v\x02Tunel z imenom »%[1]s« že obstaja\x02Napaka pri uvozu konfi" +
	"guracije: %[1]v\x02Uvoženi tuneli\x14\x01\x81\x01\x00\x04\x16\x02Uvoženi" +
	" %[1]d tuneli\x02\x14\x02Uvožen %[1]d tunel\x03\x16\x02Uvožena %[1]d tun" +
	"ela\x00\x17\x02Uvoženo %[1]d tunelov\x14\x02\x80\x01\x04 \x02Uvoženi %[1" +
	"]d od %[2]d tunelov\x02\x1f\x02Uvožen %[1]d od %[2]d tunelov\x03 \x02Uvo" +
	"žena %[1]d od %[2]d tunelov\x00 \x02Uvoženo %[1]d od %[2]d tunelov\x02T" +
	"unela ni bilo mogoče ustvariti\x14\x01\x81\x01\x00\x04\x16\x02Izbriši %[" +
	"1]d tunele\x02\x15\x02Izbriši %[1]d tunel\x03\x16\x02Izbriši %[1]d tunel" +
	"a\x00\x17\x02Izbriši %[1]d tunelov\x14\x01\x81\x01\x00\x048\x02Ali ste p" +
	"repričani, da želite izbrisati %[1]d tunele?\x027\x02Ali ste prepričani," +
	" da želite izbrisati %[1]d tunel?\x038\x02Ali ste prepričani, da želite " +
	"izbrisati %[1]d tunela?\x009\x02Ali ste prepričani, da želite izbrisati " +
	"%[1]d tunelov?\x02Izbriši tunel ‘%[1]s’\x02Ali ste prepričani, da želite" +
	" izbrisati tunel »%[1]s«?\x02%[1]s Tega dejanja ne morete razveljaviti." +
	"\x02Napaka pri izbrisu tunela\x02Napaka pri odstranjevanju tunela: %[1]s" +
	"\x02Napaka pri izbrisu tunelov\x14\x01\x81\x01\x00\x04*\x02%[1]d tunelov" +
	" ni bilo mogoče odstraniti.\x02)\x02%[1]d tunela ni bilo mogoče odstrani" +
	"ti.\x03*\x02%[1]d tunelov ni bilo mogoče odstraniti.\x00*\x02%[1]d tunel" +
	"ov ni bilo mogoče odstraniti.\x02Konfiguracijske datoteke (*.zip, *.conf" +
	")|*.zip;*.conf|Vse datoteke (*.*)|*.*\x02Uvozi tunele iz datoteke\x02Kon" +
	"figuracijske datoteke ZIP (*.zip)|*.zip\x02Izvozi tunele v datoteko zip" +
	"\x02%[1]s (nepodpisane različice, brez posodobitev)\x02Napaka pri izhodu" +
	" iz WireGuarda\x02Storitve ni bilo mogoče zaustaviti, ker: %[1]v. Poskus" +
	"ite zaustaviti WireGuard z uporabo programa Storitve.\x02Posodobitev Wir" +
	"eGuarda je na voljo. Zelo priporočamo posodobitev brez odlašanja.\x02Sta" +
	"tus: Čaka na uporabnika\x02Posodobi zdaj\x02Status: Čaka na servis za po" +
	"sodobitev\x02Napaka: %[1]v. Poskusite ponovno.\x02Status: Končano!\x02pr" +
	"ed-aktivacijo\x02po-aktivaciji\x02pred-deaktivacijo\x02po-deaktivaciji" +
	"\x02&Tuneli"

var ukIndex = []uint32{ // 181 elements
	// Entry 0 - 1F
	0x00000000, 0x0000000f, 0x0000000f, 0x0000000f,
	0x00000042, 0x0000009c, 0x0000009c, 0x000000f5,
	0x00000191, 0x00000213, 0x0000026a, 0x00000275,
	0x000002c8, 0x000002c8, 0x000002c8, 0x000002c8,
	0x000002c8, 0x000002c8, 0x000002d7, 0x000002e0,
	0x000002ed, 0x000002fa, 0x00000307, 0x00000314,
	0x00000314, 0x00000335, 0x00000371, 0x000003ac,
	0x000003e4, 0x0000041f, 0x00000436, 0x00000452,
	// Entry 20 - 3F
	0x00000452, 0x00000475, 0x00000475, 0x00000475,
	0x00000494, 0x00000494, 0x000004da, 0x00000535,
	0x00000567, 0x0000059f, 0x000005d2, 0x00000619,
	0x0000063e, 0x0000068a, 0x000006cc, 0x00000713,
	0x0000074d, 0x0000074d, 0x0000074d, 0x0000074d,
	0x0000075e, 0x0000078e, 0x0000078e, 0x0000079d,
	0x000007bc, 0x000007ca, 0x000007e4, 0x000007fa,
	0x00000817, 0x00000817, 0x00000817, 0x00000817,
	// Entry 40 - 5F
	0x00000817, 0x00000817, 0x00000817, 0x00000817,
	0x00000817, 0x00000817, 0x00000817, 0x00000817,
	0x00000817, 0x00000817, 0x00000817, 0x00000817,
	0x00000817, 0x00000817, 0x00000817, 0x00000817,
	0x00000817, 0x00000817, 0x00000817, 0x00000817,
	0x00000817, 0x00000817, 0x00000817, 0x00000817,
	0x00000817, 0x00000817, 0x00000817, 0x00000817,
	0x00000817, 0x00000817, 0x00000817, 0x00000817,
	// Entry 60 - 7F
	0x00000817, 0x00000817, 0x00000817, 0x00000817,
	0x00000817, 0x00000817, 0x00000817, 0x00000817,
	0x00000817, 0x00000817, 0x00000817, 0x00000817,
	0x00000817, 0x00000817, 0x00000817, 0x00000817,
	0x00000817, 0x00000817, 0x00000817, 0x00000817,
	0x00000817, 0x00000817, 0x00000817, 0x00000817,
	0x00000817, 0x00000817, 0x00000817, 0x00000817,
	0x00000817, 0x00000817, 0x00000817, 0x00000817,
	// Entry 80 - 9F
	0x00000817, 0x00000817, 0x00000817, 0x00000817,
	0x00000817, 0x00000817, 0x00000817, 0x00000817,
	0x00000817, 0x00000817, 0x00000817, 0x00000817,
	0x00000817, 0x00000817, 0x00000817, 0x00000817,
	0x00000817, 0x00000817, 0x00000817, 0x00000817,
	0x00000817, 0x00000817, 0x00000817, 0x00000817,
	0x00000817, 0x00000817, 0x00000817, 0x00000817,
	0x00000817, 0x00000817, 0x00000817, 0x00000817,
	// Entry A0 - BF
	0x00000817, 0x00000817, 0x00000817, 0x00000817,
	0x00000817, 0x00000817, 0x00000817, 0x00000817,
	0x00000817, 0x00000817, 0x00000817, 0x00000817,
	0x00000817, 0x00000817, 0x00000817, 0x00000817,
	0x00000817, 0x00000817, 0x00000817, 0x00000817,
	0x00000817,
} // Size: 748 bytes

const ukData string = "" + // Size: 2071 bytes
	"\x02Помилка\x02Параметри командного рядка\x02Неможливо визначити, чи пра" +
	"цює процес під WOW64: %[1]v\x02Не вдалося відкрити токен поточного проц" +
	"есу: %[1]v\x02WireGuard може бути використаний тільки користувачами, як" +
	"і є членами вбудованих %[1]s груп.\x02WireGuard запущено, але UI доступ" +
	"ний лише з комп\x22ютерів вбудованої %[1]s групи.\x02Значок системи Wir" +
	"eGuard не з'явився через 30 секунд.\x02Зараз\x02Системний годинник налаш" +
	"тований некоректно!\x02%[1]s тому\x02%[1]d Б\x02%.2[1]f КБ\x02%.2[1]f М" +
	"Б\x02%.2[1]f ГБ\x02%.2[1]f ТБ\x02Недійсна IP-адреса\x02Невірна довжина " +
	"префіксу мережі\x02Відсутній порт з кінцевої точки\x02Недійсний хост кі" +
	"нцевої точки\x02Дужки повинні містити адресу IPv6\x02Недійсний MTU\x02Н" +
	"едійсний порт\x02Недійсний ключ: %[1]v\x02Дві коми поспіль\x02Рядок пов" +
	"инен бути вказаним у розділі\x02Ключ конфігурації відсутній роздільник " +
	"рівності\x02Ключ повинен мати значення\x02Хибний ключ для [Interface] р" +
	"озділу\x02Хибний ключ для [Peer] розділу\x02Інтерфейс повинен мати особ" +
	"истий ключ\x02[жодного не вказано]\x02Всі учасники повинні мати відкрит" +
	"і ключі\x02Помилка при отриманні конфігурації\x02Недійсний ключ для роз" +
	"ділу інтерфейсу\x02Версія протоколу повинна бути 1\x02Про WireGuard\x02" +
	"Зображення логотипу WireGuard\x02Закрити\x02♥ &Пожертвувати!\x02Статус:" +
	"\x02&Деактивувати\x02&Активувати\x02Відкритий ключ:"

var viIndex = []uint32{ // 181 elements
	// Entry 0 - 1F
	0x00000000, 0x00000006, 0x00000006, 0x00000006,
	0x00000006, 0x00000006, 0x00000006, 0x00000006,
	0x00000006, 0x00000006, 0x00000006, 0x00000011,
	0x00000011, 0x00000023, 0x00000036, 0x00000049,
	0x0000005c, 0x0000006f, 0x0000007e, 0x0000007e,
	0x0000007e, 0x0000007e, 0x0000007e, 0x0000007e,
	0x0000007e, 0x000000a0, 0x000000a0, 0x000000a0,
	0x000000a0, 0x000000a0, 0x000000a0, 0x000000c0,
	// Entry 20 - 3F
	0x000000c0, 0x000000c0, 0x000000c0, 0x000000c0,
	0x000000c0, 0x000000db, 0x000000db, 0x000000db,
	0x000000db, 0x000000db, 0x000000db, 0x000000db,
	0x000000db, 0x000000db, 0x000000db, 0x000000db,
	0x000000db, 0x000000db, 0x000000db, 0x000000db,
	0x000000f5, 0x00000104, 0x00000104, 0x0000010b,
	0x0000010b, 0x0000011a, 0x0000011a, 0x0000011a,
	0x0000011a, 0x0000011a, 0x0000011a, 0x0000011a,
	// Entry 40 - 5F
	0x0000011a, 0x0000011a, 0x0000011a, 0x0000011a,
	0x00000129, 0x00000129, 0x00000129, 0x00000129,
	0x00000129, 0x0000013b, 0x00000155, 0x00000181,
	0x0000019f, 0x000001c0, 0x000001c0, 0x000001d3,
	0x000001dd, 0x000001ef, 0x000001ef, 0x000001ef,
	0x000001ef, 0x000001ef, 0x000001ef, 0x000001ef,
	0x000001f5, 0x000001f5, 0x0000020c, 0x00000224,
	0x0000024a, 0x0000026b, 0x00000280, 0x000002ad,
	// Entry 60 - 7F
	0x000002ad, 0x000002ad, 0x000002ad, 0x000002ad,
	0x000002ad, 0x000002ad, 0x000002ad, 0x000002ad,
	0x000002ad, 0x000002ad, 0x000002ad, 0x000002ad,
	0x000002ad, 0x000002ad, 0x000002ad, 0x000002ad,
	0x000002ad, 0x000002ad, 0x000002ad, 0x000002ad,
	0x000002ad, 0x000002ad, 0x000002ad, 0x000002ad,
	0x000002ad, 0x000002ad, 0x000002ad, 0x000002ad,
	0x000002ad, 0x000002ad, 0x000002ad, 0x000002ad,
	// Entry 80 - 9F
	0x000002ad, 0x000002ad, 0x000002ad, 0x000002ad,
	0x000002ad, 0x000002ad, 0x000002ad, 0x000002ad,
	0x000002ad, 0x000002ad, 0x000002ad, 0x000002ad,
	0x000002ad, 0x000002ad, 0x000002ad, 0x000002ad,
	0x000002ad, 0x000002ad, 0x000002ad, 0x000002ad,
	0x000002ad, 0x000002ad, 0x000002ad, 0x000002ad,
	0x000002ad, 0x000002ad, 0x000002ad, 0x000002ad,
	0x000002ad, 0x000002ad, 0x000002ad, 0x000002ad,
	// Entry A0 - BF
	0x000002ad, 0x000002ad, 0x000002ad, 0x000002ad,
	0x000002ad, 0x000002ad, 0x000002ad, 0x000002ad,
	0x000002ad, 0x000002ad, 0x000002ad, 0x000002ad,
	0x000002ad, 0x000002ad, 0x000002ad, 0x000002ad,
	0x000002ad, 0x000002ad, 0x000002ad, 0x000002ad,
	0x000002ad,
} // Size: 748 bytes

const viData string = "" + // Size: 685 bytes
	"\x02Lỗi\x02Vừa xong\x14\x01\x81\x01\x00\x00\x0b\x02%[1]d năm\x14\x01\x81" +
	"\x01\x00\x00\x0c\x02%[1]d ngày\x14\x01\x81\x01\x00\x00\x0c\x02%[1]d giờ" +
	"\x14\x01\x81\x01\x00\x00\x0c\x02%[1]d phút\x14\x01\x81\x01\x00\x00\x0c" +
	"\x02%[1]d giây\x02%[1]s trước\x02Địa chỉ IP không hợp lệ\x02Cổng (port) " +
	"không hợp lệ\x02Tên VPN không hợp lệ\x02Thông tin về WireGuard\x02Logo W" +
	"ireGuard\x02Đóng\x02Trạng thái:\x02Đầu cuối:\x02đã kích hoạt\x02Nhận %[1" +
	"]s, gứi %[2]s\x02Không thể xác định tình trạng VPN\x02Không thể kích hoạ" +
	"t VPN\x02Không thể vô hiệu hóa VPN\x02Mạng ngang hàng\x02Tạo VPN\x02Chỉn" +
	"h sửa VPN\x02Huỷ\x02Tên không hợp lệ\x02Yêu cầu nhập tên.\x02Tên VPN ‘%[" +
	"1]s' không hợp lệ.\x02Không thể liệt kê các VPN\x02VPN đã tồn tại\x02Đã " +
	"tồn tại VPN với tên ‘%[1]s’."

var zh_CNIndex = []uint32{ // 181 elements
	// Entry 0 - 1F
	0x00000000, 0x00000007, 0x00000030, 0x00000047,
	0x00000057, 0x0000008b, 0x000000c9, 0x000000ef,
	0x00000134, 0x0000018e, 0x000001c5, 0x000001cc,
	0x000001e5, 0x000001f6, 0x00000207, 0x0000021b,
	0x0000022f, 0x00000240, 0x0000024a, 0x00000252,
	0x0000025f, 0x0000026c, 0x00000279, 0x00000286,
	0x00000293, 0x000002a2, 0x000002bb, 0x000002dd,
	0x00000304, 0x0000032c, 0x00000337, 0x00000344,
	// Entry 20 - 3F
	0x0000035d, 0x00000375, 0x0000039f, 0x000003cd,
	0x000003e6, 0x000003f9, 0x00000415, 0x0000043a,
	0x0000044d, 0x0000046c, 0x00000486, 0x000004a2,
	0x000004ae, 0x000004d0, 0x000004e6, 0x000004ff,
	0x00000517, 0x00000530, 0x00000534, 0x00000536,
	0x00000547, 0x0000055d, 0x000005c7, 0x000005ce,
	0x000005df, 0x000005e7, 0x000005f3, 0x000005ff,
	0x00000607, 0x00000615, 0x0000061a, 0x00000622,
	// Entry 40 - 5F
	0x00000631, 0x00000639, 0x0000064a, 0x00000658,
	0x00000660, 0x00000674, 0x00000688, 0x00000690,
	0x000006af, 0x000006b9, 0x000006d4, 0x000006ed,
	0x00000700, 0x00000719, 0x00000727, 0x0000072e,
	0x0000073e, 0x0000074b, 0x00000758, 0x00000765,
	0x0000076e, 0x0000079d, 0x00000873, 0x0000087f,
	0x00000886, 0x00000893, 0x000008a0, 0x000008b6,
	0x000008d4, 0x000008ed, 0x000008fd, 0x0000091e,
	// Entry 60 - 7F
	0x00000937, 0x0000094a, 0x00000985, 0x0000098f,
	0x0000099c, 0x000009a6, 0x000009b3, 0x000009ba,
	0x000009c1, 0x000009cd, 0x000009d9, 0x000009e8,
	0x000009ef, 0x000009fc, 0x00000a2e, 0x00000a3b,
	0x00000a54, 0x00000a61, 0x00000a87, 0x00000a99,
	0x00000ab0, 0x00000adb, 0x00000af0, 0x00000aff,
	0x00000b0b, 0x00000b20, 0x00000b3e, 0x00000b4a,
	0x00000b5e, 0x00000b7c, 0x00000b90, 0x00000bb4,
	// Entry 80 - 9F
	0x00000bcb, 0x00000bdc, 0x00000bea, 0x00000bf8,
	0x00000c08, 0x00000c19, 0x00000c5b, 0x00000c62,
	0x00000c6e, 0x00000c86, 0x00000c93, 0x00000ca6,
	0x00000cc9, 0x00000ce1, 0x00000d0c, 0x00000d27,
	0x00000d3f, 0x00000d55, 0x00000d6f, 0x00000d8f,
	0x00000dbc, 0x00000dd6, 0x00000de3, 0x00000e04,
	0x00000e3a, 0x00000e4d, 0x00000e6b, 0x00000e9e,
	0x00000eb6, 0x00000ee0, 0x00000efe, 0x00000f11,
	// Entry A0 - BF
	0x00000f2b, 0x00000f3e, 0x00000f65, 0x00000fa6,
	0x00000fbc, 0x00000fd7, 0x00000ffa, 0x00001027,
	0x00001042, 0x000010a3, 0x000010db, 0x000010f0,
	0x000010fd, 0x00001118, 0x00001135, 0x00001147,
	0x00001151, 0x0000115b, 0x00001165, 0x0000116f,
	0x0000117b,
} // Size: 748 bytes

const zh_CNData string = "" + // Size: 4475 bytes
	"\x02错误\x02(无参数): 提升并安装管理服务\x02用法: %[1]s [\x0a%[2]s]\x02命令行选项\x02无法确定该进程是" +
	"否在WOW64下运行: %[1]v\x02您必须在此计算机上使用原生版本的 WireGuard。\x02无法打开当前进程令牌: %[1]v" +
	"\x02WireGuard 可能只能被内建的 %[1]s 小组中的成员使用。\x02WireGuard 正在运行，但用户界面只能从内建的 %[1" +
	"]s 小组的桌面访问。\x02WireGuard 系统托盘图标在30秒后没有出现。\x02刚刚\x02系统时间倒退了！\x14\x01\x81" +
	"\x01\x00\x00\x0a\x02%[1]d 年\x14\x01\x81\x01\x00\x00\x0a\x02%[1]d 天\x14" +
	"\x01\x81\x01\x00\x00\x0d\x02%[1]d 小时\x14\x01\x81\x01\x00\x00\x0d\x02%[1]" +
	"d 分钟\x14\x01\x81\x01\x00\x00\x0a\x02%[1]d 秒\x02%[1]s 前\x02%[1]d B\x02%.2" +
	"[1]f\u00a0KiB\x02%.2[1]f\u00a0MiB\x02%.2[1]f\u00a0GiB\x02%.2[1]f\u00a0Ti" +
	"B\x02%[1]s: %[2]q\x02IP地址无效\x02网络前缀长度无效\x02对端 (endpoint) 中缺少端口\x02对端主机名 " +
	"(endpoint host) 无效\x02方括号中应包含一个 IPv6 地址\x02MTU 无效\x02端口无效\x02连接保活间隔无效" +
	"\x02无效的密钥：%[1]v\x02解码后的密钥长度必须为32字节\x02数值必须介于 0 至 2^64-1 之间: %[1]v\x02一行中" +
	"有两个逗号\x02隧道名称无效\x02行必须出现在段落中\x02配置项必须要有一个等于号\x02必须有一个值\x02[Interface] " +
	"段落的键无效\x02[Peer] 段落的键无效\x02接口必须有一个私钥\x02[未指定]\x02所有节点必须拥有公钥。\x02获取配置时出" +
	"错\x02接口段落的键无效\x02协议版本必须为 1\x02节点段落的键无效\x02、\x02 \x02关于 WireGuard\x02Wi" +
	"reGuard logo 图片\x02应用版本: %[1]s\x0aGo 后端版本: %[2]s\x0aGo 语言版本: %[3]s-%[4]s" +
	"\x0a操作系统: %[5]s\x0a架构: %[6]s\x02关闭\x02♥ 捐助! (&D)\x02状态:\x02断开 (&D)\x02连接" +
	" (&A)\x02公钥:\x02监听端口:\x02MTU:\x02地址:\x02DNS 服务器:\x02脚本:\x02预共享密钥:\x02允许的" +
	" IP:\x02对端:\x02连接保活间隔:\x02上次握手时间:\x02流量:\x02已禁用（依管理策略）\x02已启用\x02接收 %[1]" +
	"s, 发送 %[2]s\x02无法确认隧道状态\x02无法连接隧道\x02无法断开隧道连接\x02接口: %[1]s\x02节点\x02创建新隧" +
	"道\x02编辑隧道\x02名称 (&N):\x02公钥 (&P):\x02(未知)\x02拦截未经隧道的流量 (kill-switch) (" +
	"&B)\x02只有一个节点，且该节点允许的 IP 中包含 0.0.0.0/0 或 ::/0 时，使用防火墙规则拦截所有未通过隧道，或是发往错误的" +
	" DNS 服务器的流量。DHCP 和 NDP 流量不受影响。\x02保存 (&S)\x02取消\x02配置 (&C):\x02名称无效\x02必" +
	"须输入名称。\x02隧道名「%[1]s」无效。\x02无法列出现有隧道\x02隧道已存在\x02隧道名「%[1]s」已存在。\x02无法创建" +
	"新的配置\x02写入文件失败\x02文件「%[1]s」已存在。\x0a\x0a您确定要覆盖它吗？\x02已连接\x02正在连接\x02已断开" +
	"\x02正在断开\x02未知\x02日志\x02复制 (&C)\x02全选 (&A)\x02导出… (&S)\x02时间\x02日志消息\x02" +
	"文本文件 (*.txt)|*.txt|所有文件 (*.*)|*.*\x02导出日志\x02关于 WireGuard… (&A)\x02隧道错" +
	"误\x02%[1]s\x0a\x0a更多信息请查看日志。\x02%[1]s (已过时)\x02WireGuard 检测错误\x02无法等待 " +
	"WireGuard 窗口出现: %[1]v\x02WireGuard: 已断开\x02状态: 未知\x02地址: 无\x02管理隧道… (&M)" +
	"\x02从文件导入隧道… (&I)\x02退出 (&E)\x02WireGuard 已连接\x02隧道「%[1]s」已连接。\x02WireGu" +
	"ard 已断开\x02隧道「%[1]s」已断开连接。\x02WireGuard 隧道错误\x02WireGuard: %[1]s\x02状态: " +
	"%[1]s\x02地址: %[1]s\x02发现更新！\x02WireGuard 更新\x02新的 WireGuard 版本发布了。强烈建议您现" +
	"在安装。\x02隧道\x02编辑 (&E)\x02新建空隧道… (&E)\x02新建隧道\x02删除所选隧道\x02导出所有隧道 (ZIP " +
	"压缩包)\x02切换连接状态 (&T)\x02导出所有隧道 (ZIP 压缩包)… (&Z)\x02编辑所选隧道… (&E)\x02删除所选隧" +
	"道 (&R)\x02未找到配置文件\x02无法导入配置: %[1]v\x02无法列出现有隧道: %[1]v\x02另一个同名的隧道「%[1]" +
	"s」已存在\x02无法导入配置: %[1]v\x02导入隧道\x14\x01\x81\x01\x00\x00\x1a\x02导入了 %[1]d " +
	"个隧道\x14\x02\x80\x01\x000\x02导入了 %[2]d 个隧道中的 %[1]d 个隧道\x02无法创建隧道\x14" +
	"\x01\x81\x01\x00\x00\x17\x02删除 %[1]d 个隧道\x14\x01\x81\x01\x00\x00,\x02您确定" +
	"要删除这 %[1]d 个隧道吗？\x02删除隧道「%[1]s」\x02您确定要删除隧道「%[1]s」吗？\x02%[1]s此操作无法撤销。" +
	"\x02无法删除隧道\x02无法删除隧道: %[1]s\x02无法删除隧道\x14\x01\x81\x01\x00\x00 \x02无法删除 %" +
	"[1]d 个隧道。\x02配置文件 (*.zip, *.conf)|*.zip;*.conf|所有文件 (*.*)|*.*\x02从文件导入隧道" +
	"\x02配置文件 (*.zip)|*.zip\x02导出配置文件 (ZIP 压缩包)\x02%[1]s (未签名版本，禁用自动更新)\x02退出" +
	" WireGuard 时出错\x02无法停止服务: %[1]v。您可能需要在服务管理器中手动停止 WireGuard 服务。\x02发现新版 W" +
	"ireGuard。强烈建议您现在安装。\x02状态: 等待用户\x02立即更新\x02状态: 等待更新服务\x02错误: %[1]v。请重试。" +
	"\x02状态: 完成！\x02连接前\x02连接后\x02断开前\x02断开后\x02隧道 (&T)"

var zh_TWIndex = []uint32{ // 181 elements
	// Entry 0 - 1F
	0x00000000, 0x00000007, 0x00000037, 0x00000056,
	0x00000066, 0x000000a4, 0x000000a4, 0x000000d5,
	0x00000118, 0x0000017d, 0x000001b9, 0x000001c6,
	0x000001df, 0x000001f0, 0x00000201, 0x00000215,
	0x00000229, 0x0000023a, 0x00000244, 0x0000024d,
	0x0000025a, 0x00000267, 0x00000274, 0x00000281,
	0x00000290, 0x000002a4, 0x000002c6, 0x000002e5,
	0x000002ff, 0x00000327, 0x00000335, 0x00000345,
	// Entry 20 - 3F
	0x0000036b, 0x00000384, 0x000003a3, 0x000003cc,
	0x000003e5, 0x000003f8, 0x00000414, 0x0000043c,
	0x00000452, 0x00000471, 0x0000048b, 0x000004b1,
	0x000004bd, 0x000004df, 0x000004fb, 0x00000518,
	0x00000530, 0x00000548, 0x0000054c, 0x0000054e,
	0x0000055f, 0x00000575, 0x00000575, 0x0000057c,
	0x0000058f, 0x00000596, 0x000005a8, 0x000005b4,
	0x000005bb, 0x000005c5, 0x000005c9, 0x000005d0,
	// Entry 40 - 5F
	0x000005de, 0x000005de, 0x000005ee, 0x000005fe,
	0x00000608, 0x00000619, 0x0000062c, 0x00000633,
	0x00000633, 0x0000063d, 0x0000065f, 0x00000678,
	0x0000068b, 0x000006a4, 0x000006b3, 0x000006ba,
	0x000006ca, 0x000006dd, 0x000006e9, 0x000006f5,
	0x000006fe, 0x00000733, 0x00000733, 0x0000073f,
	0x00000746, 0x00000752, 0x00000762, 0x00000778,
	0x0000079c, 0x000007b5, 0x000007c5, 0x000007e6,
	// Entry 60 - 7F
	0x00000805, 0x00000818, 0x0000084b, 0x00000855,
	0x00000865, 0x00000875, 0x00000885, 0x0000088c,
	0x00000893, 0x0000089f, 0x000008ab, 0x000008ba,
	0x000008c1, 0x000008ce, 0x000008fd, 0x0000090d,
	0x00000923, 0x00000930, 0x0000095f, 0x00000974,
	0x0000098c, 0x000009b9, 0x000009cf, 0x000009df,
	0x000009ec, 0x000009fe, 0x00000a16, 0x00000a22,
	0x00000a36, 0x00000a51, 0x00000a6b, 0x00000a8f,
	// Entry 80 - 9F
	0x00000aa6, 0x00000ab8, 0x00000ac7, 0x00000ac7,
	0x00000ace, 0x00000adf, 0x00000b38, 0x00000b3f,
	0x00000b4b, 0x00000b63, 0x00000b70, 0x00000b83,
	0x00000ba6, 0x00000bbe, 0x00000be3, 0x00000bfb,
	0x00000c16, 0x00000c16, 0x00000c32, 0x00000c4e,
	0x00000c78, 0x00000c94, 0x00000ca4, 0x00000cc5,
	0x00000cf8, 0x00000d0b, 0x00000d29, 0x00000d59,
	0x00000d6e, 0x00000d98, 0x00000dbe, 0x00000dd1,
	// Entry A0 - BF
	0x00000ded, 0x00000e00, 0x00000e24, 0x00000e68,
	0x00000e84, 0x00000ea2, 0x00000ebb, 0x00000ef1,
	0x00000f09, 0x00000f6a, 0x00000fbf, 0x00000fd8,
	0x00000fe5, 0x00001001, 0x00001026, 0x0000103c,
	0x0000103c, 0x0000103c, 0x0000103c, 0x0000103c,
	0x0000103c,
} // Size: 748 bytes

const zh_TWData string = "" + // Size: 4156 bytes
	"\x02錯誤\x02(無參數)：提升權限並安裝管理服務\x02使用方法： %[1]s [\x0a%[2]s]\x02命令列選項\x02無法確定該" +
	"處理程序是否在 WOW64 下執行： %[1]v\x02無法開啓目前處理程序的權杖： %[1]v\x02WireGuard 可能只能被內建的" +
	"「%[1]s」群組成員使用。\x02WireGuard 正在執行，但 UI 只能從內建的內建的「%[1]s」群組成員的桌面存取。\x02Wi" +
	"reGuard 的工作列圖示在 30 秒後並沒有顯示。\x02就是現在\x02系統時鐘倒退了！\x14\x01\x81\x01\x00\x00" +
	"\x0a\x02%[1]d 年\x14\x01\x81\x01\x00\x00\x0a\x02%[1]d 天\x14\x01\x81\x01" +
	"\x00\x00\x0d\x02%[1]d 小時\x14\x01\x81\x01\x00\x00\x0d\x02%[1]d 分鐘\x14\x01" +
	"\x81\x01\x00\x00\x0a\x02%[1]d 秒\x02%[1]s 前\x02%[1]d\u00a0B\x02%.2[1]f" +
	"\u00a0KiB\x02%.2[1]f\u00a0MiB\x02%.2[1]f\u00a0GiB\x02%.2[1]f\u00a0TiB" +
	"\x02%[1]s： %[2]q\x02無效的 IP 位址\x02無效的網路位址首碼長度\x02Endpoint 中沒有指定埠號\x02無效的 " +
	"Endpoint 位址\x02括號中必須包含一個 IPv6 位址\x02無效的 MTU\x02無效的埠號\x02無效的 Persistent K" +
	"eepalive 設定\x02無效的金鑰： %[1]v\x02金鑰必須剛好長 32 bytes\x02數值必須介於 0 到 2^64-1： %[" +
	"1]v\x02一行中有兩個逗號\x02隧道名稱無效\x02行必須出現在段落中\x02設定的項目必須要有一個等號\x02必須要有一個值\x02[I" +
	"nterface] 中有無效選項\x02[Peer] 中有無效選項\x02Interface 中必須要有一把私鑰\x02[未指定]\x02每個 " +
	"Peer 都必須要有公鑰\x02讀取設定時發生錯誤\x02Interface 中的金鑰無效\x02協定版本必須為 1\x02Peer 中的金鑰無" +
	"效\x02、\x02 \x02關於 WireGuard\x02WireGuard logo 圖片\x02關閉\x02♥ 捐贈！ (&D)" +
	"\x02狀態\x02中斷連線 (&D)\x02連線 (&A)\x02公鑰\x02監聽埠\x02MTU\x02位址\x02DNS 伺服器\x02預" +
	"交換金鑰\x02允許的位址\x02連接點\x02Keepalive 間隔\x02最後交握時間\x02流量\x02已啓用\x02已收到 %[1" +
	"]s；已傳送 %[2]s\x02無法確認隧道狀態\x02無法連接隧道\x02無法斷開隧道連線\x02[隧道] %[1]s\x02節點\x02建立" +
	"新隧道\x02編輯隧道設定\x02名稱 (&N)\x02公鑰 (&P)\x02(未知)\x02阻斷未經過隧道的流量（kill-switch）" +
	" (&B)\x02儲存 (&S)\x02取消\x02設定 (&C)\x02無效的名稱\x02必須填寫名稱。\x02無效的隧道名稱「%[1]s」。" +
	"\x02無法列出現有隧道\x02隧道已存在\x02已有同名隧道「%[1]s」。\x02無法建立新的隧道設定\x02檔案寫入失敗\x02檔案已存在" +
	"： %[1]s\x0a\x0a您確定要覆蓋嗎？\x02已連線\x02正在連線…\x02已中斷連線\x02正在中斷…\x02未知\x02日誌" +
	"\x02複製 (&C)\x02全選 (&A)\x02匯出… (&S)\x02時間\x02日誌訊息\x02純文字 (*.txt)|*.txt|所有" +
	"檔案 (*.*)|*.*\x02匯出日誌…\x02關於 WireGuard (&A)\x02隧道錯誤\x02%[1]s\x0a\x0a如需更" +
	"多資訊，請查看日誌。\x02%[1]s（已過時）\x02偵測 WireGuard 錯誤\x02無法等待 WireGuard 視窗開啓： %[" +
	"1]v\x02WireGuard - 未連線\x02[狀態] 未知\x02[位址] 無\x02管理隧道 (&M)\x02從檔案匯入… (&I)" +
	"\x02離開 (&X)\x02WireGuard 已連線\x02已連線至隧道 - %[1]s\x02WireGuard 已中斷連線\x02已中斷" +
	"與隧道的連線 - %[1]s\x02WireGuard 隧道錯誤\x02WireGuard - %[1]s\x02[狀態] %[1]s" +
	"\x02更新\x02WireGuard 更新\x02更新的 WireGuard 已經為您準備好了。\x0a強烈建議您立即更新 WireGuard" +
	"。\x02隧道\x02編輯 (&E)\x02新增隧道精靈 (&E)\x02新增隧道\x02刪除選取隧道\x02匯出所有隧道（ZIP 格式）" +
	"\x02切換連線狀態 (&T)\x02匯出所有隧道至 &ZIP 壓縮檔\x02編輯選取隧道 (&S)\x02刪除已選取隧道 (&R)\x02無法" +
	"匯入設定： %[1]v\x02無法列出隧道： %[1]v\x02已有另一個同名的隧道「%[1]s」\x02無法匯入設定： %[1]v\x02" +
	"已匯入隧道\x14\x01\x81\x01\x00\x00\x1a\x02已匯入 %[1]d 個隧道\x14\x02\x80\x01\x00" +
	"-\x02已匯入 %[1]d 個隧道（共 %[2]d 個）\x02無法建立隧道\x14\x01\x81\x01\x00\x00\x17\x02刪" +
	"除 %[1]d 個隧道\x14\x01\x81\x01\x00\x00)\x02您確定要刪除 %[1]d 個隧道嗎？\x02刪除隧道 - %" +
	"[1]s\x02您確定要刪除隧道「%[1]s」嗎？\x02%[1]s\x0a\x0a您將無法復原此操作。\x02無法刪除隧道\x02無法刪除隧道" +
	"： %[1]s\x02無法刪除隧道\x14\x01\x81\x01\x00\x00\x1d\x02無法刪除 %[1]d 個隧道\x02隧道設" +
	"定檔 (*.zip, *.conf)|*.zip;*.conf|所有檔案 (*.*)|*.*\x02從檔案中匯入隧道…\x02隧道設定檔 (" +
	"*.zip)|*.zip\x02匯出隧道設定至…\x02%[1]s（未簽署發行版本，無法自動更新）\x02離開 WireGuard 失敗\x02" +
	"無法結束服務： %[1]v。\x0a您可能需要手動從服務管理中結束 WireGuard 服務。\x02更新的 WireGuard 已經為您準" +
	"備好了。\x0a強烈建議您立即進行更新。\x02狀態：等待使用者\x02立即更新\x02狀態：等待更新服務\x02錯誤： %[1]v。請稍後" +
	"再試。\x02狀態：已完成！"

	// Total table size 99186 bytes (96KiB); checksum: FBC08C97
